package provide FIQAPP 1.0
#FIQAPP.tcl
#ApplicationFunctions

# Linke-Maus auf Link
proc cLink {x y parent} {
# Wenn auf Link geklickt
	global FTPrender debug activeHTM mainHTML active grabMode LastFile currentFile winSYS \
	urltext zlrGFX anzGFX baseurl base mouseOver underlineHyper keepColor visitedGFX filter \
	msgText autoscroll shiftPress rubber thumbsOnly cancel fTypes HTMLwin movement moved
#puts "cLINK"
	if {$active} return
	set mouseOver [lindex [split $parent .] end]
	set link [$parent href $x $y]
	if {$debug>5} {puts "Link: $link"}
	#NEW250904: Workaround to ResolveRedirected Links correctly for Marking
	set merkHTM $activeHTM
	set activeHTM $mouseOver
	set dummy [string trim [reslvURL [lindex $link 0]]]
	regsub -nocase -all {:/+} $dummy {://} dummy
	set activeHTM $merkHTM
	set mark ""
	set new [acode decode $dummy]
	if {$debug>5} {puts "cLink: $new"}
	if {$new!=""} {
		set cancel 0
	#$LastFile MUSS ein Array: $LastFile($parent) werden, damit das last File des
	#jeweiligen (aktuellen) Frames (!) aufgerufen werden kann !!!!!!!!
	#MUSS dann berall das akt. Frame ($parent) bercksichtigt werden !
		set pattern $LastFile($activeHTM)#
		set len [string length $pattern]
		incr len -1
		if {[string range $new 0 $len]==$pattern} {
			#wenn Link auf gleicher Seite, weiter unten (geht nur, wenn BaseURL in HTML-Widget gesetzt !)
			incr len
			$parent yview [string range $new $len end]
		} else {
			set such [lindex [split $new #] 0]
			if {[regexp -nocase {#} $new] && [regexp -nocase $such $baseurl($activeHTM)]} {
				#Link aus gleicher Seite, weiter unten (ScrollBar moven !)
				set such [lindex [split $new #] end]
				$mainHTML yview $such
			} else {
			  	MouseCurs 1
				clearPage
				update
				set anzGFX 1
				set zlrGFX 0
				set grabMode 1
				if {$keepColor==1} {
					regsub -nocase {\.x$} $parent {} parent
					set link [lindex [split $parent .] end]
#CHNG211206: search only cutted URL
				set help [cutLink $new]
				if {[regexp -nocase $help $new]} {
  				   		set such $help
				} else {
				  	    set such $new
				}
					#regsub -nocase -all {\?} $new {\&} such
					set memgfx [getLink $such $mouseOver]
					if {$activeHTM != $link} {
						if {[string length $memgfx]>0} {
							#ImageLink farbig markieren
							set mark blue
							#NEW240905: Autoscroll
							if {$autoscroll == 2} {update; $parent yview scroll 1 units}
						} elseif {[regexp -nocase {\.local$|\.remote$|\.internal$} $parent]} {
							#TextLink farbig markieren
							set tid [getToken $new]
                                                        if {$winSYS == 0} {
                                                             set chk [$parent text ascii $tid.0]
                                                        } else {
                                                             set chk [$parent text ascii $tid.0 $tid.2]
                                                        }
							if {$tid > 0 && ![regexp -nocase {^\+|^\-} $chk]} {
								#TID + 1 cause Link is one TID before "Text" in HTML
								#set tid [expr $tid + 1]
								#$parent selection set $tid.0 $tid.end
                                                                if {$winSYS == 0} {
                                                                   $parent text insert $tid.0 "+"
#								   $parent refresh text
                                                                } else {
                                                                   $parent token insert $tid Text "+"
                                                                }
								$parent refresh text
							}
						}
					}
				}
				#NEW150804: cut redirected Links
				set chk [lindex [split $baseurl($mouseOver) /] 0]
				if {[regexp -nocase "^$chk" $new] && [string length $chk]!=[string length $new]} {
					set dummy [cutLink2 $new]
				} else {
					set dummy $help
				}
				if {[string length $dummy]>0} {
	       				#NEU180404: Wenn Link aus NeuerSeite und dort weiter unten
        				if {[regexp -nocase {#} $new] && [regexp -nocase $such $baseurl($activeHTM)]} {
        				#Link aus gleicher Seite, weiter unten (ScrollBar moven !)
        					set such [lindex [split $new #] end]
        					$mainHTML yview $such
        				} else {
        				set chkFlt [grep $filter $dummy]
        				if {$rubber>0} {set chkFlt 0}
						if {$chkFlt>0 || [regexp -nocase $fTypes(Danger) $dummy]} {
							#NEW111106: Disallow dangerous FileTypes or Filter
							.mbar.lbAnim configure -image imTuxForbidden
							set mark red
							markImage $memgfx yellow
							setLED red
							MouseCurs 0
							if {$chkFlt>0} {
								   dispMSG $msgText(filter.3)
							} else {
							  	   dispMSG $msgText(fiq.blocked.1)
	  	   					}
							return
						} else {
							ChangeMode 3
							if {$shiftPress==1} {
								set thumbsOnly 1
								.tile.bottom.pane.f3.box.lbType configure -background red -image imOPTthumbnail
							}
							if {$mark != ""} {markImage $memgfx $mark}
							addHistry $dummy
							setLED cyan
							dispMSG $msgText(resolving.url)
							set urltext [upperHTTP $dummy]
       						goEnter
						}
						set currentFile $dummy
						set grabMode 0
					}
        			}
			}
		}
	} else {
#OUT060610
#		if {$urltext!=""} {ZoomIn}
	}
}

#RECHTS-Klick auf HTMLSeite/Link
proc onClick {x y parent} {
	#QuickSaveMode (User hat irgendwo auf Seite rechtsKlick gemacht
	global liste activeHTM cutGfx MapMode debug active grabMode onLink urltext destDir quickSave \
	fileTypes cutType fTypes msgText remSTR thumbsOnly HTMLurl mouseOver chkCHR shiftPress cancel
	if {$MapMode!=4} {
		if {[string length $urltext]==0} return
	}
	if {$active} return
	if {$onLink} {
		set cancel 0
		#rechte Maus auf Link
		set fn [$parent href $x $y]
		set fn [string trim [reslvURL [lindex $fn 0] 0] {\"}]
		set fn [cutLink $fn]
		#NEW210106: shiftPress+rightMouse on Link = Thumbnail
#CHNG020411:
#Link: http://www.imagefap.com/image.php?id=1124947376&pgid=&gid=2491233&page=0
#=Thumb: http://x.fap.to/images/thumb/44/112/1124947376.jpg
#		if {$shiftPress==1 || $thumbsOnly==1} {set fn [link2thumb $fn]}
		if {$shiftPress==1 || $thumbsOnly==1 || [regexp -nocase "imagefap" $fn]} {set fn [link2thumb $fn]}
#		set fn [acode encode $fn]
		if {$debug>3} {puts "onClick: $fn"}
		if {[lindex $fileTypes 0]=="*" || $thumbsOnly==1} {
			AddSelected $fn 0
		} else {
			set dummyfn [transType $fn]
			regsub -nocase -all { } [join $fileTypes] {|} dummyTypes
			if {[regexp -nocase $dummyTypes$ $dummyfn] || [chkEXT [getEXT $dummyfn]] || [regexp -nocase {%47$|/$} $dummyfn]} {
			#Nur ausgewhlte FileTypes zulassen
				AddSelected $fn 0
			} else {
				AddSelected $fn 0
				dispMSG $msgText(file.match)
				setLED red
			}
		}
	} else {
		#rechte Maus ins "leere"
		if {$quickSave} {
			SavePage
		} else {
		# Seite automatisch speichern bei rechterMaus
			set grabMode 1
			set srcurl [getFileURL [reslvURL $urltext 1] 0]
			set srcFile [lindex [split $srcurl #] end]
			set destFile [string trimright $destDir /]/$srcFile
			if {[string length $srcFile]<=5} {
			#NEU260204: WENN FileName sehr kurz, hnge vorherigen DirName vorweg
				set dir [split $srcurl #]
				set len [expr [llength $dir] - 2]
				set dir [join [lindex $dir $len]]
				set destFile [string trimright $destDir /]/[string trim $dir]_$srcFile
			}
			if {[file exists $destFile]} {
				#File existiert im Zielordner bereits, also umbenennen
				set extension [lindex [split $destFile .] end ]
				if {$cutGfx==0} {
					set zielname [lindex [split $destFile .] 0 ]
					set destFile $zielname\_[clock seconds].$extension
				} else {
					if {$cutType=="All Selected" || $cutType=="All_Files"} {
						regsub -nocase -all {\-} [clock clicks] {} code
						set destFile $code.$extension
					} else {
						if {[regexp -nocase $cutType $extension]} {
							regsub -nocase -all {\-} [clock clicks] {} code
							set destFile $code.$extension
						} else {
							if {[reGrep $cutType [array names fTypes]]} {
								if {[reGrep $extension $fTypes($cutType)]>0} {
									regsub -nocase -all {\-} [clock clicks] {} code
									set destFile $code.$extension
								}
							}
						}
					}
				}
			}
			catch {file copy $srcurl $destFile}
			set grabMode 0
			dispMSG "$msgText(file.save.7) $srcFile"
			setLED blue
		}
	}
}

#NEU Menu: Forw/Back
proc BackPage {} {
	global scanFile FTPrender FTPidx FTPhistry FTPdest MapMode histry idxHistry active urltext msgText
	if {$active} return
	if {$MapMode==4 && $FTPrender==0} {
		set win [chkFTPactive]
		if {$FTPidx($win)>0} {
			set FTPidx($win) [expr $FTPidx($win) - 1]
			set FTPdest($win) [lindex $FTPhistry($win) $FTPidx($win)]
			refreshFTP $win
			#Modus (local/FTP) des aktiven Windows auslesen
			if {[chkMode $win]=="local"} {
				readLocalDir $win $FTPdest($win)
			} else {
				readRemoteDir $win $FTPdest($win)
			}
			displayTag $win
		}
		unset win
	} else {
		if {$MapMode==2} {
		#Im ScannerMode Variable 1 back
			if {![winfo exists .head.scanUrl.lbStart]} return
			set startURL [string trim [.head.scanUrl.lbStart cget -text]]
			set valueURL [string trim [.head.scanUrl.lbValue cget -text]]
			if {[string length $valueURL]<=0} return
			regsub -nocase -all {^0*} $valueURL {} dummy
			catch {set dummy [expr $dummy - 1]}
			if {$dummy<0} {set dummy 0}
			catch {expr int($dummy)} dummy
			set counter "%0[string length $valueURL]u"
			set valueURL [format $counter $dummy]
			set stopURL [string trim [.head.scanUrl.lbEnd cget -text]]
			set urltext [upperHTTP $startURL[string trim $valueURL]$stopURL]
			set merk $urltext
			if {$scanFile==2 || $scanFile==3} {
				set kill [lindex [split $urltext /] end]
				if {[regexp -nocase -all {\.} $kill]} {
					regsub -nocase $kill $urltext {} urltext
					if {![regexp -nocase {\?} $urltext]} {
						set urltext [upperHTTP [string trimright $urltext /]/]
					}
				}
			}
			.head.scanUrl.lbValue configure -text $valueURL -width [string length $valueURL]
			goEnter
			if {$scanFile==3} {
				set urltext $merk
				goEnter
			}
		} else {
			if {$idxHistry > 0} {
				set idxHistry [expr $idxHistry - 1]
				set datei [lindex $histry $idxHistry]
				set urltext [upperHTTP [acode decode $datei]]
				goEnter
				dispMSG $msgText(fiq.ready)
			} else {
				set idxHistry [llength $histry]
			}
		}
	}
}

# ForwardSite
proc ForwPage {} {
	global scanFile FTPrender FTPidx FTPhistry MapMode histry idxHistry active urltext msgText
	if {$active} return
	if {$MapMode==4 && $FTPrender==0} {
		set win [chkFTPactive]
		if {$FTPidx($win)<[llength $FTPhistry($win)]} {
			incr FTPidx($win)
			set FTPdest($win) [lindex $FTPhistry($win) $FTPidx($win)]
			refreshFTP $win
			#Modus (local/FTP) des aktiven Windows auslesen
			if {[chkMode $win]=="local"} {
				readLocalDir $win $FTPdest($win)
			} else {
				readRemoteDir $win $FTPdest($win)
			}
			displayTag $win
		}
		unset win
	} else {
		if {$MapMode==2} {
		#Im ScannerMode Variable 1 weiter
			if {![winfo exists .head.scanUrl.lbStart]} return
			set startURL [string trim [.head.scanUrl.lbStart cget -text]]
			set valueURL [string trim [.head.scanUrl.lbValue cget -text]]
			if {[string length $valueURL]<=0} return
			regsub -nocase -all {^0*} $valueURL {} dummy
			catch {incr dummy}
			catch {expr int($dummy)} dummy
			set counter "%0[string length $valueURL]u"
			set valueURL [format $counter $dummy]
			set stopURL [string trim [.head.scanUrl.lbEnd cget -text]]
			set urltext [upperHTTP $startURL[string trim $valueURL]$stopURL]
			set merk $urltext
			if {$scanFile==2 || $scanFile==3} {
				set kill [lindex [split $urltext /] end]
				if {[regexp -nocase -all {\.} $kill]} {
					regsub -nocase $kill $urltext {} urltext
					if {![regexp -nocase {\?} $urltext]} {
						set urltext [upperHTTP [string trimright $urltext /]/]
					}
				}
			}
			.head.scanUrl.lbValue configure -text $valueURL -width [string length $valueURL]
			goEnter
			if {$scanFile==3} {
				set urltext $merk
				goEnter
			}
		} else {
			if { $idxHistry < [expr [llength $histry]-1] } {
				set idxHistry [expr $idxHistry + 1]
				set datei [lindex $histry $idxHistry]
				set urltext [upperHTTP [acode decode $datei]]
				goEnter
				dispMSG $msgText(fiq.ready)
			} else {
				set idxHistry 0
			}
		}
	}
}

#jumps to a specific Site from History
proc jumPage {element} {
	global histry idxHistry urltext msgText
	if {$element=="first"} {
		set idxHistry 1
		set datei [lindex $histry $idxHistry]
	} else {
		set idxHistry [llength $histry]
		set datei [lindex $histry end]
	}
	if {[string length $datei]>0} {
		set urltext [upperHTTP [acode decode $datei]]
		preSolve
		dispMSG $msgText(fiq.ready)
		unset datei
	}
}

# BreakDownload and ALL actions
proc Stop {intoken} {
	global active cancel snd msgText styleParsed toknHandles downMode synCount getCSS metaREDIR
	set cancel 1
	set active 0
	ShowTableStruct 0
	set downMode 0
	set synCount 0
	set getCSS 0
	set styleParsed 0
	setLED orange
	clearSelected
	catch {snd stop; s stop}
	if {[llength $toknHandles]>0} {
		foreach inhalt $toknHandles {
			catch {http::reset $inhalt}
			catch {http::cleanup $inhalt}
		}
	}
	catch {http::reset $intoken}
	catch {http::cleanup $intoken}
	catch {stop_anigif .mbar.lbAnim}
	set metaREDIR ""
	MouseCurs 0
	set toknHandles ""
	wm title . "Inquisitor"
	wm iconname . "FIQ"
	dispMSG $msgText(stop)
}

# Refresh Page.
proc Refresh {args} {
	global mainHTML baseurl LastFile activeHTM
	if {![info exists LastFile]} return
#CHANGE050605: ZoomIN/OUT geht NUR mit LoadFile !!!
	LoadFile $LastFile($activeHTM)
}

#Set Application Colors (called from FIQsetup)
proc setAppColor {} {
    global fgColor backColor normLight etryBack listColor htmlBG htmlFG barColor appText msgText language sysFont red grn blu \
	color actColor merkColor ScrewRelief
	set merkColor(backColor) $backColor
	set merkColor(fgColor) $fgColor
	set merkColor(barColor) $barColor
	set merkColor(normLight) $normLight
	set merkColor(etryBack) $etryBack
	set merkColor(listColor) $listColor
	set merkColor(htmlBG) $htmlBG
	set merkColor(htmlFG) $htmlFG
        regsub -nocase -all {#} $backColor {} dummy
        set red [string range $dummy 0 1]
        set grn [string range $dummy 2 3]
        set blu [string range $dummy 4 5]
	set red [format "%03u" 0x$red]
	set grn [format "%03u" 0x$grn]
	set blu [format "%03u" 0x$blu]
	set color 1

	toplevel .colorbox
	wm title .colorbox $appText(.colorbox.1)
	wm iconname .colorbox $appText(.colorbox.2)
	wm protocol .colorbox WM_DELETE_WINDOW {destroy .colorbox}
	wm geometry .colorbox +300+300

	frame .colorbox.frCSel

	frame .colorbox.frCSel.frCtext
	label .colorbox.frCSel.frCtext.imScrew1 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
	button .colorbox.frCSel.frCtext.lbText -text $appText(.colorbox.frCSel.0) -relief raised -font $sysFont(0) -background $listColor -foreground $fgColor -borderwidth 1 -command {calcColor $actColor}
	label .colorbox.frCSel.frCtext.imScrew2 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
	pack .colorbox.frCSel.frCtext.imScrew1 .colorbox.frCSel.frCtext.lbText .colorbox.frCSel.frCtext.imScrew2 -in .colorbox.frCSel.frCtext -side left
	pack .colorbox.frCSel.frCtext -in .colorbox.frCSel -side top -padx 2 -pady 2

	radiobutton .colorbox.frCSel.1 -text $appText(.colorbox.frCSel.1) -underline 0 -variable color -value 1 -font $sysFont(0) -selectcolor $backColor -background $backColor -command {setColorMix $backColor} -anchor w
	radiobutton .colorbox.frCSel.2 -text $appText(.colorbox.frCSel.2) -underline 0 -variable color -value 2 -font $sysFont(0) -selectcolor $backColor -background $fgColor -command {setColorMix $fgColor} -anchor w
	radiobutton .colorbox.frCSel.3 -text $appText(.colorbox.frCSel.3) -underline 0 -variable color -value 3 -font $sysFont(0) -selectcolor $backColor -background $barColor -command {setColorMix $barColor} -anchor w
	radiobutton .colorbox.frCSel.4 -text $appText(.colorbox.frCSel.4) -underline 0 -variable color -value 4 -font $sysFont(0) -selectcolor $backColor -background $normLight -command {setColorMix $normLight} -anchor w
	radiobutton .colorbox.frCSel.5 -text $appText(.colorbox.frCSel.5) -underline 0 -variable color -value 5 -font $sysFont(0) -selectcolor $backColor -background $etryBack -command {setColorMix $etryBack} -anchor w
	radiobutton .colorbox.frCSel.6 -text $appText(.colorbox.frCSel.6) -underline 0 -variable color -value 6 -font $sysFont(0) -selectcolor $backColor -background $listColor -command {setColorMix $listColor} -anchor w
	radiobutton .colorbox.frCSel.7 -text $appText(.colorbox.frCSel.7) -underline 0 -variable color -value 7 -font $sysFont(0) -selectcolor $backColor -background $htmlBG -command {setColorMix $htmlBG} -anchor w
	radiobutton .colorbox.frCSel.8 -text $appText(.colorbox.frCSel.8) -underline 0 -variable color -value 8 -font $sysFont(0) -selectcolor $backColor -background $htmlFG -command {setColorMix $htmlFG} -anchor w
	.colorbox.frCSel.$color select

	pack .colorbox.frCSel.1 .colorbox.frCSel.2 .colorbox.frCSel.3 .colorbox.frCSel.4 .colorbox.frCSel.5 .colorbox.frCSel.6 \
	.colorbox.frCSel.7 .colorbox.frCSel.8 -in .colorbox.frCSel -padx 1 -pady 1 -side top -anchor w -fill x

	#ColorScales
	frame .colorbox.frScales
	#MixerLabel
	label .colorbox.frScales.lbMix -background $backColor -width 10 -height 5 -relief sunken -text "\n\n\n\n"
	#red
	scale .colorbox.frScales.scRed -variable red -from 0 -to 255 -orient horizontal -background "#FF0000" -command "changeColor red"
	.colorbox.frScales.scRed set $red
	#green
	scale .colorbox.frScales.scGrn -variable grn -from 0 -to 255 -orient horizontal -background "#00FF00" -command "changeColor green"
	.colorbox.frScales.scGrn set $grn
	#blue
	scale .colorbox.frScales.scBlu -variable blu -from 0 -to 255 -orient horizontal -background "#0000FF" -command "changeColor blue"
	.colorbox.frScales.scBlu set $blu

	pack .colorbox.frScales.lbMix .colorbox.frScales.scRed .colorbox.frScales.scGrn .colorbox.frScales.scBlu -in .colorbox.frScales -side top -padx 2 -pady 1

	frame .colorbox.buttons
	button .colorbox.buttons.btok -text OK -image imOKbutton -compound left -font $sysFont(0) -command {
		set backColor [.colorbox.frCSel.1 cget -background]
		set fgColor   [.colorbox.frCSel.2 cget -background]
		set barColor  [.colorbox.frCSel.3 cget -background]
		set normLight [.colorbox.frCSel.4 cget -background]
		set etryBack  [.colorbox.frCSel.5 cget -background]
		set listColor [.colorbox.frCSel.6 cget -background]
		set htmlBG    [.colorbox.frCSel.7 cget -background]
		set htmlFG    [.colorbox.frCSel.8 cget -background]
		setPalette
		dispMSG $msgText(color.set.1)
		destroy .colorbox
	}
	button .colorbox.buttons.btreset -text $appText(.colorbox.buttons.btreset) -image imEscape -compound left -command {resetAppColor; destroy .colorbox} -font $sysFont(0)
	button .colorbox.buttons.btcancel -text Cancel -image imCancel -compound left -font $sysFont(0) -command {
		set backColor $merkColor(backColor)
		set fgColor $merkColor(fgColor)
		set barColor $merkColor(barColor)
		set normLight $merkColor(normLight)
		set etryBack $merkColor(etryBack)
		set listColor $merkColor(listColor)
		set htmlBG $merkColor(htmlBG)
		set htmlFG $merkColor(htmlFG)
		setPalette
		dispMSG $msgText(color.set.2)
		destroy .colorbox
	}
	pack .colorbox.buttons.btok .colorbox.buttons.btreset .colorbox.buttons.btcancel -side left -expand 1
	pack .colorbox.buttons -side bottom -fill x -pady 3
	pack .colorbox.frScales -side right -padx 2 -pady 2
	pack .colorbox.frCSel -side left -padx 2 -pady 2 -expand true -fill x
}

#sets RGB ColorValues
proc setColorMix {color} {
        regsub -nocase -all {#} $color {} color
        if {[string length $color]<=0} return
        set r [string range $color 0 1]
        set g [string range $color 2 3]
        set b [string range $color 4 5]
	set r [format "%03u" 0x$r]
	set g [format "%03u" 0x$g]
	set b [format "%03u" 0x$b]
	.colorbox.frScales.scRed set $r
	.colorbox.frScales.scGrn set $g
	.colorbox.frScales.scBlu set $b
}

#Change ColorBars
proc changeColor {sel wert} {
	global red grn blu color actColor
	switch $sel {
		red {
			.colorbox.frScales.scRed configure -background #[format "%02X" $red]0000
		}
		green {
			.colorbox.frScales.scGrn configure -background #00[format "%02X" $grn]00
		}
		blue {
			.colorbox.frScales.scBlu configure -background #0000[format "%02X" $blu]
		}
	}
	set actColor #[format "%02X" $red][format "%02X" $grn][format "%02X" $blu]
	.colorbox.frScales.lbMix configure -background $actColor
	.colorbox.frCSel.$color configure -background $actColor
}

#MUST CHANGE ALL COLORS (curently unused, but MAY used instead of tk_setPalette; see above)
proc setPalette {} {
	global fgColor backColor normLight etryBack listColor htmlBG htmlFG tagStyle
	tk_setPalette background $backColor foreground $fgColor activeBackground $normLight \
	selectColor $etryBack highlightColor $normLight highlightBackground $htmlBG selectBackground $normLight \
	selectForeground $htmlFG activeFforeground white
	set tagStyle(bold) "-background $normLight -relief raised -borderwidth 1"
	set tagStyle(mark) "-foreground $fgColor -background $normLight -relief raised -borderwidth 1"
}

#calculate Colors
proc calcColor {color} {
	global backColor fgColor barColor normLight etryBack listColor htmlBG htmlFG msgText language
	#set color [tk_chooseColor -title $msgText(color.change)]
        if {[string length $color]>0} {
		set backColor $color
                set normLight [colorIncr $color 32]
                set etryBack [colorIncr $color 48]
                set listColor [colorDecr $color 48]
                regsub -nocase -all {#} $color {} dummy
                if {[expr "0x$dummy" > "0x888888"]} {
                        set fgColor "#000000"
                } else {
                        set fgColor "#FFFFFF"
                }
                set htmlBG [colorIncr $color 128]
                set htmlFG [colorDecr $color 128]
                tk_setPalette $color
		.colorbox.frCSel.1 configure -background $backColor
		.colorbox.frCSel.2 configure -background $fgColor
		.colorbox.frCSel.3 configure -background $barColor
		.colorbox.frCSel.4 configure -background $normLight
		.colorbox.frCSel.5 configure -background $etryBack
		.colorbox.frCSel.6 configure -background $listColor
		.colorbox.frCSel.7 configure -background $htmlBG
		.colorbox.frCSel.8 configure -background $htmlFG
		setPalette
	}
}

#ReSet Application Colors to Default (called from FIQsetup)
proc resetAppColor {} {
       global FTPask backColor fgColor normLight etryBack listColor htmlBG htmlFG barColor msgText language barColor
       if {$FTPask==1} {
		set answer [optionBox -title $msgText(color.reset.1) -icon warning -type yesno -message $msgText(color.reset.2)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
                       set backColor "#0061A8"
                       set fgColor   "#FFFFFF"
		       		   set barColor  "#00008B"
                       set normLight "#3881C8"
                       set etryBack  "#4891D8"
                       set listColor "#003178"
                       set htmlBG    "#98E1FF"
                       set htmlFG    "#000028"
		       setPalette
                       dispMSG $msgText(color.reset.3)
		       imLED configure -foreground $backColor
                }
        }
}

#NEW171004: ColorCalculations (called from setAppColor)
proc colorIncr {color value} {
        regsub -nocase -all {#} $color {} color
        if {[string length $color]<=0} return
        set r [string range $color 0 1]
        set g [string range $color 2 3]
        set b [string range $color 4 5]
        set backR [expr "0x$r" + $value]
        set backG [expr "0x$g" + $value]
        set backB [expr "0x$b" + $value]
        if {$backR>255} {set backR 255}
        if {$backG>255} {set backG 255}
        if {$backB>255} {set backB 255}
        unset r g b
        append back [format "%02X" $backR] [format "%02X" $backG] [format "%02X" $backB]
        return #$back
}

#Decrease Color by amount of Value (return new ColorValue)
proc colorDecr {color value} {
        regsub -nocase -all {#} $color {} color
        if {[string length $color]<=0} return
        set r [string range $color 0 1]
        set g [string range $color 2 3]
        set b [string range $color 4 5]
        set backR [expr "0x$r" - $value]
        set backG [expr "0x$g" - $value]
        set backB [expr "0x$b" - $value]
        if {$backR<0} {set backR 00}
        if {$backG<0} {set backG 00}
        if {$backB<0} {set backB 00}
        unset r g b
        append back [format "%02X" $backR] [format "%02X" $backG] [format "%02X" $backB]
        return #$back
}

#Icon Handler for each FileType (returns specific Icon for given FileType; used by various functions)
proc fileType {datei} {
        global filtVars MapMode
	set datei [string trim $datei]
#puts "FileType: $datei"
	if {[regexp -nocase {^/|^FILE://|^~} $datei] && $MapMode==4} {
		if {[regexp -nocase {^/\.[a-z]} $datei]} {
			#set back imFTunknown
			set back imIdentity
		} else {
			#NEU250704
			switch -regexp $datei {
			{^/\.\.$} {
				set back imFTopen
				}
			{^/\.$} {
				set back imHomePNG
				}
			{^/[a-zA-Z]:$} {
				set back imFThdd
				}
			{^~} {
				set back imFTlink
				}
			default {
				set back imFTfolder
				}
			}
		}
		return $back
	} else {
	    if {[regexp -nocase $filtVars $datei]} return
		set dummy [string tolower $datei]
		if {[regexp -nocase {\.} $dummy]} {
#		  	set dummy [lindex [split $dummy "\."] end]
		  	set dummy [getEXT $dummy]
			regsub -nocase -all {[^a-zA-Z0-9]} $dummy {} dummy
			set dummy [string trim $dummy]
		}
		if {[regexp -nocase {com$|info$|hu$|ca$|/$} $dummy]} {set dummy htm}
		set back imFTunknown
		switch -regexp $dummy {
			"readme" {set back imFTnews}
			"info" {set back imFTinfo}
			"warn" {set back imWarning}
			"phtm" {set back imFThtml}
			"shtm" {set back imFThtml}
			"xhtm" {set back imFThtml}
			"plex" {set back imFTphp}
			"core" {set back imFTerror}
			"jpg" {set back imFTgfx}
			"gif" {set back imFTgfx}
			"tif" {set back imFTgfx}
			"bmp" {set back imFTbmp}
			"tga" {set back imFTgfx}
			"png" {set back imFTgfx}
			"pcx" {set back imFTgfx}
			"xpm" {set back imFTgfx}
			"sgi" {set back imFTgfx}
			"sun" {set back imFTgfx}
			"ppm" {set back imFTgfx}
			"xbm" {set back imFTico}
			"ico" {set back imFTico}
			"cdr" {set back imFTcdr}
			"exe" {set back imFTexe}
			"com" {set back imFTexe}
			"swf" {set back imFTswf}
			"spl" {set back imFTswf}
			"rmf" {set back imFTreal}
			"rmv" {set back imFTreal}
			"rmj" {set back imFTreal}
			"rms" {set back imFTreal}
			"ram" {set back imFTreal}
			"rax" {set back imFTreal}
			"rvx" {set back imFTreal}
			"rtx" {set back imFTreal}
			"rmm" {set back imFTreal}
			"rmx" {set back imFTreal}
			"flv" {set back imFTreal}
			"rmp" {set back imFTrmv}
			"xpl" {set back imFTrmv}
			"wax" {set back imFTrmv}
			"wvx" {set back imFTrmv}
			"wmx" {set back imFTrmv}
			"wpl" {set back imFTrmv}
			"pls" {set back imFTrmv}
			"m4p" {set back imFTrmv}
			"m3u" {set back imFTrmv}
			"rts" {set back imFTrmv}
			"sdp" {set back imFTrmv}
			"bak" {set back imFTbak}
			"bat" {set back imFTbat}
			"mid" {set back imFTmidi}
			"wav" {set back imFTwma}
			"smp" {set back imFTsound}
			"aif" {set back imFTsound}
			"snd" {set back imFTsound}
			"voc" {set back imFTsound}
			"sam" {set back imFTsound}
			"raw" {set back imFTsound}
			"wma" {set back imFTwma}
			"mp3" {set back imFTmp3}
			"avi" {set back imFTvideo}
			"m1v" {set back imFTvideo}
			"m4v" {set back imFTvideo}
			"mpv" {set back imFTvideo}
			"vfw" {set back imFTvideo}
			"mov" {set back imFTquick}
			"qt" {set back imFTquick}
			"mqv" {set back imFTquick}
			"dvx" {set back imFTwmv}
			"mpg" {set back imFTwmv}
			"mpa" {set back imFTwmv}
			"mpe" {set back imFTwmv}
			"wmv" {set back imFTwmp}
			"swa" {set back imFTwmp}
			"asf" {set back imFTwmp}
			"asx" {set back imFTwmp}
			"ani" {set back imFTani}
			"fli" {set back imFTani}
			"flc" {set back imFTani}
			"css" {set back imFTcss}
			"zip" {set back imFTzip}
			"tgz" {set back imFTzip}
			"bz2" {set back imFTzip}
			"tar" {set back imFTzip}
			"lha" {set back imFTzip}
			"rar" {set back imFTzip}
			"lza" {set back imFTzip}
			"rpm" {set back imFTrpm}
			"txt" {set back imFTtext}
			"bin" {set back imFTbinary}
			"scr" {set back imFTscript}
			"pdf" {set back imFTpdf}
			"eps" {set back imFTeps}
			"doc" {set back imFTdoc}
			"rtf" {set back imFTrtf}
			"xls" {set back imFTxls}
			"dbf" {set back imFTvfp}
			"cdx" {set back imFTvfp}
			"sql" {set back imFTvfp}
            "prg" {set back imFTprg}
            "sct" {set back imFTprg}
            "scx" {set back imFTprg}
            "fxp" {set back imFTprg}
            "pjt" {set back imFTprg}
            "pjx" {set back imFTprg}
			"log" {set back imFTlog}
			"ttf" {set back imFTttf}
			"fon" {set back imFTfont}
			"ifo" {set back imFTinfo}
			"ini" {set back imFTini}
			"cnf" {set back imFTini}
			"lnk" {set back imFTlink}
			"pif" {set back imFTlink}
			"dll" {set back imFTdll}
			"hlp" {set back imFThelp}
			"man" {set back imFThelp}
			"ema" {set back imFTemail}
			"obj" {set back imFTcsource}
			"php" {set back imFTphp}
			"cgi" {set back imFTxml}
			"xml" {set back imFTxml}
			"dtd" {set back imFTxml}
			"asp" {set back imFTxml}
			"msp" {set back imFTxml}
			"htm" {set back imFThtml}
			"cfm" {set back imFThtml}
			"vcx" {set back imFTvcx}
			"ocx" {set back imFTvcx}
			"err" {set back imFTerror}
			"src" {set back imFTsource}
			"vbs" {set back imFTvbs}
			"fqh" {set back imWorld2}
			"tcl" {set back imFThide}
			"mmc" {set back imFTmmc}
			"tex" {set back imFTtex}
			"js" {set back imFTjava}
			"py" {set back imFTpython}
			"rm" {set back imFTrmv}
			"ra" {set back imFTreal}
			"rv" {set back imFTrmv}
			"au" {set back imFTsound}
			"fq" {set back imWorld}
			"gz" {set back imFTzip}
			"bz" {set back imFTzip}
			"ps" {set back imFTeps}
			"gs" {set back imFTeps}
			"vc" {set back imFTvcs}
			"c" {set back imFTcsource}
			"h" {set back imFThsource}
			"~" {set back imFTtrash}
			"" {set back imExport}
			default {set back imFTunknown}
		}
	}
#puts "BackType: $back"
	return $back
}

#MapMode=3; NormalMode
proc MapNRM {} {
	global sMode mainHTML backColor
	set sMode 0
	searchMode
	pack forget .tile.top.ftp
	pack forget .head.scanUrl
	pack .tile.top.html -side left -fill both -expand true
	pack .head.dispUrl -in .head -expand true -fill x
	.imHTTPS configure -image imUnLock -background $backColor
	#ReadOnly ListBox
	.tile.bottom.foot.box.selected configure -state disabled
}

#lets search the page
proc searchDoc {args} {
	global debug mainHTML MapMode FTPdest FTPdir linktext cancel linkmark anzSEL selected active msgText normLight htmlFG
	regsub -nocase -all {\*} [lindex $args 0] {} such
	set start [lindex $args 1]
	if {$debug>2} {puts "searchDoc: $such"}
	if {[string length $such]<=0} return
	if {[string length $start]<=0} {
		set start 0
	}
	set such [string tolower $such]
	if {$MapMode!=4} {
	   if {[winfo exist $mainHTML.frame.text]} {
	   	  #Search in textEditor
	   	  set w $mainHTML.frame.text
          $w tag remove search 0.0 end
		  if {$such == ""} return
		  set help 0
		  set cur 1.0
		  while 1 {
			set cur [$w search -regexp -nocase -count length $such $cur end]
			if {$cur == ""} break
			$w tag add "search" $cur "$cur + $length char"
			set cur [$w index "$cur + $length char"]
			$w tag configure search -background $normLight -foreground $htmlFG
			if {$help==0} {$w see $cur; set help 1}
		  }
		  return
	   }
	   #Suche auf HTMLSeite
		if {![info exist html]} {
			set html ""
			foreach inhalt [$mainHTML token get 1 end] {
				lappend html [string tolower $inhalt]
			}
			if {[llength $html]<=0} return
		}
		#Suche Innerhalb des HTML-Textes:
		set zeile [expr [lsearch -regexp -start $start $html $such] - 1]
		set zeile [expr $zeile + 3]
		$mainHTML selection set $zeile [expr $zeile + 2]
		set max [llength $html]
		set pro [expr 100.0 / [expr $max.0 / $zeile.0]]
		set pro [expr round($pro)]
		$mainHTML yview moveto 0.$pro
		unset max pro html
		return $zeile
	} else {
	#Suche im FTP-Mode (Sniff)
		set active 1
		chkActive
		update
		set linkmark 1
		set z 0
		set selected ""
		set directory ""
		set win [chkFTPactive]
		set max [llength $FTPdir($win)]
		dispMSG $msgText(ftp.sniff.1)
		setLED cyan
		catch {stop_anigif .mbar.lbAnim}
		catch {show_anigif [list -data [getAnim zoom22]] .mbar.lbAnim}
		set linktext "$msgText(ftp.sniff.2) $FTPdest($win)"
		foreach inhalt $FTPdir($win) {
			ProgressFile $z $max
			set inhalt [lindex [split $inhalt { }] 0]
			regsub -nocase -all {\n} $inhalt {} inhalt
			set inhalt [string trimright $FTPdest($win) /]/[string trimleft $inhalt /]
			if {[regexp -nocase -all $such $inhalt] && ![regexp -nocase -all {^~} $inhalt]} {
				AddSelected [reslvDIR $inhalt] 0
			}
			#Liste mit zu durchsuchenden SubDirectorys (inkl. akt. Dir) erstellen
			if {[regexp -nocase -all {^/} $inhalt] && ![regexp -nocase -all {^/\.} $inhalt] && ![regexp -nocase -all {^~} $inhalt]} {
				lappend directory [reslvDIR $inhalt]
			}
			incr z
			if {$cancel==1} {break}
		}
		if {$cancel==1} {return}
		#alle SubDirectorys ebenfalls durchsuchen
		if {[llength $directory]>0} {
			set mode [chkMode $win]
			#akt. Dir merken
			set merkDir $FTPdir($win)
			set z 0
			set max [llength $directory]
			foreach dir $directory {
				ProgressBar $z $max
				if {$debug>3} {puts "Dir: $dir"}
				#jedes SubDirectory einlesen
				if {$mode=="local"} {
					readLocalDir $win $dir
				} else {
					readRemoteDir $win $dir
				}
				#IN SubDirectory ebenfalls suchen
				set zlr 0
				set mx  [llength $FTPdir($win)]
				foreach inhalt $FTPdir($win) {
					ProgressFile $zlr $mx
					if {$cancel==1} {break}
					set inhalt [lindex [split $inhalt { }] 0]
					regsub -nocase -all {\n} $inhalt {} inhalt
					set inhalt [string trimright $FTPdest($win) /]/[string trimleft $inhalt /]
					if {$debug>4} {puts "File: $inhalt"}
					if {[regexp -nocase -all $such $inhalt] && ![regexp -nocase -all {^~} $inhalt]} {
						AddSelected [reslvDIR $inhalt] 0
					}
					incr zlr
				}
				if {$cancel==1} {break}
				set linktext "$msgText(ftp.sniff.3) $dir ($z / $max)"
				incr z
			}
			#akt. Dir wieder als Standard setzen
			set FTPdir($win) $merkDir
			catch {stop_anigif .mbar.lbAnim}
			ProgressBar 0 0
			ProgressFile 0 0
			searchMode
			set linktext "$msgText(ftp.sniff.4) $anzSEL"
			dispMSG "$msgText(ftp.sniff.5) $z"
			setLED blue
			unset merkDir inhalt mode directory win max mx z zlr
		}
		set active 0
		chkActive
		if {$cancel==1} {set cancel 0}
	}
}

#lets select multiple files with invisible rubber-band
proc rubberSelect {x1 y1 x2 y2} {
	global mainHTML active
	if {$x1<=0 || $y1<=0 || $x2<=0 || $y2<=0 || $active} return
	set step 5
	set select ""
	for {set y $y1} {$y<$y2} {incr y $step} {
		for {set x $x1} {$x<$x2} {incr x $step} {
			#set value [string trim [join [$mainHTML href $x $y]]]
			set value [string trim [lindex [$mainHTML href $x $y] 0]]
			set value [cutLink $value]
			if {$value!=""} {
				if {[lsearch $select $value]<0} {
					lappend select $value
				}
			}
		}
	}
	if {[llength $select]>0} {
		foreach inhalt $select {
			AddSelected [cutLink [reslvURL $inhalt 0]] 0
		}
	}
}

#unzips a file
proc unzip {zipfile} {
        global debug winSYS msgText
        if {$debug>2} {puts "UnZip: $zipfile"}
	set ext .[string trim [lindex [split $zipfile .] end] .]
	regsub -nocase $ext $zipfile {} outfile
	if {[file exists $outfile]} {
		if {[file size $outfile]<=0} {
                   catch {file delete -force $outfile}
                }
	}
   if {$winSYS==1} {
                  set zipfile [string trimleft $zipfile /]
				  if {![catch {gz open $zipfile} id]} {
                  #Write unZipped File
                          catch {gz read $id} inhalt
                          catch {gz close $id}
                          writeFile $outfile $inhalt
                          catch {unset inhalt}
		          } else {
				      dispMSG $msgText(unzip.error)
				      setLED red
		          }

    } else {
		#Linux (unzip with HTMLwidget)
        if {![catch {html gunzip file $zipfile} inhalt]} {
              #Write unZipped File
		      if {![catch {open $outfile "w"} fileid]} {
           	       	  puts $fileid $inhalt
              		  close $fileid
              }
		      catch {unset inhalt}
		} else {
		      dispMSG $msgText(unzip.error)
		      setLED red
		}
    }
}

#NEU120604: FICS (TM) in Function
proc getFics {cachedir gfx lidx tabidx endidx} {
	global debug tableOnly htmlTD link fics ficsVars
	if {$debug>1} {puts "getFics gets: $cachedir/$gfx $lidx $tabidx $endidx"}
	#Use "FICS" (TM) wenn KEIN Link, ODER ausserhalb "Tabelle" (TR-Tag)
	# Ld eine Datei aus dem Cache (NICHT aus INet !), wenn diese
	# a) von der gleichen Domain, b) den gleichen Dateinamen, und
	# c) die gleiche Gre (Auflsung !; Dateigre) hat (geht noch nich, Header abfragen !)
	#NICHT bei "Links" innerhalb einer Tabelle, weil Anordnung auf Seite sonst falsch !
	mkCacheDir
        set merk $gfx
        set dummy [acode decode $gfx]
	#CHNG190206:
	if {$fics>4} {
		regsub -nocase -all {\?|&} $dummy {#} dummy
	} else {
		regsub -nocase -all {&} $dummy {#} dummy
	}
	set dummy [lindex [split $dummy #] 0]
        regsub -nocase -all {/} $dummy {#} dummy
	set dummy [split $dummy #]
	regsub -nocase -all {#} $dummy {} dummy
	set dom [lindex $dummy 0]
	set hold ""
	set dir ""
	switch $fics {
		0 {
			return $gfx
		}
		1 {
			if {$link==0} {
				if {[regexp -nocase $ficsVars $gfx] || ($lidx<=$tabidx || $lidx>=$endidx)} {
					set fn [lindex $dummy end]
					set dir [glob -nocomplain -directory $cachedir [string trim $dom]*[string trim $fn]]
					set hold [strSort $dir #]
				}
			}
		}
		2 {
			if {[regexp -nocase $ficsVars $gfx] || ($lidx<=$tabidx || $lidx>=$endidx)} {
				set fn [lindex $dummy end]
				set dir [glob -nocomplain -directory $cachedir [string trim $dom]*[string trim $fn]]
				set hold [strSort $dir #]
			}
		}
		3 {
			if {[regexp -nocase $ficsVars $gfx]} {
				set fn [lindex $dummy end]
				set dir [glob -nocomplain -directory $cachedir [string trim $dom]*[string trim $fn]]
				set hold [strSort $dir #]
			}
		}
		4 {
			if {![lsearch -regexp $htmlTD $gfx]} {
				#Wenn TableOnly UND Image NICHT in Table
				#NEU040504: FICS aggressive Mode
				set fn [lindex [split $gfx .] end]
				set dir [glob -nocomplain -directory $cachedir [string trim $dom]*.[string trim $fn]]
				set hold [lindex [lsort $dir] 0]
			}
		}
		5 {
			set fn [lindex $dummy end]
			set dir [glob -nocomplain -directory $cachedir [string trim $dom]*[string trim $fn]]
			set hold [lindex [lsort $dir] 0]
		}
		6 {
			set fn [lindex [split $gfx .] end]
			set dir [glob -nocomplain -directory $cachedir [string trim $dom]*.[string trim $fn]]
			set hold [lindex [lsort $dir] 0]
		}
	}
	if {[string length $hold]>0} {
		set gfx [lindex [split $hold /] end]
	} else {
		set hold [lindex [lsort -unique -decreasing $dir] 0]
		set gfx [lindex [split $hold /] end]
	}
	if {[string length $gfx]<=0} {set gfx $merk}
	if {$debug>1} {puts "getFics returns: $gfx"}
	catch {unset fn dir hold dom dummy merk}
	return $gfx
}

#chkType checks Filetype by open it and read the 1st 10 bytes (knows only important filetypes)
#If it contains "jfif" then file = JPG, if the 1st char is "<" then file = HTM, etc.
proc chkType {args} {
#puts "chkType gets: $args"
	set which [lindex $args 0]
	set datei [lindex $args 1]
	set bytes 16
	switch -regexp $which {
		file {
			if {[file exists $datei]} {
				set fsize [file size $datei]
				if {$fsize<=0} return
			}
			if {[catch {open $datei r} fp]} {
				catch {close $fp}
				return
			} else {
				fconfigure $fp -translation binary
				catch {read $fp $bytes} r
				close $fp
			}
		}
		data {
			catch {string range $datei 0 $bytes} r
		}
	}
	if {[string length $r]<=0} return
#puts "R before: $r"
	regsub -nocase -all {[^a-zA-Z0-9!&%\.\?<>\x00\x01]} $r {} r
	set r [string trim $r]
#puts "R after: $r"
#puts "HEX: [hexDump $r]"
	#check MIMEtype by reading 1st 10 bytes
	switch -regexp $which {
		file {
#			set back [transType .[string trim [getEXT $datei] .]]
			set back ""
			if {[regexp -nocase {^<[a-zA-Z]+>|^[^a-zA-Z0-9]*<[a-zA-Z]+>|^<!|^[^a-zA-Z0-9]*<!|^<[a-zA-Z]+|^[^a-zA-Z0-9]*<[a-zA-Z]+} $r] && ![regexp -nocase {.htm$} $datei]} {return ".htm"}
			if {[regexp -nocase {JFIF.*$|EXIF.*$|XIF.+$|.!Adobe.d.+$} $r] && ![regexp -nocase {.jpg$} $datei]} {return ".jpg"}
			if {[regexp -nocase {^\x89PNG|^\?PNG|^.*PNG} $r] && ![regexp -nocase {.png$} $datei]} {return ".png"}
			if {[regexp -nocase {^GIF8[0-9]+|^GIF} $r] && ![regexp -nocase {.gif$} $datei]} {return ".gif"}
			if {[regexp -nocase {^\x00\x00\x01\x00} $r] && ![regexp -nocase {.ico$} $datei]} {return ".ico"}
			if {[regexp -nocase {^RIFF....AVI} $r] && ![regexp -nocase {.avi$} $datei]} {return ".avi"}
			if {[regexp -nocase {^RIFF....WAV} $r] && ![regexp -nocase {.wav$} $datei]} {return ".wav"}
			if {[regexp -nocase {^...!....} $r] && ![regexp -nocase {.mpg$} $datei]} {return ".mpg"}
			if {[regexp -nocase {^FWS|^CWS} $r] && ![regexp -nocase {.swf$} $datei]} {return ".swf"}
			if {[regexp -nocase {^BM8|^BM} $r] && ![regexp -nocase {.bmp$} $datei]} {return ".bmp"}
			if {[regexp -nocase {^0&\*u} $r] && ![regexp -nocase {.wmv$} $datei]} {return ".wmv"}
			if {[regexp -nocase {^%PDF} $r] && ![regexp -nocase {.pdf$} $datei]} {return ".pdf"}
			if {[regexp -nocase {^PK} $r] && ![regexp -nocase {.zip$} $datei]} {return ".zip"}
			if {[regexp -nocase {^MZ} $r] && ![regexp -nocase {.exe$} $datei]} {return ".exe"}
		}
		data {
			set back ""
			if {[regexp -nocase {^<[a-zA-Z]+>|^[^a-zA-Z0-9]*<[a-zA-Z]+>|^<!|^[^a-zA-Z0-9]*<!|^<[a-zA-Z]+|^[^a-zA-Z0-9]*<[a-zA-Z]+} $r]} {return ".htm"}
			if {[regexp -nocase {JFIF.*$|EXIF.*$|XIF.+$|.!Adobe.d.+$} $r]} {return ".jpg"}
			if {[regexp -nocase {^\x89PNG|^\?PNG|^.*PNG} $r]} {return ".png"}
			if {[regexp -nocase {^GIF8[0-9]+|^GIF} $r]} {return ".gif"}
			if {[regexp -nocase {^\x00\x00\x01\x00} $r]} {return ".ico"}
			if {[regexp -nocase {^RIFF....AVI} $r]} {return ".avi"}
			if {[regexp -nocase {^RIFF....WAV} $r]} {return ".wav"}
			if {[regexp -nocase {^...!....} $r]} {return ".mpg"}
			if {[regexp -nocase {^FWS|^CWS} $r]} {return ".swf"}
			if {[regexp -nocase {^BM8|^BM} $r]} {return ".bmp"}
			if {[regexp -nocase {^0&\*u} $r]} {return ".wmv"}
			if {[regexp -nocase {^%PDF} $r]} {return ".pdf"}
			if {[regexp -nocase {^PK} $r]} {return ".zip"}
			if {[regexp -nocase {^MZ} $r]} {return ".exe"}
		}
	}
#puts "chkType returns: $back"
	return $back
}

#Download all selected Files/Inline Files
proc downLoad {} {
	global downMode DOWNsync urltext selected urltext baseurl activeHTM followLinks active msgText cancel homeDir
#	set merkBase $urltext
	set merkBase $baseurl($activeHTM)
		if {$DOWNsync<=0} {
			set downMode 0
			downASync
		} else {
			set downMode 1
#puts "call: downSync"
	  		if {$followLinks<=0} {
				downSync
				exitLoadFile $urltext
			} else {
			  	set buffer $selected
			  	set max [llength $buffer]
			  	set zlr 0
#set datei $homeDir/Success.log
#if {[file exists $datei]} {file delete -force $datei}
				foreach inhalt $buffer {
				    set selected ""
					set urltext $inhalt
					set ext [transType .[string trim [getEXT $inhalt] .]]
					if {[chkEXT $ext]} {
						set downMode 0
						goEnter
					}
#if {![catch {open $datei "a+"} write]} {
#		puts $write $inhalt
#		close $write
#}
					if {$cancel==1} {break}
					if {[chkEXT $ext]} {
						selectALL 0
						set downMode 1
					}
					downSync
					exitLoadFile $urltext
					incr zlr
#					ProgressBar $zlr $max
					set erg [expr $max - $zlr]
					wm title . "ALL: $zlr/$max ($erg)"
					wm iconname . "ALL: $zlr/$max ($erg)"

				}
#				dispMSG "$msgText(download.4) $zlr"
#				set linktext ""
				exitLoadFile $urltext
#if {[file exists $datei]} {file delete -force $datei}
				catch {unset buffer inhalt max zlr}
			}
		}
		#NEW260806: (re)setBase after Download completed
#		exitLoadFile $urltext
		setBase $merkBase
		setLED blue
		wm title . "Inquisitor"
		wm iconname . "FIQ"
}

proc downHTML {inhalt url} {
	global urltext cancel fileTypes fics ficsVars filtVars minFileSize remSTR cookie maxDepth msgText fileOK followLinks anzDest selected
	set merkUrl $url
	set url [regSTR $remSTR $url]
	if {![chkEXT .[string trim [getEXT $inhalt] .]]} return
	set dummy $inhalt
	set srcfiles ""
	set back ""
	set count 0
	set htmlpage [encode [ReadFile $dummy]]
	set htmlpage [splitHTM $htmlpage]
	set htmlpage [split $htmlpage \n]
	foreach zeile $htmlpage {
#puts "Zeile: $zeile"
		set chklen [string trim [string length $zeile]]
		if {$chklen<=0 || ($chklen<3 && [regexp -nocase {^.>|^>} [string trim $zeile]])} continue
		if {$cancel==1} {break}
		if {[regexp -nocase {img } $zeile] && [regexp -nocase {src} $zeile]} {
			#WENN FileType in SRC enthalten (meist bei HTML)
			set src [reslvURL [getValue src $zeile] 1]
#puts "IMGSRC: $src"
			if {[regexp -nocase $filtVars $src]} continue
			if {$fics>0} {
	   	     			if {[regexp -nocase $ficsVars $src]} continue
			}
			set ext [string trim [getEXT $src] "\."]
			if {[reGrep $ext $fileTypes]>0 && [string length $src]>0} {
				  set dummy [getFileURL $src 0]
			          if {$followLinks<=0} {
				          lappend srcfiles $dummy $src
				  } else {
    				          #set back [AddSelected $src 0]
					  set back [copyPic $dummy $src 100]
					  #incr anzDest
				  }
				  incr count
			} elseif {[chkEXT .$ext]} {
				set dummy [getFileURL $src 0]
				if {[reGrep [lindex [split $dummy .] end] $fileTypes]>0 && [string length $src]>0} {
    				          if {$followLinks<=0} {
					          lappend srcfiles $dummy $src
					  } else {
       					          #set back [AddSelected $src 0]
					      	  set back [copyPic $dummy $src 100]
					      	  #incr anzDest
      					  }
				}
				incr count
			}
		}
		set cookie ""
	}
	catch {unset htmlpage zeile dummy}
	if {$cancel==1} {return}
		set max [llength $srcfiles]
		if {$max==1} {
			set dummy [lindex $srcfiles 0]
			set srcfile [lindex $dummy 0]
			set src [lindex $dummy 1]
			if {[string length $srcfile]>0} {
				set back [copyPic $srcfile $src 1]
			}
		} elseif {$max>1} {
			set files ""
			set merksize 0
				foreach {datei furl} $srcfiles {
					if {$cancel==1} {break}
					if {[string length $datei]<=0 || [string length $furl]<=0} continue
					set ext [string trim [getEXT $datei] "\."]
					if {[reGrep $ext $fileTypes]<=0} continue
					if {[file exists $datei]} {
						catch {file size $datei} filesize
						if {$filesize >= $minFileSize} {
							lappend files [list $filesize $datei]
						}
					}
				}
				if {[llength $files]>0} {
					set srcfiles [lsort -integer -index 0 $files]
					ProgressFile 100 100
					set dummy [lindex $srcfiles end]
					set srcfile [lindex $dummy 1]
					#NEW120206: standardmig fileOK auf 100 setzen, weil es sein kann, da die zuletzt angefragte Datei NICHT ok sein knnte
					#aber die vorherige (mit dem JPG) in Ordnung ist, und an dieser Stelle auch existiert, und grer 0 ist
					set fileOK 100
					set back [copyPic $srcfile $url $fileOK]
				}
                }
	if {$followLinks>0} {
		set fileOK 100
		#set back [copyPic $inhalt $url $fileOK]
		set back [AddSelected $merkUrl $fileOK]
		incr anzDest -1
		clearSelected
        }
	catch {unset srcfiles files srcfile url max merkUrl}
	return $back
}

#NormalPanel Button: Download
proc downLoadOLD {} {
	global debug mainHTML fileTypes fTypes selected cancel destDir linkmark followLinks msgText remSTR bytesTotal \
	thumbsOnly ByteCount maxBytes urltext autoscroll
	if {$debug>2} {puts "downLoadOLD: $fileTypes"}
	set gesZLR 0
	set max [llength $selected]
	if {$max<=0} {
		dispMSG $msgText(download.1)
		setLED orange
		return
	}
#NEW240905: autoscroll
if {$autoscroll > 0} {$mainHTML yview moveto 0.0}
	if {([lindex $fileTypes 0]=="*" || [extGrep $fileTypes $selected]) && $followLinks==0} {
		grabPIC $destDir 0
#puts "GrabPic0"
	} else {
#puts "GrabPic1"
		if {$followLinks==1 || ([extGrep $fTypes(HTML) $selected] || [inGrep {/$} $selected]>0)} {
        		if {(![extGrep $fTypes(HTML) $selected] && ![regexp -nocase {/$|\?|&} $selected]) || ([extGrep $fTypes(HTML) $selected] && [regexp -nocase -all {} [join $selected]])} {
        		#Wenn Auswahl keine HTML-Seiten enthlt
        			grabPIC $destDir 0
#puts "GrabPic2"
        		} else {
#puts "GrabPic3"
				#Ausgewhlte HTML-Seiten zwischenspeichern
                                set linkmark 1
        			set buffer ""
        			set z 0
        			if {$followLinks==1} {
        			#nur Links von aktueller Seite verfolgen
#CHANGED090705:
#        				set dummy [$mainHTML token find a]
					set dummy [$mainHTML token find img]
        				foreach inhalt $dummy {
						if {$cancel==1} {return}
        					set datei [reslvURL [getValue {href} $inhalt] 0]
        					set datei [lindex [split $datei #] 0]
        					AddSelected $datei 0
        				}
        			}
				foreach inhalt $selected {
        				if {$cancel==1} {break}
        				ProgressFile $z $max
					if {[grep $fTypes(HTML) $inhalt] || [regexp -nocase {%47$|/$} $inhalt]} {
        					lappend buffer $inhalt
        				} else {
        					#Nicht HTML-Dokumente aus AuswahlListe rausnehmen
						AddSelected $inhalt 0
        				}
        				incr z
        			}
				if {$cancel==1} {return}
        			set max [llength $buffer]
        			if {$max<=0} {
        				dispMSG $msgText(download.2)
        				setLED orange
        				ProgressFile 0 0
        				return
        			}
        			set z 0
        			while {$z < $max} {
        				set inhalt [lindex $buffer $z]
					ProgressBar $z $max
					if {$cancel==1} {break}
        				#selected HTML-Seiten lschen und aktuelle HTML-Seite laden
        				clearSelected
					set urltext [upperHTTP $inhalt]
					preSolve
					#NEW160505: bei HTMLseiten, die JPG beinhalten, wird Zhler nicht korrekt gesetzt
					incr gesZLR
# warum hier nicht: selectALL 0 ????
#CHANGED130905:
					if {[regexp -nocase {\.htm$|\.html|$047|/$} $inhalt]} {
						set dummy [$mainHTML token find a]
					} else {
#CHANGED090705:
						set dummy [$mainHTML token find img]
					}
        				set mx [llength $dummy]
        				set zlr 0

					if {$mx == 1} {
					#Nur 1 Image in HTMLpage gefunden
#puts "1 Image in HTML"
						set datei [regSTR {< > \"} [join $dummy]]
						set datei [reslvURL [getValue {src} $datei] 0]
						AddSelected $datei 0
					} elseif {$mx == 2} {
					#2 Images in HTMLpage gefunden
#puts "2 Images in HTML"
						set merksize 0
						set merkdatei ""
						foreach inhtml $dummy {
							if {$cancel==1} {break}
							set datei [regSTR {< > \"} $inhtml]
							set datei [reslvURL [getValue {src} $datei] 0]
#puts "Datei0: $datei"
							#set size [file size [getFileURL $datei]]
							catch {file size [getFileURL $datei]} size
							if {$size > $merksize} {set merkdatei $datei; set merksize $size}
						}
						set datei $merkdatei
						AddSelected $datei 0
					} elseif {$mx > 2} {
#puts "mehr als 2 Images in HTML"
						set merksize 0
						set merkdatei ""
						foreach inhtml $dummy {
#puts "inHTML: $inhtml"
							ProgressFile $zlr $mx
							if {$cancel==1} {break}
							set datei [regSTR {< > \"} $inhtml]
							set datei [reslvURL [getValue {href} $datei] 0]
#puts "Datei1: $datei"
							#Nur ausgewhlte FileTypes in Liste Selected aufnehmen
							set ext [lindex [split $datei .] end]
							if {[grep $fileTypes $datei] && ![chkEXT $ext]} {
								#new310105: AddSelected wurde urspr. mit 1 angesprochen; jetzt 0
								AddSelected $datei 0
#puts "Bin hier."
							} else {
#puts "oder hier..."
								if {$followLinks==2} {
								#Links ALLER Seiten verfolgen
									set datei [lindex [split $datei #] 0]
									set link [fileDIR $datei]
									set domain [fileDIR $inhalt]
									if {[chkEXT $ext] && [regexp -nocase $link $domain]} {
										set fn [regSTR $remSTR $datei]
										set in [regSTR $remSTR $inhalt]
										if {[inGrep $fn $buffer]==0 && ![regexp -nocase $fn $in]} {
											lappend buffer $datei
											set max [llength $buffer]
										}
									}
								} else {
									set datei [regSTR {< > \"} $inhtml]
									set datei [reslvURL [getValue {src} $datei] 0]
#puts "Datei2: $datei"
									#set size [file size [getFileURL $datei]]
									catch {file size [getFileURL $datei]} size
									if {$size > $merksize} {set merkdatei $datei; set merksize $size}
									#AddSelected $datei 0
								}
							}
							incr zlr
						}
						if {$cancel==1} {return}
						if {[string length $merkdatei]>0} {
							set datei $merkdatei
							AddSelected $datei 0
							incr gesZLR
						}
        				}
					#Jedes File in Selected Downloaden
        				if {[llength $selected]>0} {
        					catch {stop_anigif .mbar.lbAnim}
        					catch {show_anigif [list -data [getAnim trans22]] .mbar.lbAnim}
						#NEW250905:
						if {$autoscroll > 0} {$mainHTML yview moveto 0.0}
                                                #new310105: grabPic wurde urspr. mit 1 angesprochen, jetzt 0
        					grabPIC $destDir 0
        					catch {stop_anigif .mbar.lbAnim}
        				}
        				incr z
					if {$cancel==1} {break}
        				#Nchste HTML-Seite aufrufen, und das Ganze von vorn
        				#Bis alle HTML-Seiten nacheinander aus $buffer ausgelesen wurden
        			}
				if {$cancel==1} {return}
        		set linkmark 0
			clearSelected
        		refreshTotal
        		setLED blue
        		dispMSG "$msgText(download.3) $gesZLR / $bytesTotal KBytes"
			wm title . "Inquisitor"
			wm iconname . "FIQ"
			set ByteCount [expr $ByteCount + $bytesTotal]
			if {$maxBytes > 0 && $ByteCount > $maxBytes} {
				setLED red
				dispINF "$msgText(download.5)"
				.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
			}
        		ProgressFile 0 0
        		}
                } else {
                #z.B. HTM-Seite, die JPG enthlt, wenn FileType=JPG, aber HTML selected
			if {[extGrep $fileTypes $selected]} {
				grabPIC $destDir 0
			} else {
				set buffer ""
				foreach inhalt $selected {
					if {$cancel==1} {break}
					if {[grep $fTypes(HTML) $inhalt] || [regexp -nocase {%47$|/$} $inhalt]} {
						lappend buffer $inhalt
					} else {
						#Nicht HTML-Dokumente aus AuswahlListe rausnehmen
						AddSelected $inhalt 0
					}
				}
				if {$cancel==1} {return}
				clearSelected
				foreach inhalt $buffer {
					if {$cancel==1} {break}
					#set urltext [cutLink $inhalt]
					set urltext [upperHTTP $inhalt]
					preSolve
					selectALL 0
					if {$autoscroll > 0} {$mainHTML yview moveto 0.0}
					grabPIC $destDir 0
				}
#				ProgressBar 0 0
				ProgressFile 0 0
			}
		}
	}
#	set cancel 0
}

#Alle GFX auswhlen, wenn rechte Maus auf Listbox
proc selectALL {arg} {
	global FTPrender activeHTM debug liste baseurl active fileTypes MapMode FTPdir FTPdest linkmark selected htmlDIR \
		mouseOver followLinks thumbsOnly msgText fics ficsVars shiftPress TableIDX ImageIDX htmlTD cancel filter mainHTML
	if {$active} return
	catch {stop_anigif .mbar.lbAnim}
	if {$MapMode==4} {
	#selectALL 0 im FTP-Mode
		set selected ""
		set linkmark 1
		set win [chkFTPactive]
		if {$debug>3} {puts "selectALL tags: $win"}
		set max [llength $FTPdir($win)]
		if {$max<=0} return
		.mbar.lbAnim configure -image imWorker2
		MouseCurs 1
		set tag 0
		foreach inhalt $FTPdir($win) {
			if {$cancel==1} {
				setLED red
				break
			}
			set inhalt [lindex $inhalt 0]
			ProgressFile $tag $max
			incr tag
			#Die obersten beiden Directorys auslassen
			if {$tag<3} continue
			if {[lindex $fileTypes 0]=="*"} {
				AddSelected [string trimright $FTPdest($win) /]/[string trimleft $inhalt /] 1
				set dummy 1
			} else {
				set dummyfn [transType $inhalt]
				if {[grep $fileTypes $dummyfn]} {
					AddSelected [string trimright $FTPdest($win) /]/[string trimleft $inhalt /] 1
					set dummy 1
				}
			}
		}
		ProgressFile 0 0
		unset inhalt tag win
	} else {
	#Alle anderen Modi
		if {[string length $baseurl($activeHTM)]<=0} return
		set cancel 0
		set back 0
		set mouseOver $activeHTM
		#Sorted
		if {[lindex $fileTypes 0]=="*" || ($arg>0 && $followLinks>0)} {
			set href ""
			set dummy [$mainHTML token find a]
#			#CHNG260910:
#                        if {[llength $dummy]<=0} return
#puts "Dummy: $dummy"
			foreach inhalt $dummy {
					lappend href [reslvURL [lindex $inhalt 2] 0]
			}
		} else {
			set href [lsort -dictionary [array names liste $activeHTM,*]]
		}
#puts "HREF: [llength $href] $href"
        set max [llength $href]
		if {$max<=0} return
		.mbar.lbAnim configure -image imWorker2
		MouseCurs 1
		set z 0
#		set merk $linkmark
#		set linkmark $arg
		regsub -nocase -all { } [join $filter] {|} search
		regsub -nocase -all { } [join $fileTypes] {|} dummy
		foreach var $href {
#puts "Var: $var"
			if {$cancel==1} {
				setLED red
				break
			}
      	    		ProgressFile $z $max
      	    		set erg [expr $max - $z]
    				wm title . "FIQ: $z/$max ($erg)"
					wm iconname . "FIQ: $z/$max ($erg)"
      	    		incr z
			set filename [acode decode [lindex [split $var ,] end]]
			set uncutFile $filename
#puts "BEFORE cutted: $filename"
			set filename [string trim [cutLink $filename]]
#puts "after cutted: $filename"
#			if {$fics>0} {
#				if {[regexp -nocase $ficsVars $filename]} continue
#			}
			#NEW060806: don't select filtered keywords
			if {[regexp -nocase -all $search $filename]} continue
			if {[lindex $fileTypes 0]=="*" || $shiftPress==1} {
				AddSelected $filename 0
				set back 0
			} else {
				set ext [getEXT $filename]
				set ext [transType .[string trim $ext .]]
				set ext .[string trim $ext .]
#puts "EXT: $ext"
				if {$htmlDIR==0} {
#					if {[regexp -nocase $dummy $ext] || $followLinks==1 || $thumbsOnly==1} {}
					if {[regexp -nocase $dummy $ext] || $arg>0} {
					#Nur ausgewhlte FileTypes zulassen
						AddSelected $filename 0
						set back 0
					} else {
						set check [transType $uncutFile]
#puts "$check fileTypes: $fileTypes"
						if {[regexp -nocase $dummy $check]} {
							AddSelected $filename 0
							set back 0
						} else {
							set back 1
						}
					}
				 } else {
					if {[regexp -nocase $dummy $ext]} {
						AddSelected $filename 0
						set back 0
					} else {
						set back 1
					}
				 }
			}
		}
		ProgressFile 0 0
		wm title . "Inquisitor"
		wm iconname . "FIQ"
		if {$back == 1 && [llength $selected]>0} {
			dispMSG $msgText(file.match)
			setLED red
		}
		catch {unset href var filename uncutFile}
	}
#	set linkmark $merk
	catch {stop_anigif .mbar.lbAnim}
	MouseCurs 0
}

#HistoryFunctions
#NEU170404: Load/SaveHistory
proc LoadHistory {} {
	global lastDir idxHistry FTPsort msgText language linkmark
	set filetypes {
		{{History Files} {.FQH .LOG}}
		{{Selection Files} {.FQS .TXT}}
		{{All Files} *}
	}
	set merk $linkmark
	set linkmark 1
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim floater22]] .mbar.lbAnim} err
	set f [tk_getOpenFile -title $msgText(history.load.1) -initialdir $lastDir -filetypes $filetypes]
    catch {stop_anigif .mbar.lbAnim} err
	update
	if {[string length $f]>1} {
		set lastDir [string trimright [fileDIR $f] /]/
		set dummy [openFile $f]
		set dummy [lsort -dictionary $dummy]
		if {$FTPsort==1} {set dummy [lsort -command compare $dummy]}
		.mbar.lbAnim configure -image imWorker2
		MouseCurs 1
		#MenuConfig
		set max [llength $dummy]
		set z 0
		foreach inhalt $dummy {
			ProgressBar $z $max
			set erg [expr $max - $z]
			wm title . "FIQ: $z/$max ($erg)"
			wm iconname . "FIQ: $z/$max ($erg)"
			if {[regexp -nocase {.fqs$|.txt$} $f]} {
			  		AddSelected $inhalt 0
			} else {
					addHistry $inhalt
			}
			incr z
		}
		set idxHistry 1
		catch {stop_anigif .mbar.lbAnim}
		MouseCurs 0
		ProgressBar 0 0
		wm title . "Inquisitor"
		wm iconname . "FIQ"
		dispMSG $msgText(history.load.2)
		setLED blue
	}
	set linkmark $merk
}

proc SaveHistory {} {
	global histry lastDir urltext msgText language selected
	if {[llength $histry]<=0 && [llength $selected]<=0} {
		dispMSG $msgText(history.save.1)
		setLED orange
		return
	}
	set filename [lindex [split $urltext /] end]
	set filename [lindex [split $filename .] 0]
	set filetypes {
		{{History Files} {.FQH .LOG}}
		{{Selection Files} {.FQS .TXT}}
		{{All Files} *}
	}
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim superTux22]] .mbar.lbAnim} err
	set f [tk_getSaveFile -title $msgText(history.save.2) -initialdir $lastDir -filetypes $filetypes -initialfile $filename]
#	set f [string toupper $f]
        catch {stop_anigif .mbar.lbAnim} err
	if {[string length $f]>1} {
		set lastDir [string trimright [fileDIR $f] /]/
#		if {![catch {open $f "w"} fileid]} {
		   	if {[regexp -nocase {.fqs$|.txt$} $f]} {
		   		writeFile $f [regsub -nocase -all { } [join $selected] "\n"]
#puts "SaVe: $f [regsub -nocase -all { } [join $selected] "\n"]"
			} else {
				writeFile $f [regsub -nocase -all { } [join $histry] "\n"]
#puts "SavE: $f [regsub -nocase -all { } [join $histry] "\n"]"
			}
#			close $fileid
#		} else {
#			return
#		}
		dispMSG $msgText(history.save.3)
		setLED blue
	}
}

#Select DestDirectory for Save
proc selectDIR {} {
	global destDir FTPdest homeDir msgText language inifile dirList
	if {[string length $destDir] == 0} {set destDir $homeDir}
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim faller22]] .mbar.lbAnim} err
	set merkDir $destDir
        set destDir [tk_chooseDirectory -title $msgText(destination.select) -initialdir $destDir]
	set destDir [string trimright $destDir /]/
#NEW260910
#set dirList [lappend $dirList $destDir]
#set dirList [linsert $dirList [lsearch -regexp $dirList $destDir] $destDir]
addDirlist $destDir
#puts "$dirList - [lsearch -regexp $dirList $destDir]"

	catch {stop_anigif .mbar.lbAnim} err
	if {[string length $destDir] <= 1} {set destDir $merkDir}
	set FTPdest(local) $destDir
    refreshTotal
	update
	#NEW291005: SaveINI
	SaveScript $inifile
}

#NEW220406: Change CacheLocation
proc changeDIR {} {
	global homeDir msgText cacheLocation FTPask msgText
	if {[string length $cacheLocation] <= 0} {set cacheLocation $homeDir}
	set merk $cacheLocation
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim faller22]] .mbar.lbAnim} err
	set cacheLocation [tk_chooseDirectory -title $msgText(change.cache.select) -initialdir $cacheLocation]
	set cacheLocation [string trimright $cacheLocation /]/
	catch {stop_anigif .mbar.lbAnim} err
	if {[string length $cacheLocation] <= 0} {set cacheLocation $homeDir}
	if {$cacheLocation != $merk} {
                if {![file isdirectory $cacheLocation]} {
                        if {$FTPask==1} {
                		set answer [optionBox -title $msgText(copy.cache.1) -icon warning -type yesnocancel -message $msgText(copy.cache.2)]
                	} else {
                		set answer yes
                	}
                	switch $answer {
                		yes {
                                      catch {file copy -force [string trimright $merk /]/ [string trimright $cacheLocation /]/}
                                      catch {file delete -force [string trimright $merk /]/}
                                }
                                no {
                                      mkCacheDir
                                      catch {file delete -force [string trimright $merk /]/}
                                }
                                default {set cacheLocation $merk}
                        }
                }
	}
}

#NEW171004: newSaveFileSelectionDialog (MultipleSave)
proc fileSave {select} {
	global LastFile lastDir urltext selected value cutGfx sysFont backColor msgText language
	if {[llength $selected]<=0} {SavePage; return}
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim loop22]] .mbar.lbAnim} err
	set filename [string trimright $lastDir /]/[lindex [split $urltext /] end]
	if {[file exists $filename]} {
		set extension [lindex [split $filename .] end ]
		set zielname [lindex [split $filename .] 0 ]
		set filename ${lastDir}/${zielname}\_[clock seconds].$extension
	}
	regsub -nocase -all {/+} $filename {/} LastFile(local)
	set value(kind) $select
	set merk $cutGfx
	set w .filebox
	toplevel $w
	wm title $w $msgText(files.save.1)
	wm iconname $w $msgText(files.save.2)
	wm protocol $w WM_DELETE_WINDOW {set cutGfx $merk; catch {stop_anigif .mbar.lbAnim}; destroy .filebox}
	wm geometry $w +300+300
	frame $w.buttons
	button $w.buttons.btok -text OK -image imOKbutton -compound left -command "SaveFile; set cutGfx $merk; catch {stop_anigif .mbar.lbAnim}; destroy $w" -font $sysFont(0)
	checkbutton $w.buttons.cutDest -variable cutGfx -text $msgText(files.save.3) -relief groove
	button $w.buttons.btcancel -text Cancel -image imCancel -compound left -command "set cutGfx $merk; catch {stop_anigif .mbar.lbAnim}; destroy $w" -font $sysFont(0)
	pack $w.buttons.btok $w.buttons.cutDest $w.buttons.btcancel -side left -expand 1
	pack $w.buttons -side bottom -fill x -pady 3
	#include Links/Images in HTMLfile
	frame $w.include -borderwidth 2 -relief ridge
	radiobutton $w.include.without -text $msgText(files.save.4) -underline -1 -variable value(with) -value 1 -relief groove -command ActDest
	radiobutton $w.include.images -text $msgText(files.save.5) -underline -1 -variable value(with) -value 2 -relief groove -command ActDest
	radiobutton $w.include.all -text $msgText(files.save.6) -underline -1 -variable value(with) -value 3 -relief groove
	pack $w.include.without $w.include.images $w.include.all -in $w.include -side left -padx 1 -pady 2
	pack $w.include -side bottom -padx 1 -pady 2
        #Kind of SaveFile
	frame $w.icons
	label $w.icons.fiq -image imFSworld -compound left -background $backColor -relief groove
        label $w.icons.logo -image imFSlogo -compound left -background $backColor -relief groove
        frame $w.icons.radio -borderwidth 2 -relief ridge
	radiobutton $w.icons.radio.displayed -text $msgText(files.save.7) -underline -1 -variable value(kind) -value 1 -relief groove -command ActDest
	radiobutton $w.icons.radio.selected -text $msgText(files.save.8) -underline -1 -variable value(kind) -value 2 -relief groove -command ActDest
	radiobutton $w.icons.radio.both -text $msgText(files.save.9) -underline -1 -variable value(kind) -value 3 -relief groove
	#NEW180505: SaveThumbOnly
	radiobutton $w.icons.radio.thumbs -text $msgText(files.save.10) -underline -1 -variable value(kind) -value 4 -relief groove
	pack $w.icons.radio.displayed $w.icons.radio.selected $w.icons.radio.both $w.icons.radio.thumbs -in $w.icons.radio -side left -padx 1 -pady 2
	pack $w.icons.fiq $w.icons.radio $w.icons.logo -side left -padx 2 -pady 1
	pack $w.icons -side bottom -padx 1 -pady 2
	switch -regexp $select {
		2 {set value(kind) 2; $w.icons.radio.selected select}
		3 {set value(kind) 3; $w.icons.radio.both}
		default {set value(kind) 1; $w.icons.radio.displayed select}
	}
	#Destination
	frame $w.save
	label $w.save.lab -text $msgText(files.save.11) -anchor e -font $sysFont(0)
	entry $w.save.ent -textvariable LastFile(local) -width 30 -justify left
	button $w.save.but -text $msgText(files.save.12) -command "fileDialog $filename; raise $w" -font $sysFont(0)
	pack $w.save.lab -side left
	pack $w.save.ent -side left -expand yes -fill x
	pack $w.save.but -side left -padx 2
	pack $w.save -fill x -padx 3 -pady 3
	ActDest
}

#HelpRoutine 2 ActualizeDestination when changes displayed/selection Save
proc ActDest {} {
	global LastFile value urltext selected lastDir
	set w .filebox
	switch -regexp $value(kind) {
		2 {set filename [lindex [split [lindex $selected 0] /] end]}
		default {set filename [lindex [split $urltext /] end]}
	}
	set LastFile(local) [string trimright $lastDir /]/[string trim $filename /]
	if {[chkEXT [getEXT $LastFile(local)]]} {
		$w.include.without configure -state normal
		$w.include.images configure -state normal
		$w.include.all configure -state normal
	} else {
		$w.include.without configure -state disabled
		$w.include.images configure -state disabled
		$w.include.all configure -state disabled
		set value(with) 1
	}
}

#Routine 2 Save MultipleFiles
proc SaveFile {} {
	global LastFile value urltext selected cutGfx liste msgText language
	set filename $LastFile(local)
	if {[string length $filename]<=0} {dispMSG $msgText(file.save.1); setLED orange; return}
	set msg ""
	switch -regexp $value(kind) {
		1 {
			set quelle [getFileURL $urltext 0]
			file copy -force $quelle $filename
			set msg $msgText(file.save.2)
		}
		2 {
			foreach inhalt $selected {Save $inhalt}
			set msg $msgText(file.save.3)
		}
		3 {
			set quelle [getFileURL $urltext 0]
			file copy -force $quelle $filename
			foreach inhalt $selected {Save $inhalt}
			set msg $msgText(file.save.4)
		}
		4 {
		#NEW170505: Save ThumsOnly from within DisplayedSite
			set such ""
			foreach inhalt $selected {
				set thmbname [acode resolv [link2thumb $inhalt]]
				Save $thmbname
			}
		}
	}
	if {$value(with)>1} {
	#Save also all Links/Images from within HTML
		set such [array get liste]
		switch -regexp $value(with) {
			2 {
				foreach {linkname thmbname} $such {Save $thmbname}
				set msg $msgText(file.save.5)
			}
			3 {
				foreach {linkname thmbname} $such {Save [lindex [split $linkname ,] end]}
				set msg $msgText(file.save.6)
			}
		}
	}
	if {[string length $msg]>0} {dispMSG $msg}
	catch {unset filename value}
}

proc Save {inhalt} {
	global lastDir cutGfx
	setLED green
	set filename [lindex [split $inhalt /] end]
	set ziel $lastDir/$filename
	if {[file exists $ziel]} {
		set extension [lindex [split $filename .] end ]
		set zielname [lindex [split $filename .] 0 ]
		if {$cutGfx==1} {
			set filename [clock clicks].$extension
		} else {
			set filename $zielname\_[clock clicks].$extension
		}
		set ziel $lastDir/$filename
	}
	set quelle [getFileURL $inhalt 0]
	file copy -force $quelle $ziel
}

#File/Directory SelectionDialogue
proc fileDialog {filename} {
	global LastFile fTypes lastDir msgText language
	set filename [lindex [split $filename /] end]
	set filetypes { {{All Files} *} }

	if {[chkIMG [getEXT $filename]]} {
		set filetypes ""
		foreach inhalt $fTypes(Images) {
			lappend filetypes "$inhalt $inhalt"
		}
		lappend filetypes {{All Files} *}
	} else {
		if {[chkEXT [getEXT $filename]]} {
			set filetypes ""
			foreach inhalt $fTypes(HTML) {
				lappend filetypes "$inhalt $inhalt"
			}
			lappend filetypes {{All Files} *}
		}
	}
	set LastFile(local) [tk_getSaveFile -title $msgText(page.save) -initialdir $lastDir -filetypes $filetypes -initialfile $filename]
	set dummy [lindex [split $LastFile(local) /] end]
	regsub -nocase -all $dummy $LastFile(local) {} lastDir
}

proc ChangeMode {mode} {
	global debug active MapMode MMode destDir msgText language
	if {$active==1} return
	closeFTP
	if {$debug>2} {puts "ChangeMode get: $mode"}
	if {[string length $mode]<=0} return
	if {$MapMode==$mode} return
	set MapMode $mode
	set MMode $mode
	if {$debug>3} {puts "changeMode: set MapMode $mode"}
	#AlleFrames entfernen
	exitConf
	switch $mode {
		2 {
			.tile.bottom.pane raise 2
			MapNRM
			MapSCN
			dispMSG $msgText(mode.change.2)
			setLED blue
		}
		3 {
			.tile.bottom.pane raise 3
			MapNRM
			dispMSG $msgText(mode.change.3)
			setLED blue
                        refreshTotal
			focus .head.dispUrl.url.e
			#update
                }
		4 {
			.tile.bottom.pane raise 4
			MapNRM
			MapFTP
			dispMSG $msgText(mode.change.4)
			setLED blue
		}
		default {
		        if {$MapMode==3} return
                	.tile.bottom.pane raise 3
			MapNRM
			dispMSG $msgText(mode.change.3)
			setLED blue
                        refreshTotal
                }
	}
	update
}

proc confFIQ {} {
	global MapMode kidZprotect msgText language
	if {$kidZprotect==1} {
                setLED magenta
                .mbar.lbAnim configure -image imStopTux
                dispMSG $msgText(kidmode.denied)
                return
        }
	set MapMode 0
	if {[winfo ismapped .tile.top.conf]} {
		exitConf
		ChangeMode 3
	} else {
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim world22]] .mbar.lbAnim} err
		pack forget .tile.top.ftp
		pack forget .tile.top.html
		pack .tile.top.conf -in .tile.top -side left -expand true -fill both
		.tile.top.conf.page raise page3
	}
	set MapMode 3
}

proc exitConf {} {
	global cfgfile
	catch {stop_anigif .mbar.lbAnim} err
	catch {pack forget .tile.top.conf}
}

#Prg Verlassen (Config speichern, und aufrumen)
proc leavePRG {nError} {
	global inifile cfgfile dummyIMG token FTPask snd cClean cancel linktext activeHTM HTMLwin \
	mainHTML urltext active msgText language winPos toknHandles filter
	if {$nError>=0} {
		if {$nError==0} {
			if {$FTPask==1} {
				catch {stop_anigif .mbar.lbAnim} err
				catch {show_anigif [list -data [getAnim exit22]] .mbar.lbAnim}
				dispMSG $msgText(exit.1)
				set answer [optionBox -title $msgText(exit.2) -icon question -type yesno -message $msgText(exit.3)]
			} else {
				set answer yes
			}
			switch $answer {
				yes {
					SaveScript $inifile
				}
				no {
					catch {stop_anigif .mbar.lbAnim} err
					return
				}
			}
		} else {
			puts "Abnormal Exit cause FIQ-Error:"
			puts $nError
		}
	} else {
		catch {stop_anigif .mbar.lbAnim}
		catch {show_anigif [list -data [getAnim exit22]] .mbar.lbAnim} err

		update
	}
	wm title . "Goodbye Inquisitor"
	wm iconname . "Goodbye FIQ"
	set active 1
	chkActive
	.mbar.stop configure -state disabled
    set cancel 1
	exitConf
	ChangeMode 3
	set urltext ""
        clearBoth
	if {[llength $toknHandles]>0} {
		foreach inhalt $toknHandles {
			catch {http::reset $inhalt}
			catch {http::cleanup $inhalt}
		}
	}
	catch {http::reset $token}
	catch {http::cleanup $token}
	catch {image delete dummyIMG}
	catch {http::unregister https}
	catch {font delete [font names]}
        catch {snd stop; s stop}
        catch {snd destroy; s destroy}
        saveCFG $cfgfile
	if {$winPos==1} {
		set f [lindex [split $cfgfile .] 0].POS
		savePOS $f
	}
	#NEW300706: saveFilter
	if {[llength $filter]>0} {
		set f [lindex [split $cfgfile .] 0].FIL
		writeFile $f $filter
	}
       	catch {stop_anigif .mbar.lbAnim}
        #NEU280804: cleanCache
	if {$cClean > 0} {set linktext $msgText(exit.4); update; cleanCache $cClean}
	catch {unset [info vars]}
	exit
}

#Cache bereinigen
proc clearCache {args} {
	global homeDir urltext MapMode FTPdest FTPask selected winSYS msgText language remSTR filtVars cacheLocation
	if {$FTPask==1 || $args==0 || $args==1 || $args==4} {
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim bomber22]] .mbar.lbAnim} err
		set answer [optionBox -title $msgText(cache.clear.1) -icon warning -type yesno -message $msgText(cache.clear.2)]
		catch {stop_anigif .mbar.lbAnim} err

		update
	} else {
		set answer yes
	}
	switch $answer {
		yes {
			mkCacheDir
			if {$MapMode==4} {
				set cfile [string trim $FTPdest([chkFTPactive]) /]
				set dummy $cfile
       				set cfile [acode encode $cfile]
       				set cachedir [string trimright $cacheLocation /]/cache/preview/[getCachedir $cfile]
       				set filename ${cachedir}/${cfile}.FQV
       				catch {file delete -force $filename}
       				dispMSG $msgText(cache.clear.3)
       				setLED blue
			} else {
				if {$args==0} {
				#Complete Cache
					set path [string trimright $cacheLocation /]/cache/html/
					#set path2 [string trimright $cacheLocation /]/cache/directories/
#					set path3 [string trimright $homeDir /]/cache/domDB/
#					set path4 [string trimright $homeDir /]/cache/eTagDB/
					catch {file delete -force $path}
					dispMSG $msgText(cache.clear.4)
					setLED blue
				} else {
					set datei [regSTR $remSTR $urltext]
					if {[string length $datei]<=0} return
                                        if {$winSYS==1} {regsub -nocase -all {^/} $datei {} datei}
					set fake [trimFile $datei]
#					set fdir [string trimleft $fake .]
#					set chart [lindex [split $fdir {}] 0]
					set chart [getCachedir $fake]
					set cachedir [string trimright $cacheLocation /]/cache/html/$chart
					set lockfile [string trimright $cachedir /]/FIQ.LOCK
					#set dirfile1 [string trim [string trimright $homeDir /]/cache/directories/$chart].FQD
#					set dirfile2 [string trimright $homeDir /]/cache/domDB/$chart
#					set dirfile3 [string trimright $homeDir /]/cache/eTagDB/$chart
                                        #catch {file delete -force $dirfile1}
		                        set datei [acode encode $datei]
                		        set gfx $datei
					if {$args==1} {
					#actual Page
						if {[string length $cachedir]>0} {
							set gfx [cutEXT [acode encode $datei]]*
                                                        catch {file delete -force $cachedir/$gfx}
						        dispMSG $msgText(cache.clear.5)
						        setLED blue
						}
					}
					if {$args==2} {
					#selected pages
						if {[string length $gfx]>0} {
							    set ext [getEXT $gfx]
							    regsub -nocase "$ext$" $gfx {*} gfx
      						            catch {file delete -force $cachedir/$gfx}
							    if {[file exists $lockfile]} {file delete -force $lockfile}
						            dispMSG $msgText(cache.clear.6)
						            setLED blue
						}
					}
					if {$args==3} {
					#Domain
						if {[llength $selected]>0} {
      						   foreach inhalt $selected {
							set datei [regSTR $remSTR $inhalt]
							set gfx [acode encode $datei]
							catch {file delete -force $cachedir/$gfx}
							if {[file exists $lockfile]} {file delete -force $lockfile}
						   }
						   dispMSG $msgText(cache.clear.7)
						   setLED blue
						}
					}
					if {$args==4} {
					#actual Directory
						if {[string length $cachedir]>0} {
                                                        catch {file delete -force $cachedir}
						        dispMSG $msgText(cache.clear.8)
						        setLED blue
						}
					}
				}
			}
		}
		no return
	}
}

proc cleanCache {maxsize} {
#Bereinigt/lscht CacheDir, wenn subDir > maxsize (in MB) on exit
	global homeDir infostatus sysFont linktext dayClean speedCache msgText language HTMLurl activeHTM remSTR urltext winSYS cacheLocation anzSEL compltCache FIQexe
	if {[string length $HTMLurl(local)]<=0} {set $HTMLurl(local) $urltext}
	if {[string length $HTMLurl(remote)]<=0} {set $HTMLurl(remote) $urltext}
	set localURL [regSTR $remSTR $HTMLurl(local)]
	regsub -nocase -all {www\.|www[0-9]\.} $localURL {} localURL
	set localURL [trimFile $localURL]
	set localURL [lindex [split $localURL  {}] 0]
	set remotURL [regSTR $remSTR $HTMLurl(remote)]
	regsub -nocase -all {www\.|www[0-9]\.} $remotURL {} remotURL
	set remotURL [trimFile $remotURL]
	set remotURL [lindex [split $remotURL  {}] 0]
	set cachedir [string trimright $cacheLocation /]/cache/html/
#puts "CACHE: $cachedir : [file exists $cachedir] : $maxsize : $dayClean : $FIQexe"
	if {![file exists $cachedir] || $maxsize == 0 || $dayClean == 1 || $FIQexe==0} return
#puts "CACHE2"
	.mbar.lbText configure -text "Status:" -relief flat -font $sysFont(0)
	set infostatus $msgText(cache.clean)
	.mbar.lbAnim configure -image imWorker

	update
#NEW190806: delete COMPLETE Cachedir after Leaving
	if {$compltCache>0} {
        set cachedir [string trimright $cacheLocation /]/cache/*
		catch {file delete -force $cachedir}
		return
	}
	#NEW170906:
	set lockfile [string trimright $cacheLocation /]/cache/FIQ.LOCK
	if {![file exists $lockfile]} {
		writeFile $lockfile "FIQ LockFile"
	} else {
	    return
	}
	set favicoall [string trimright $cacheLocation /]/cache/favicons/*
	set maindir [glob -nocomplain $favicoall]
        set favicons ""
        set z 0
	set max [llength $maindir]
	foreach dirlist $maindir {
	        set favall [string trimright $dirlist /]/*
                set dummy [glob -nocomplain $favall]
		ProgressFile $z $max
                if {[llength $dummy]<=0} {
			#NEW190206: remove whole Directory if empty
			catch {file delete -force $dirlist}
		} else {
	                foreach inhalt $dummy {
	                        if {![regexp -nocase -all {\.ico$} [lindex [split $inhalt /] end]] || [file size $inhalt]<=800} {lappend favicons $inhalt}
	                }
	                if {[llength $favicons]>0} {
	        		foreach datei $favicons {
#	                                update
	        			catch {file delete -force $datei}
	        		}
	        		set favicons ""
	        	}
		}
		incr z
    }
	ProgressFile 0 0
	#NEW031005: Clear non existent Preview Directorys
	set prev [string trimright $cacheLocation /]/cache/preview/*
	set maindir [glob -nocomplain $prev]
        set preview ""
	foreach dirlist $maindir {
	        set prev [string trim $dirlist]/*.FQV
                set dummy [glob -nocomplain $prev]
                set dlen [llength $dummy]
                if {$dlen>0} {
        		foreach inhalt $dummy {
        			set prev [lindex [split $inhalt /] end]
        			set prev [lindex [split $prev .] 0]
        			if {$winSYS==1} {
                 			set prev [string trim [acode decode $prev] /]/
        			} else {
                 			set prev /[string trim [acode decode $prev] /]/
        			}
                                if {![file isdirectory $prev]} {lappend preview $inhalt}
                        }
                	set len [llength $preview]
                        if {$len>0} {
                                set z 0
                		foreach datei $preview {
                                        ProgressFile $z $len
                                        
                                        update
        				set datei [lindex [split $datei .] 0].FQV
                			catch {file delete -force $datei}
                			incr z
                		}
                		ProgressFile 0 0
                	}
      		} else {
                        catch {file delete -force $dirlist}
      		}
        }
#NEW0301005 end
	set dirs [glob -nocomplain $cachedir/*]
	set max [llength $dirs]
	set allsize 0
	set z 0
	set dirlist ""
#NEW180206: jump actual URLdir
set chart [getCachedir $HTMLurl($activeHTM)]
set actualdir [string trimright $cacheLocation /]/cache/html/$chart
#set week [clock format [clock seconds] -format "%m"]
set month [clock scan "3 month ago"]
	foreach dir $dirs {
                set size 0
                ProgressBar $z $max
		set linktext $msgText(exit.4)$dir
		set rem [expr $max - $z]
        	if {$rem<10} {
			set anzSEL [format "%02u" $rem]
		} else {
			set anzSEL $rem
		}
		.lbAnzSelGfx configure -width [string length $anzSEL]
        wm title . "CLR: $z/$max ($rem)"
		wm iconname . "CLR: $z/$max ($rem)"
	        incr z
                set filelist ""
#NEW180206: jump actual URLdir
if {[regexp -nocase $actualdir $dir]} continue
		set files [glob -nocomplain $dir/*]
#NEW180206: jump Dir if it contains FIQ.LOCK
if {[regexp -nocase {FIQ.LOCK} $files]} {
	if {[file exists $dir/FIQ.LOCK]} {file delete -force $dir/FIQ.LOCK}
	continue
}
#set dirmonth [clock format [file atime $dir/] -format "%m"]
		if {[llength $files]<=6 || [llength $files]>900 || [file atime $dir/]<=$month} {
			set linktext $msgText(exit.5)$dir
			update
			catch {file delete -force $dir}
			continue
		}
		update
		foreach datei $files {
			set fSize [file size $datei]
			if {[regexp -nocase -all {[0-9]} $fSize]} {
				catch {expr $size + $fSize} size
			}
			lappend filelist [list $fSize [lindex [split [string trimright $datei /] /] end]]
			setLED violet
		}
#		          if {[llength $filelist]>0} {writeFile $cachefile $filelist}
		catch {expr $allsize + $size} allsize
                lappend dirlist [list $size $dir]
                setLED magenta
	}
	wm title . "FIQ CLEAN: $msgText(cache.clear.delete)"
	wm iconname . "FIQ CLR: $msgText(cache.clear.delete)"
	set anzSEL "00"
	.lbAnzSelGfx configure -width [string length $anzSEL]
    update
	#calculate Size in MBytes
	catch {expr $maxsize * 1024 * 1024} maxsize
       	set clrlist ""
	if {$allsize > $maxsize && $maxsize != 0} {
		set dummy [lsort -index 0 -integer $dirlist]
		set zlr [llength $dummy]
		set dirlist ""
#puts "Dummy: $dummy $zlr"
		while {$allsize > $maxsize} {
			set dir [lindex $dummy $zlr]
#puts "Dir: $zlr $dir"
			if {![regexp -nocase {^$localURL|^$remotURL} $dir] && [string length $dir]>0} {
				set help [string trimright [lindex $dir 1] /]
				lappend clrlist $help
				set dirsize [lindex $dir 0]
				set allsize [expr $allsize - $dirsize]
#puts "DirSize: $maxsize $dirsize $allsize"
			}
			set zlr [expr $zlr - 1]
			if {$zlr < 0} break
		}
#puts "clrlist: $clrlist"
#puts "DIRlist: $dirlist"
		set dummy [split $clrlist " "]
		foreach datei $dummy {
#puts "Delete: $datei"
			catch {file delete -force $datei}
		}
	}
	catch {file delete -force $lockfile}
	#NEW121106:
	set dummy [string trimright $cacheLocation /]/cache/*.*
	if {[file exists $dummy]} {catch {file delete -force $dummy}}
	#NEW221006:
	set dummy [string trimright $homeDir /]/.HTM
	if {[file exists $dummy]} {catch {file delete -force $dummy}}
	set dummy [string trimright $homeDir /]/.INI
	if {[file exists $dummy]} {catch {file delete -force $dummy}}
	catch {unset dummy filelist files fName cachedir favicohtm favicoplain favicons dir dirs dirlist z max localURL remotURL}
	ProgressBar 0 0
}

# Menu: clearHistory
proc clrHistory {} {
	global histry idxHistry imgHistry msgText language
	set histry ""
	set imgHistry ""
	set idxHistry 0
	.head.dispUrl.url configure -values $histry -images $imgHistry
	dispMSG $msgText(history.clear)
	setLED blue
}

#Button: Auswahl lschen & GFX zurcksetzen
proc clearSelected {} {
	global FTPrender MapMode anzGFX zlrGFX anzSEL selected active thumbsOnly buffer cancel
	if {$active} return
	foreach choice $selected {
#		if {$thumbsOnly==1} {
#			AddSelected [getThumb $choice] 0
#		} else {
			AddSelected $choice 0
#		}
	}
	catch {unset selected}
	set selected ""
	set buffer ""
#	set cancel 0
    refreshSelected
	set anzGFX 0
	set zlrGFX 0
	set anzSEL 00
	.lbAnzSelGfx configure -width [string length $anzSEL]
	if {$MapMode==4 && $FTPrender==0} {
		unselectTags 0
	}
	setLED blue
}

#ClearCookies deletes all Cookies in CachDir (Called from FIQsetup)
proc clearCookies {} {
	global homeDir FTPask cookie cookieHeader msgText language cacheLocation
	if {$FTPask==1} {
		set answer [optionBox -title $msgText(cookies.delete.1) -icon warning -type yesno -message $msgText(cookies.delete.2)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
      	             set dir [string trimright $cacheLocation /]/cache/cookies/
  	             catch {file delete -force $dir}
  	             if {![file isdirectory $dir]} {
  		             file mkdir $dir
  	             }
		     set cookie ""
		     set cookieHeader ""
	             dispMSG $msgText(cookies.delete.3)
		     setLED blue
	        }
	}
}

proc refreshTotal {} {
     global anzDest destDir fgColor etryBack backColor
#     set dummy [expr [llength [glob -nocomplain -directory $destDir *]] -2]
	set dummy [join [glob -nocomplain -directory $destDir *]]
	regsub -nocase -all {/\.|/\.\.} $dummy {} dummy
	set dummy [split $dummy]
	set dummy [llength $dummy]
     if {$dummy<0} {set dummy 0}
     set anzDest $dummy
     if {$anzDest <=999} {
                .tile.bottom.pane.f3.box.etTotal configure -foreground $fgColor -background $backColor -activebackground $backColor -disabledforeground $etryBack
     } else {
               	if {$anzDest > 999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background yellow -activebackground yellow -disabledforeground black}
                if {$anzDest > 9999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background orange -activebackground orange -disabledforeground black}
                if {$anzDest > 99999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background red -activebackground red3 -disabledforeground black}
     }
     unset dummy
}

#NEW050505: set Filter on specified URL (so that URL couldn't be clicked anymore)
proc addFilter {} {
     global urltext filter msgText
     if {$urltext == ""} {
          set filter [list "irgendwasunmgliches"]
          dispMSG $msgText(filter.1)
     } else {
          set chk [lindex [URLsplit $urltext] 1]
          if {[string length $chk ]<=0} {set chk $urltext}
	  lappend filter $chk
          dispMSG $msgText(filter.2)
     }
     setLED blue
}

#NEW280505: Swap HTML/FTP Pages left/right
proc swapPage {} {
	global MapMode HTMLurl urltext FTPdir
	switch $MapMode {
		4 {
			set dummy $FTPdir(local)
			set FTPdir(local) $FTPdir(remote)
			set FTPdir(remote) $dummy
			refreshFTP "local"
			refreshFTP "remote"
#		                #NEW290105: disable remoteFTPwindows for TextWriting
#		                .tile.top.ftp.tile.remote.remote configure -state disabled
				readLocalDir local $FTPdir(local)
				readLocalDir remote $FTPdir(remote)
#				displayTag local
#				displayTag remote
		}
		default {
#TEST
#destroy .tile.top.html.tile.html.intern.internal
#pack .tile.top.html.tile.html.pane.left.hold.local -in .tile.top.html.tile.html.intern
#pack forget .tile.top.html.tile.html.pane.left.hold.local
#pack .tile.top.html.tile.html.pane.rght.hold.remote -in .tile.top.html.tile.html.pane.left.hold.local
#pack forget .tile.top.html.tile.html.pane.rght.hold.remote
#pack .tile.top.html.tile.html.intern.internal -in .tile.top.html.tile.html.pane.rght.hold.remote
#pack forget .tile.top.html.tile.html.intern.internal
#return

			#if {[string length $HTMLurl(local)]>0 && [string length $HTMLurl(remote)]>0} {
				setHTMLactive remote 0
				set merk $HTMLurl(local)
				setHTMLactive local 0
				set urltext [upperHTTP $HTMLurl(remote)]
				set HTMLurl(local) $HTMLurl(remote)
				preSolve

				setHTMLactive remote 0
				set urltext $merk
				set HTMLurl(remote) $merk
				preSolve
			#}
		}
	}
}

proc optionBox {args} {
	global urltext sysFont msgText returnValue playSounds homeDir GIFdelay cancel normLight
	if {[winfo exists .optbox]} return
	set returnValue 0
	set header ""
	set mtext ""
	set icon ""
	set type "ok"
	set image ""
	foreach {arg value} $args {
		switch -regexp \\"$arg" {
			"-title"   {set header $value}
			"-message" {set mtext $value}
			"-icon"    {set icon $value}
			"-type"    {set type $value}
			"-image"   {set image $value}
		}
	}
#NEW310705: MessageText aufteilen zu je 80 Zeichen dann CRLF
	set len [string length $mtext]
	if {$len > 80 && ![regexp -nocase "\n" $mtext]} {
		#Text aufteilen, wenn > 80 Zeichen (CRLF)
		set count 0
		set crlf 0
		set dummy ""
		while {$count <= $len} {
			append dummy [string index $mtext $count]
			incr count
			incr crlf
			if {$crlf == 80} {
				set crlf 0
				append dummy "\n"
			}
		}
		append dummy "\n"
		set mtext $dummy
		unset dummy
	}

	set w .optbox
	toplevel $w
	wm title $w $header
	#wm iconname $w $msgText(files.save.2)
	wm protocol $w WM_DELETE_WINDOW {set cancel 1; catch {snd stop; s stop}; destroy .optbox; .mbar.lbAnim configure -image imAnim}
	wm geometry $w +300+300
	#wm resizable $w false false
	#wm transient $w .
	set img imInfo22
	switch -regexp icon {
	       error {set img imStopPNG}
	       info {set img imInfo22}
	       question {set img imQuestion22}
	       warning {set img imWarning22}
	       default {set img imInfo22}
	}
	frame $w.frtext
	label $w.frtext.lbicon -relief flat -image $img -compound left
	if {[string length $image]<=0} {
		label $w.frtext.lbtext -text "\n $mtext \n" -relief ridge -font $sysFont(7) -background $normLight
	} else {
		$image configure -gamma 0.2
		canvas $w.frtext.lbtext -relief ridge -width 300 -height 260 -background black
		$w.frtext.lbtext create image 150 130 -image $image
		$w.frtext.lbtext create text 150 130 -text "\n $mtext \n" -font "arial 11 bold" -fill red -justify center
	}
	pack $w.frtext.lbicon $w.frtext.lbtext -in $w.frtext -side left -padx 2 -pady 1
	frame $w.buttons
	pack $w.frtext $w.buttons -in $w -side top -expand true -fill x -padx 2 -pady 1
	switch $type {
		ok {
			button $w.buttons.btok -text OK -image imOKbutton -compound left -command {set returnValue 1; destroy .optbox} -font $sysFont(0)
			pack $w.buttons.btok -in $w.buttons -padx 2 -pady 1
		}
		okcancel {
			button $w.buttons.btok -text $msgText(okcancel.1) -image imOKbutton -compound left -command {set returnValue 1; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btcancel -text $msgText(okcancel.2) -image imCancel -compound left -command {set returnValue 0; destroy .optbox} -font $sysFont(0)
			pack $w.buttons.btok -in $w.buttons -side left -padx 2 -pady 1
			pack $w.buttons.btcancel -in $w.buttons -side right -padx 2 -pady 1
		}
		okhome {
                        button $w.buttons.btok -text "OK" -image imOKbutton -compound left -command {set cancel 1; catch {snd stop; s stop}; set returnValue 1; destroy .optbox; .mbar.lbAnim configure -image imAnim} -font $sysFont(3)
			button $w.buttons.bthome -text "Home" -image imHomePNG -compound left -command {set cancel 1; catch {snd stop; s stop}; set returnValue 0; set urltext "inquisitor.sourceforge.net"; destroy .optbox; .mbar.lbAnim configure -image imAnim; goEnter} -font $sysFont(3)
                        label $w.buttons.frTHX -relief ridge
                        label $w.buttons.frTHX.lbScrews1 -image imScrew -relief groove
			button $w.buttons.frTHX.btTHX -text $msgText(okcancel.thanx.1) -font $sysFont(3) -command {
                                destroy .optbox.frtext.lbtext
                                label .optbox.frtext.lbtext -relief groove -background DarkBlue -foreground white -font $sysFont(7) -text "\n$msgText(okcancel.thanx.3)\nJan Nijtmans (Img),\nJoe English (Tile),\nKare Sjolander (snack),\nSteffen Traeger (FTP),\nMatt Newman (TLS),\n D. Richard Hipp (TkHTML), \nMichael Kraus (mkZipLib),\nUnifix (bWidgets)\n\nFrenzy"
                                pack .optbox.frtext.lbtext -side top -padx 2 -pady 2
                        }
                        button $w.buttons.frTHX.lbTHX -text "Beyond" -font $sysFont(3) -command {
                                destroy .optbox.frtext.lbtext
                                set datei [string trimright $homeDir /]/SYSTEM/JayT_Beyond.mp3
                                if {[file exists $datei] && $playSounds==1} {
                                    label .optbox.frtext.lbtext -relief ridge -background DarkBlue -foreground white -font $sysFont(7) -text "\n\nNow playing:\n\n\"Beyond\"\n\nfrom the Album: Beyond Infinity\n\nWritten and (C) 2001\nby: Jay T. (Jens Timmermann)\n\n\n Music is reduced in size and quality \n\n"
                                } else {
                                    label .optbox.frtext.lbtext -relief ridge -background DarkBlue -foreground white -font $sysFont(7) -text "\n\nTurn on 'Play Sounds' to hear:\n\n\"Beyond\"\n\nfrom the Album: Beyond Infinity\n\nWritten and (C) 2001\nby: Jay T. (Jens Timmermann)\n\n\n Music is reduced in size and quality \n\n"
                                }
                                pack .optbox.frtext.lbtext -side top -padx 2 -pady 2
                        }

                        label $w.buttons.frTHX.lbScrews2 -image imScrew -relief groove
                        pack $w.buttons.frTHX.lbScrews1 $w.buttons.frTHX.btTHX $w.buttons.frTHX.lbTHX $w.buttons.frTHX.lbScrews2 -in $w.buttons.frTHX -side left -expand true -pady 4

			pack $w.buttons.btok -in $w.buttons -side left -padx 2 -pady 1
			pack $w.buttons.frTHX -in $w.buttons -side left -expand true -fill x -padx 2 -pady 2 -anchor n
			pack $w.buttons.bthome -in $w.buttons -side right -padx 2 -pady 1
                        set datei [string trimright $homeDir /]/SYSTEM/JayT_Beyond.mp3
				if {[file exists $datei] && $playSounds==1} {
                                catch {stop_anigif .mbar.lbAnim}
                                .mbar.lbAnim configure -image imTuxmeter
                        		catch {snd stop; s stop; s record}
                        		after $GIFdelay tuxOmeter
                                snd config -file $datei -skip 0
                       			snd play -start 0 -block 1 -command {set cancel 1; catch {snd stop; s stop; .mbar.lbAnim configure -image imAnim}} -blocking false
                                }
		}
		yesno {
			button $w.buttons.btyes -text $msgText(yesno.1) -image imOKbutton -compound left -command {set returnValue yes; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btno -text $msgText(yesno.2) -image imEscape -compound left -command {set returnValue no; destroy .optbox} -font $sysFont(0)
			pack $w.buttons.btyes -in $w.buttons -side left -padx 2 -pady 1
			pack $w.buttons.btno -in $w.buttons -side right -padx 2 -pady 1
		}
		yesnocancel {
			button $w.buttons.btyes -text $msgText(yesno.1) -image imOKbutton -compound left -command {set returnValue yes; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btno -text $msgText(yesno.2) -image imEscape -compound left -command {set returnValue no; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btcancel -text $msgText(okcancel.2) -image imCancel -compound left -command {set returnValue 0; destroy .optbox} -font $sysFont(0)
			pack $w.buttons.btyes $w.buttons.btno -in $w.buttons -side left -padx 2 -pady 1
			pack $w.buttons.btcancel -in $w.buttons -side right -padx 2 -pady 1
		}
		abortretryignore {
			button $w.buttons.btabort -text $msgText(abortretry.1) -image imEscape -compound left -command {set returnValue abort; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btretry -text $msgText(abortretry.2) -image imRetry -compound left -command {set returnValue retry; destroy .optbox} -font $sysFont(0)
			button $w.buttons.btignore -text $msgText(abortretry.3) -image imCancel -compound left -command {set returnValue ignore; destroy .optbox} -font $sysFont(0)
			pack $w.buttons.btabort $w.buttons.btretry -in $w.buttons -side left -padx 2 -pady 1
			pack $w.buttons.btignore -in $w.buttons -side right -padx 2 -pady 1
		}

	}
	#Warte solange bis Window geschlossen wurde
	tkwait window $w
	return $returnValue
}

proc getPasswd {} {
	global sysFont backColor fgColor user pwd msgText selected token winSYS
	.mbar.lbAnim configure -image imTuxForbidden
	setLED magenta
	dispMSG $msgText(auth.req.0)
	set merkBG [.imHTTPS cget -background]
	.imHTTPS configure -image imLock -background orange -foreground $merkBG
	set user ""
	set pwd ""
	set w .pwdbox
	toplevel $w
	wm title $w $msgText(auth.req.1)
	wm iconname $w $msgText(auth.req.1)
	wm protocol $w WM_DELETE_WINDOW {set user ""; set pwd ""; destroy .pwdbox}
	wm geometry $w +300+300
#	wm resizable $w false false
	label $w.lbMessage -text \n$msgText(auth.req.2) -relief groove -font $sysFont(7) -image imSysadmin -compound left
	frame $w.frUser
	label $w.frUser.lbUser -text $msgText(auth.req.3) -relief flat -font $sysFont(3) -image imIdentity -compound left
	entry $w.frUser.etUser -relief sunken -insertbackground black -textvariable user -background $backColor -foreground $fgColor
	pack $w.frUser.lbUser -in $w.frUser -side left -padx 2 -pady 2
	pack $w.frUser.etUser -in $w.frUser -side right -padx 2 -pady 2 -fill x -expand true

	frame $w.frPwd
	label $w.frPwd.lbPwd -text $msgText(auth.req.4) -relief flat -font $sysFont(3) -image imPassword -compound left
	entry $w.frPwd.etPwd -show "*" -relief sunken -insertbackground black -textvariable pwd -background $backColor -foreground $fgColor
	pack $w.frPwd.lbPwd -in $w.frPwd -side left -padx 2 -pady 2
	pack $w.frPwd.etPwd -in $w.frPwd -side right -padx 2 -pady 2 -fill x -expand true
	bind $w.frPwd.etPwd <Return> {set user [.pwdbox.frUser.etUser get]; set pwd [.pwdbox.frPwd.etPwd get]; destroy .pwdbox}

	frame $w.frButton
	button $w.frButton.btOk -text OK -image imOKbutton -compound left -command {set user [.pwdbox.frUser.etUser get]; set pwd [.pwdbox.frPwd.etPwd get]; destroy .pwdbox} -font $sysFont(0)
	button $w.frButton.btCancel -text Cancel -image imCancel -compound left -font $sysFont(0) -command {
		set user ""
		set pwd ""
		if {[llength $selected]>0} {Stop $token}
		destroy .pwdbox
		.imHTTPS configure -image imUnLock -background [.imHTTPS cget -foreground]
	}
	pack $w.frButton.btOk -in $w.frButton -padx 2 -pady 2 -side left
	pack $w.frButton.btCancel -in $w.frButton -padx 2 -pady 2 -side right
	pack $w.lbMessage -in $w  -in $w -side top -expand true -fill x -padx 4 -pady 4
	pack $w.frUser $w.frPwd $w.frButton -in $w -side top -expand true -fill x

	tkwait window $w
	set user [::base64::encode "$user:$pwd"]
	.mbar.lbAnim configure -image imAnim
	return "$user"
}

#TEST051205: shrinkMenuBar (activate bind in MenuScrews !)
proc shrinkMBar {} {
	global menuSize sysFont mainButtons
	if {$menuSize==0} {
	#Menu verkleinern
		set menuSize 1
#		set mainButtons 16
		set mainButtons 12
		#ClickScrews
		set smenu {.mbar.imScrew .mbar.imScrew2}
		foreach inhalt $smenu {$inhalt configure -image imScrew -cursor sb_down_arrow}
#foreach inhalt $smenu {pack forget $inhalt}
		#MenuButtons
		set smenu {.mbar.file .mbar.edit .mbar.tools .mbar.options .mbar.help}
#		foreach inhalt $smenu {$inhalt configure -borderwidth 1 -font $sysFont(5)}
		foreach inhalt $smenu {$inhalt configure -borderwidth 1 -font "Monospace 5"}
#foreach inhalt $smenu {pack forget $inhalt}
		#Buttons
		set smenu {.mbar.clrScreen .mbar.home .mbar.reload .mbar.back .mbar.forw .mbar.stop .mbar.zoomin .mbar.zoomout .mbar.zoom .mbar.lbAnim}
		set pict {imClrScreen imHome imReloadPNG imBackPNG imForwPNG imStopPNG imZoomInPNG imZoomOutPNG imZoomPNG imAnim}
		foreach inhalt $smenu img $pict {$inhalt configure -width $mainButtons -height $mainButtons -image ${img}16}
#foreach inhalt $smenu {pack forget $inhalt}

		pack forget .mbar.lbLED .mbar.prgFile .mbar.lbText .mbar.lbStatus
		pack .mbar.lbLED .mbar.prgFile .mbar.lbStatus -in .mbar -side left -fill x -padx 1
#.mbar configure -height 1
	} else {
		set menuSize 0
		set mainButtons 23
		#ClickScrews
		set smenu {.mbar.imScrew .mbar.imScrew2}
		foreach inhalt $smenu {$inhalt configure -image imScrews -cursor sb_up_arrow}
		#MenuButtons
		set smenu {.mbar.file .mbar.edit .mbar.tools .mbar.options .mbar.help}
		foreach inhalt $smenu {$inhalt configure -borderwidth 2 -font $sysFont(0)}
		#Buttons
		set smenu {.mbar.clrScreen .mbar.home .mbar.reload .mbar.back .mbar.forw .mbar.stop .mbar.zoomin .mbar.zoomout .mbar.zoom .mbar.lbAnim}
		set pict {imClrScreen imHome imReloadPNG imBackPNG imForwPNG imStopPNG imZoomInPNG imZoomOutPNG imZoomPNG imAnim}
		set mainButtons 16
		foreach inhalt $smenu img $pict {
			$inhalt configure -width $mainButtons -height $mainButtons -image ${img}
		}
		pack forget .mbar.lbLED .mbar.prgFile .mbar.lbText .mbar.lbStatus
		pack .mbar.prgFile -in .mbar -side bottom -padx 2 -pady 3 -fill x -expand true
		pack .mbar.lbLED -in .mbar -side left -padx 3 -pady 1
		pack .mbar.lbText .mbar.lbStatus -in .mbar -side left -fill x -padx 1
	}
}

#WriteDOM writes url2file translationTable on HD
proc writeDOM {url} {
return
	global translateFiles homeDir remSTR cacheLocation
	set url [regSTR $remSTR $url]
	set chart [getCachedir $url]
	set cachedir [string trimright $cacheLocation /]/cache/domDB/$chart
	if {![file isdirectory $cachedir]} {file mkdir $cachedir}
	set url [acode encode $url]
	set filename [string trim $cachedir]/[string trim $url].FQM
	if {[llength $translateFiles]<=0} return
	writeFile $filename $translateFiles
}

proc mouseMover {} {
	global HTMLwin movement moved followLonks
	#NEW110207: MouseMover like Acrobat
	bind $HTMLwin(local).x <ButtonPress-2> {
		if {[string trim [$HTMLwin(local).x href %x %y]]==""} {
				set movement(local) "$HTMLwin(local).x %x %y"
				set moved 0
			 	. configure -cursor fleur
		} else {
			 	 cLink %x %y $HTMLwin(local)
				 selectALL $followLinks
				 downloadStart
		}
	}

	bind $HTMLwin(local).x <ButtonRelease-2>	{
		 set movement(local) ""
		 set moved 0
		 . configure -cursor {}
	}

	bind $HTMLwin(local).x <Motion>	{
	 	  if {[llength $movement(local)]>0} {
	       	  set stepX [expr [lindex $movement(local) 1] - %x]
	       	  set stepY [expr [lindex $movement(local) 2] - %y]
			  if {$moved>1} {
			  	set moved 0
			  	set movement(local) "$HTMLwin(local).x %x %y"
				if {$stepX<0} {
			           [lindex $movement(local) 0] xview scroll -1 units
	#		           set scroll "$HTMLwin(local).vscrollx"
	#		           $scroll set [$scroll fraction %x %y]
	   			} else {
			           [lindex $movement(local) 0] xview scroll 1 units
				}
				if {$stepY<0} {
			           [lindex $movement(local) 0] yview scroll -1 units
	   			} else {
			           [lindex $movement(local) 0] yview scroll 1 units
				}
			} else {
			  incr moved
			}
	 	  }
	}

	#Move REMOTE HTMLwin
	bind $HTMLwin(remote).x <ButtonPress-2> {
		if {[string trim [$HTMLwin(remote).x href %x %y]]==""} {
			     set movement(remote) "$HTMLwin(remote).x %x %y"
			     set moved 0
			     . configure -cursor fleur
		} else {
			 	 cLink %x %y $HTMLwin(remote)
				 selectALL $followLinks
				 downloadStart
		}
	}

	bind $HTMLwin(remote).x <ButtonRelease-2>	{
		 set movement(remote) ""
		 set moved 0
		 . configure -cursor {}
	}

	bind $HTMLwin(remote).x <Motion>	{
	 	  if {[llength $movement(remote)]>0} {
	       	  set stepX [expr [lindex $movement(remote) 1] - %x]
	       	  set stepY [expr [lindex $movement(remote) 2] - %y]
			  if {$moved>1} {
			  	set moved 0
			  	set movement(remote) "$HTMLwin(remote).x %x %y"
				if {$stepX<0} {
			           [lindex $movement(remote) 0] xview scroll -1 units
	   			} else {
			           [lindex $movement(remote) 0] xview scroll 1 units
				}

				if {$stepY<0} {
			           [lindex $movement(remote) 0] yview scroll -1 units
	   			} else {
			           [lindex $movement(remote) 0] yview scroll 1 units
				}
			 } else {
			   incr moved
			 }
	 	  }
	}
}
