package provide FIQHTP 1.0
#FIQHTP
#HTTP Functions 4 Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

#Clear the HTMLscreen (called before loading a new Site)
proc Clear {} {
	global cleanHTML baseurl activeHTM mainHTML Images selected buffer anzGFX liste backColor fgColor HTMLreferer refererBACK colorSet getCSS getBG \
	globalCount jFunction jCommand HTMLpwd shiftPress imFavIcon applet video sound picture QTcount style reqURL bgImage vSize styleParsed showDecode \
	maxcount toknHandles metaREDIR
		if {[winfo exists $mainHTML.pdf]} {destroy $mainHTML.pdf}
		if {[winfo exists $mainHTML.flash]} {destroy $mainHTML.flash}
		if {[winfo exists $mainHTML.video]} {destroy $mainHTML.video}
		if {[winfo exists $mainHTML.movie]} {destroy $mainHTML.movie}
		if {[winfo exists $mainHTML.sound]} {destroy $mainHTML.sound}
		if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
		if {[winfo exists $mainHTML.frame]} {destroy $mainHTML.frame}
	if {$cleanHTML == 0} {
		catch {$mainHTML clear}
	} else {
		#New ClearRoutine (destroy each HTMLwidget; cause "HTML clear" brings down a Windows System with a Memory error too often)
		if {[lindex [split $mainHTML {\.}] end] == "local"} {
			destroy .tile.top.html.tile.html.pane.left.hold
			frame .tile.top.html.tile.html.pane.left.hold
			createHTML tile.top.html.tile.html.pane.left.hold local 1 2
			pack .tile.top.html.tile.html.pane.left.hold -in .tile.top.html.tile.html.pane.left -side left -fill both -expand true
		} else {
			destroy .tile.top.html.tile.html.pane.rght.hold
			frame .tile.top.html.tile.html.pane.rght.hold
			createHTML tile.top.html.tile.html.pane.rght.hold remote 1 2
			pack .tile.top.html.tile.html.pane.rght.hold -in .tile.top.html.tile.html.pane.rght -side right -fill both -expand true
		}
		#NEW010907: Bind MouseMove to middle-Button2
		mouseMover
#		$mainHTML config -base $baseurl($activeHTM)
#		$mainHTML config -base ""
	}
#NEW261206:
	if {[llength $toknHandles]>0} {
		foreach inhalt $toknHandles {
			catch {http::reset $inhalt}
			catch {http::cleanup $inhalt}
		}
	}
	set toknHandles ""
	set metaREDIR ""
#NEWend
	set selected ""
	set buffer ""
	set HTMLreferer ""
	set HTMLpwd ""
	set refererBACK ""
	set baseurl($activeHTM) ""
	set applet ""
	set video ""
	set sound ""
	set picture ""
	set vSize($activeHTM) "0x0"
	set reqURL ""
	set bgImage ""
	set colorSet 0
	set showDecode 0
	set maxcount 0
	set globalCount 0
	set anzGFX 0
	set getCSS 0
	set getBG 0
	set shiftPress 0
	set styleParsed 0
	foreach inhalt [array names liste $activeHTM,*] {
		catch {unset liste($inhalt)}
	}
	foreach inhalt [array names Images $activeHTM,*] {
                catch {image delete $Images($inhalt)}
		catch {unset Images($inhalt)}
	}
	catch {unset jFunction jCommand style}
	set imFavIcon imClrURL
	.head.dispUrl.btClrUrl configure -relief raised -image imClrURL -background $backColor
    .f9.lbShowURL configure -relief ridge -foreground $fgColor -background $backColor
	.imHTTPS configure -image imUnLock -relief sunken -background $backColor
	focus .head.dispUrl.url.e
    update
}

#Load (downloaded) HTML-Page/Image into HTMLwidget
proc LoadFile {datei} {
	if {[string length $datei]<=0} return
	global FTPdir FTPrender dispSRC activeHTM debug TableIDX ImageIDX backColor MapMode mainHTML htmldisplay imFavIcon HTMLwin otherWarn gamma \
           HTMLuseragent HTMLAccept waitID renderIMG active baseurl LastFile cancel translateFiles styleParsed htmlDIR stream fTypes linktext \
	       urltext selected zlrGFX anzGFX zoomText merkName merkValue token playSounds playAnim HTMLsplit remSTR etryBack fgColor useVideo destDir \
	       HTMLsync getFavIcon winSYS onceSounds linkmark htmlBG newPage msgText remSTR bytesTotal buffer iFrames cacheLocation useApplet metaREDIR \
	       htmlFG version homeDir ignoreReDir
	if {$debug>0} {puts "LoadFile bekommt: $datei"}
	#NEW111106: Disallow dangerous FileTypes
    if {[chkKidz $datei]==1} {setLED magenta; .mbar.lbAnim configure -image imStopTux; return}
#NEW180207: checkAbout
	if {[regexp -nocase {about:[a-zA-Z0-9]+$} $datei]} {
	    switch -regexp $datei {
			about:blank$ {clearPage; set urltext "about:blank"; return}
			about:credits$ {HELPabout; return}
		    about:buildconfig$ {
		    	clearPage
		    	set urltext "about:buildconfig"
				$mainHTML parse "<BODY bgcolor=$htmlBG color=$htmlFG><h1><b>$version</b></h1><br>$HTMLuseragent<br>\n<br>\n<b>(C) 2007 by: Frenzy Softworks<br>Written by: Jens Timmermann</b><br></BODY>"
				return
			}
		    about:license$ {
			   set dummy [string trimright $homeDir /]/License.TXT
			   clearPage
		       set urltext "FILE://$dummy"
			   set htmldisplay [openFile $dummy]
		       $mainHTML parse "<BODY bgcolor=\"$htmlBG\"><plaintext>$htmldisplay<plaintext\>"
		       return
		    }
		    about:about {
		    	clearPage
		    	set urltext "about:about"
				$mainHTML parse "<BODY bgcolor=\"$htmlBG\"><plaintext>ABOUT: about, blank, credits, buildconfig, license, config/plugins<plaintext\>"
				return
		    }
		    default {clearPage; statistics; return}
		}
	}
	set merkName ""
	set buffer ""
	set htmlDIR 0
	set TableIDX($activeHTM) ""
	set ImageIDX($activeHTM) ""
	set merkValue 0
	set dispSRC 0
	set bytesTotal 0
	set styleParsed 0
	set datei [freezeURL $datei]
	if {![regexp -nocase {^/|^[a-zA-Z]:|^FILE:/} $datei]} {
        	if {$MapMode==4 && ![regexp -nocase {ftp://} $datei]} {
        		if {$FTPrender>0} {
        			set win [chkFTPactive]
        			if {![regexp -nocase {\.} [lindex [split $datei /] end]]} {
        				setActive $win
        				useFTP $win $datei
        				return
        			}
        		} else {
        			set datei "FTP://[string trimleft $datei /]"
        		}
        	}
        	if {[regexp -nocase "FTP://" $datei]} {
        		regsub -nocase -all {ftp://} $datei {FTP://} datei
        		set urltext [upperHTTP $datei]
        		useFTP remote $datei
        		return
        	}
        }
	if {[regexp -nocase "mailto:" $datei]} {
		regsub -nocase -all {mailto:} $datei {} datei
		set urltext "MAILTO://[string trimleft $datei /]"
		return
	}
#puts "Datei3: $datei"
	catch {stop_anigif .mbar.lbAnim} err
        set merkBase $datei
        setBase $datei
	setLED cyan
	set datei [reslvURL $datei 1]
	#NEW111106: check for dangerous Domains
	if {[string length $datei]>5} {
		if {[regexp -nocase $fTypes(Danger) $datei] && [regexp -nocase $fTypes(DDOM) $datei]} {
		      .mbar.lbAnim configure -image imTuxForbidden
		      .head.dispUrl.url configure -foreground black -entrybg red
		      dispMSG $msgText(fiq.blocked.1)
		      if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
		      label $mainHTML.info -image imWarning -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
   		      $mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(fiq.blocked.1)\n"
		      setLED red
		      if {$otherWarn>0} {optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $msgText(fiq.blocked.2)}
		      return
		} elseif {[regexp -nocase $fTypes(DDOM) $datei]} {
		      .head.dispUrl.url configure -foreground black -entrybg orange
		} elseif {[regexp -nocase $fTypes(Danger) $datei]} {
		      .mbar.lbAnim configure -image imTuxForbidden
		      .head.dispUrl.url configure -foreground black -entrybg yellow
	      	      dispMSG $msgText(fiq.blocked.1)
                      if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
		      label $mainHTML.info -image imWarning -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
		      $mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(fiq.blocked.1)\n"
	      	      setLED red
	      	      if {$otherWarn>0} {optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $msgText(fiq.blocked.2)}
		      return
		} else {
	              .head.dispUrl.url configure -foreground $fgColor -entrybg $etryBack
		}
	} else {
               .head.dispUrl.url configure -foreground $fgColor -entrybg $etryBack
	}
	wm title . "Inquisitor ..."
	wm iconname . "FIQ ..."
	ProgressBar 0 0
	set merk $datei
	set lfile [regSTR $remSTR $datei]
	set favicon $lfile
	if {$getFavIcon>0 && ![regexp -nocase -all {/} $favicon] && ![regexp -nocase -all {\.} $favicon]} {
		catch {stop_anigif .mbar.lbAnim}
		exitLoadFile $merkBase
		return
	}
	set favicon [lindex [split [acode decode $favicon] /] 0]/favicon.ico
	set zlrGFX 0
	set urltext [upperHTTP [acode decode $datei]]
	set LastFile($activeHTM) $datei
	set active 1
	set linktext "$msgText(request.send.6): $urltext"
	catch {show_anigif [list -data [getAnim penguinR22]] .mbar.lbAnim} err
#	MouseCurs 1
	update
	#NEW051106: Streaming Movies (only on Windooze with QuickTime)
	set ext [transType .[string trim [getEXT $datei] .]]
	if {$stream>0} {
	   	if {$useVideo>0 && [chkANI $ext]} {
	   	    	playMOV $datei
		    	catch {stop_anigif .mbar.lbAnim}
				Buttons 1
				exitLoadFile $merkBase
				return
	    } elseif {[chkTXT $ext] && [regexp -nocase {pdf|ps} $ext]} {
		        if {$winSYS>0} {
				   	set w $HTMLwin($activeHTM)
					if {[winfo exists $w.pdf]} {destroy $w.pdf}
					set pdf [optcl::new -window $w.pdf $datei]
					#.pdf config -width 500 -height 300
					catch {pack $w.pdf -fill both -expand 1}
					Buttons 1
	   				exitLoadFile $merkBase
					return
				}
		} elseif {$useApplet>0 && [chkAPP $ext]} {
			  	if {$winSYS>0} {
					set w $HTMLwin($activeHTM).video
					if {[winfo exists $w]} {destroy $w}
					frame $w -relief sunken -borderwidth 2
                    pack $w -expand 1
					set swf [createAPP $w.video $ext]
					if {![regexp -nocase {UNK:0} $swf]} {
						pack $w.video -in $w -expand 1
						playAPP $datei $w.video 0 $swf ""
						Buttons 1
						exitLoadFile $merkBase
						return
					}
				}
			}
	}
 	set fakefile [getFileURL $datei 0]
# 	set linktext [regSTR $remSTR $urltext]
	if {[string length $fakefile]<=0} {
           catch {stop_anigif .mbar.lbAnim}
           exitLoadFile $merkBase
           return
        }
	if {![file exists $fakefile]} {
		setLED red
		MouseCurs 0
		onError "7 LoadFile: File: $fakefile does not exist !"
		return
	} else {
		#File ist im Cache
		set fsize [file size $fakefile]
		if {$fsize<=0} {
		#File hat aber Lnge von 0 Bytes
			#file delete -force $cachedir/$gfx
			setLED orange
			MouseCurs 0
			onError "8 LoadFile: $fakefile size: $fsize bytes !"
			return
		}
	}
#	set htmldisplay [ReadFile $fakefile]
#puts "HTM: $htmldisplay"
#NEW180206: set Lockfile so other FIQ wouldn't clear this cache (LockFile will removed when ready)
set lockfile [string trimright [file dirname $fakefile] /]/FIQ.LOCK
if {![file exists $lockfile]} {
	writeFile $lockfile "FIQ LockFile"
}

#puts "Read: $fakefile"
	set ext [transType .[string trim [getEXT $fakefile] .]]
	set urlext [transType .[string trim [getEXT $urltext] .]]
	if {[string length $ext]<=1} {set ext $datei}
#puts "Ext: $ext $urlext"
	set linkmark 1
	set anzGFX 1
	set zlrGFX 0
#	Clear
	set check [chkEXT $ext]
#puts "CHK: $check:$ext"

	# Anderenfalls (z.B. ".JPG", ".WAV", o..)
	# NUR zum Anzeigen, wenn auf GFX-Link geklickt wird (BigGFX)
#		if {[chkIMG $ext] || [regexp -nocase {pdf|ps} $ext]} {}
	if {[chkIMG $ext]} {
			#Change URL if Filetype is another than requested
#puts "Oder da."
			if {![regexp -nocase $ext$ $urlext] && ![regexp -nocase $urlext $ext]} {set urltext [upperHTTP [cutEXT $urltext]$ext]}
			if {$zoomText} {
				Buttons 0
			} else {
				Buttons 1
			}
			if {[string length $datei]>0} {
#puts "Datei: $datei"
#				set htmldisplay "<BODY bgcolor=\"$htmlBG\"><a href=\"$datei\">$urltext</a><br><img src=\"$datei\"/>"
				set htmldisplay "<BODY bgcolor=\"$htmlBG\"><img src=\"$datei\"/>"
				Clear
#NEW170207: Load Image directly into Label instead of HTMLwidget (much, MUCH faster)
#NO Zoom and Scroll possible !
#                        image create photo dummyIMG -file $fakefile
#                        catch "image create photo -file $datei" dummyIMG
#			if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
#			label $mainHTML.info -image dummyIMG -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw

				if {[catch {$mainHTML parse $htmldisplay} err]} {
					MouseCurs 0
					setLED orange
					if {[file exists $lockfile]} {file delete -force $lockfile}
					onError $err "LoadFile: GFX_Parse $datei Error: $err"
					return
				}
				#Used 4 Zooming if ImageFile is loaded directly into HTMLwin
				createImgLinks $htmldisplay
				#favicon setzen bei ENDE von GrabPIC (globale Variable) und erst dann holen !
				set favicon irgendwasunmgliches
			} else {
				dispMSG "Error: No Image File !"
				setLED red
			}
	} elseif {$playSounds>0 && [chkSND $ext]} {
				catch {snd stop}
				#ConfigureSnackSound
				snd config -file $datei -skip 0
				if {$onceSounds==1} {
					snd play -start 0 -block 1 -command {catch {snd stop}} -blocking false
					# -command {after 1000 exit}
				} else {
					snd play -start 0 -block 0 -command {catch {snd stop}} -blocking false
					#s play -block 0 -command {after 1000 exit}
				}
	} elseif {$useVideo>0 && [chkANI $ext]} {
			#Animation/Movie
			        if {$winSYS==1} {
                                	playMOV $fakefile
                        	} else {
                                	playLNX $datei
				}
					Buttons 1
	} elseif {[chkTXT $ext] && [regexp -nocase {pdf|ps} $ext]} {
		        if {$winSYS>0} {
			   	set w $HTMLwin($activeHTM)
				if {[winfo exists $w.pdf]} {destroy $w.pdf}
				set pdf [optcl::new -window $w.pdf $fakefile]
				#.pdf config -width 500 -height 300
				catch {pack $w.pdf -fill both -expand 1}
			}
	} elseif {$useApplet>0 && [chkAPP $ext]} {
		  	if {$winSYS>0} {
				set w $HTMLwin($activeHTM).video
				if {[winfo exists $w]} {destroy $w}
				frame $w -relief sunken -borderwidth 2
				pack $w -expand 1
				set swf [createAPP $w.video $ext]
				if {![regexp -nocase {UNK:0} $swf]} {
					pack $w.video -in $w -expand 1
					playAPP $fakefile $w.video 0 $swf ""
					Buttons 1
				}
			}
	} elseif {$check>0 || ([chkTXT $ext] && ![regexp -nocase {pdf|ps} $ext])} {
		#Change URL if Filetype is another than requested
		if {$check>0 && [chkIMG $urlext]} {
#puts "Bin Hier."
			#if {![regexp -nocase $ext$ $urlext]} {set urltext [upperHTTP [string trim $urltext.$ext]]}
			if {![regexp -nocase $ext$ $urlext] && ![regexp -nocase $urlext $ext]} {set urltext [upperHTTP [cutEXT $urltext]$ext]}
		}
		setLED cyan
		wm title . "Inquisitor .."
		wm iconname . "FIQ .."
		dispMSG $msgText(parsing.html)
		set htmldisplay [ReadFile $fakefile]
		set HTMLsplit [splitHTM $htmldisplay]
#puts "HTM splitted"
#AddSelected "HTM splitted" 0
		if {[string length $htmldisplay]<=0} {
			dispMSG "File empty !"
			setLED orange
			if {[file exists $lockfile]} {file delete -force $lockfile}
			catch {stop_anigif .mbar.lbAnim}
                        exitLoadFile $merkBase
			return
		}
		set htmldisplay [preParse $HTMLsplit]
		ProgressBar 20 100
#puts "HTM preParsed"
#AddSelected "HTM preParsed" 0
		set HTMLsplit $htmldisplay
		if {$cancel==1} {
			setLED red
			if {[file exists $lockfile]} {file delete -force $lockfile}
           	catch {stop_anigif .mbar.lbAnim}
			exitLoadFile $merkBase
			return
		}
		dispMSG $msgText(preparsed.html)
		set htmldisplay [encode $htmldisplay]
		ProgressBar 40 100
		if {[chkKidz $htmldisplay]==1} {
			setLED magenta
			.mbar.lbAnim configure -image imStopTux
			if {[file exists $lockfile]} {file delete -force $lockfile}
			MouseCurs 0
			return
#			exitLoadFile $merkBase
#			return
		}
		if {[string length $htmldisplay]>0} {
			setLED green
		    if {[chkTXT $ext]} {set htmldisplay "<BODY bgcolor=\"$htmlBG\"><plaintext>$htmldisplay<plaintext\>"}
#puts "htmlDisplay: $htmldisplay"
			dispMSG $msgText(render.html)
			if {[catch {$mainHTML parse $htmldisplay} err]} {
				MouseCurs 0
				setLED red
				if {[file exists $lockfile]} {file delete -force $lockfile}
				onError "$err LoadFile: HTML_Parse Error: $err"
				return
			}
			ProgressBar 60 100
#puts "HTM parsed: $err"
#AddSelected "HTM Parsed" 0
			if {$debug>7} {puts "HTMLdisplay: $htmldisplay"}
			setLED cyan
			wm title . "Inquisitor ."
			wm iconname . "FIQ ."
			dispMSG $msgText(creating.html)
#			update idletasks
			catch {createImgLinks $htmldisplay}
			ProgressBar 80 100
#puts "HTM images"
#AddSelected "HTM images" 0
			setLED cyan
			dispMSG $msgText(workspace.html)
#			update idletasks
			setTokens
			ProgressBar 100 100
		} else {
			dispMSG "Error: No File !"
			setLED red
		}
	} elseif {[regexp -nocase $ext $fTypes(All_Files)]} {
#Copy ANY other FileTypes to destination
      	  catch {file copy -force $fakefile [string trimright $destDir /]/}
      	  dispMSG $msgText(file.copied)
	}
	set datei [regSTR $remSTR $favicon 0]
	set chart [getCachedir $datei]
	set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
	if {![file isdirectory $cachedir]} {file mkdir $cachedir}
	set gfx [acode encode $datei]
	if {$renderIMG>0} {
		#get FavIcon BEFORE Images
		if {$getFavIcon==1 && ![regexp -nocase {irgendwasunmgliches} $favicon] && ![regexp -nocase {file://} $merk]} {
			if {![file exists $cachedir/$gfx]} {
				if {$HTMLsync<=0} {
					set dummy [getFileURL $favicon 0]
				} else {
					syncURL $favicon $cachedir/$gfx
					##getSyncURL $favicon
				}
			}
		}
		if {$HTMLsync<=0} {
			grabPIC irgendwas 1
		} else {
			grabSYNC
		}
		#get FavIcon AFTER Images
		if {$getFavIcon==2 && ![regexp -nocase {irgendwasunmgliches} $favicon] && ![regexp -nocase {file://} $merk]} {
			if {![file exists $cachedir/$gfx]} {
				if {$HTMLsync<=0} {
					set dummy [getFileURL $favicon 0]
				} else {
					syncURL $favicon $cachedir/$gfx
					##getSyncURL $favicon
				}
			}
		}
	}
	if {[file exists $lockfile]} {file delete -force $lockfile}
	#NEW010706: shwo FavIcon if exists
	if {$getFavIcon>=0} {
#		if {[regexp -nocase {favicon.ico} $cachedir/$gfx] && [file exists $cachedir/$gfx] && [file size $cachedir/$gfx]>0 && [regexp -nocase {.ico$} [chkType file $cachedir/$gfx]]} {}
		if {[regexp -nocase {favicon.ico} $cachedir/$gfx] && [file exists $cachedir/$gfx] && [file size $cachedir/$gfx]>1024} {
#puts "FavIcon: $cachedir/$gfx"
#image create photo -file $cachedir/$gfx
#32bits ICO file not supported !
			if {[catch {image create photo -file $cachedir/$gfx} dummyGFX]==0} {
				catch {image create photo -width 16 -height 16} imFavIcon
				catch {image width $dummyGFX} wide
				catch {image height $dummyGFX} high
					if {$wide>16 || $high>16} {
#puts "FavIcon16: $cachedir/$gfx"
						set imFavIcon [resizeIMG $dummyGFX 16 16]
					} else {
#puts "FavIcon: $cachedir/$gfx"
						catch {$imFavIcon copy $dummyGFX}
					}
				catch {image delete $dummyGFX}
				catch {unset dummyGFX}
			} else {
				set imFavIcon imClrURL
			}
			if {[string length $imFavIcon]>2 && [info exists imFavIcon]} {
				if {[catch {.head.dispUrl.btClrUrl configure -relief groove -image $imFavIcon -height 16 -width 16 -background white}]} {
					set imFavIcon imClrURL
					.head.dispUrl.btClrUrl configure -relief raised -image imClrURL -background $backColor
				}
			}
		}
	}
	if {[llength $metaREDIR]>0 && $ignoreReDir<=0} {
	   if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
	   label $mainHTML.info -image imTempFile -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
	   $mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.send.7)\n"
	   set wait [lindex $metaREDIR 0]
	   set url [lindex $metaREDIR 1]
	   set chkurl [regSTR $remSTR $url]
           set metaREDIR ""
#puts "URL: $url, $chkurl, $lfile"
#	   if {$url!="" && ![regexp -nocase $chkurl $lfile] && ![regexp -nocase $lfile $chkurl]} {}
   	   if {$url!="" && ![regexp -nocase $chkurl $lfile]} {
		   if {$wait>0} {
			   	after [expr $wait * 60] [subst "clearPage; LoadFile $url"]
		   } else {
				#Wait allways for min. 3 seconds
			   	after [expr 180] [subst "clearPage; LoadFile $url"]
	       }
		   return
	   }
	}
#NEW not in SYNCmode: in this case exitLoadFile ist called from grabSync
	if {$HTMLsync<=0} {
		exitLoadFile $merkBase
	}
	if {$debug>0} {puts "LoadFile returns: $fakefile"}
}

#NEW060805: ReadTokenIDs and Links into a List
proc setTokens {} {
	global mainHTML tokenlist activeHTM remSTR cancel msgText winSYS
	set tokenlist($activeHTM) ""
return
	set htmlist [$mainHTML token find a]
	if {$winSYS == 0} {
            set end [lindex [split [join [$mainHTML token list end]] { }] 0]
        } else {
            set end [lindex [lindex [$mainHTML token list 1.0 end] end] 0]
        }
	setLED cyan
	set merk ""
	set max [llength $htmlist]
	set z 0
	foreach dummy $htmlist {
		if {$cancel==1} {
			dispMSG $msgText(abbruch)
			setLED yellow
			break
		}
		ProgressFile $z $max
		incr z
		if {![regexp -nocase {mailto:} $dummy]} {
			#lindex 0 = TokenID des Links
			set idx [lindex $dummy 0]
			#Suche den darauffolgenden HTML-"Text" (also den, der farbig markiert werden soll)
			set true 0
			while {$true == 0} {
				if {$cancel==1} {
					dispMSG $msgText(abbruch)
					setLED yellow
					set true 1
					break
				}
				if {$winSYS == 0} {
                                    set such [join [$mainHTML token list $idx.0 $idx.end]]
                                } else {
                                    set such [join [$mainHTML token list $idx.0 end]]
                                }
				if {[regexp {Text } $such]} {
					set idx [lindex $such 0]
					set true 1
				} elseif {$idx >= $end} {
					set true 1
				} else {
					incr idx
				}
			}
			#NEW271105:
			set dummy [acode encode $dummy]
			set dummy [reslvURL [lindex [join $dummy] 2] 0]
			regsub -nocase -all {http:/+|https:/+} $dummy {} dummy
			set dummy [acode clear $dummy]
			if {$merk != "$idx $dummy"} {
				lappend tokenlist($activeHTM) [list $idx $dummy]
				set merk "$idx $dummy"
			}
		}
	}
	if {[llength tokenlist($activeHTM)]>0} {
		set tokenlist($activeHTM) [join $tokenlist($activeHTM)]
	}
	ProgressFile 0 0
#puts "Tokenlist: $tokenlist($activeHTM)"
	unset htmlist merk
}

#Called after a Site was completely downloaded
proc exitLoadFile {url} {
	global selected buffer active anzSEL htmldisplay waitID backColor msgText bytesTotal ByteCount maxBytes fsizeWarn cancel translateFiles getCSS \
	iFrames HTMLpwd shiftPress FTPask cacheSpace destSpace styleParsed downMode toknHandles rbytes tbytes reqURL linktext vSize activeHTM baseurl \
	getBG metaREDIR
	writeCookie $url
#	writeDOM $url
#	catch {stop_anigif .mbar.lbAnim}
	.imHTTPS configure -image imUnLock -background $backColor
	catch {stop_anigif .mbar.lbAnim}
	set selected ""
	set buffer ""
	if {[llength $toknHandles]>0} {
		foreach inhalt $toknHandles {
			catch {http::reset $inhalt}
			catch {http::cleanup $inhalt}
		}
	}
	set toknHandles ""
#	set metaREDIR ""
	set reqURL ""
    set vSize($activeHTM) "0x0"
	set downMode 0
	set active 0
#	MouseCurs 0
	ShowTableStruct 0
	set styleParsed 0
	set getCSS 0
	set getBG 0
	set shiftPress 0
	ProgressFile 0 0
	ProgressBar 0 0
	set anzSEL 00
	.lbAnzSelGfx configure -width [string length $anzSEL]
#	set cancel 0
	catch {after cancel $waitID}
#	setLED blue
	if {$bytesTotal>0} {
		dispMSG "Total: $bytesTotal KBytes"
		if {![regexp -nocase {^file:/|^/|^[A-Z]:} $url]} {
                        set ByteCount [expr $ByteCount + $bytesTotal]
                        set cacheSpace [expr $cacheSpace - $bytesTotal]
#                        set destSpace [expr $destSpace - $bytesTotal]
                        set back 0
                        if {$cacheSpace < 102400} {set back 1; .mbar.prgFile configure -background red; setLED red; dispMSG $msgText(warning.cacheSpace)}
#                        if {$destSpace < 102400} {set back 1; .tile.bottom.pane.f3.box.prgBar configure -background red; setLED red; dispMSG $msgText(warning.destSpace)}
       			if {$back > 0 && $FTPask > 0} {
				optionBox -title $msgText(warning.lowSpace.1) -icon warning -type ok -message $msgText(warning.lowSpace.2)
			}
                }
		if {$maxBytes > 0 && $ByteCount > $maxBytes} {
			setLED red
			dispINF "$msgText(download.5)"
			.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
			if {$fsizeWarn == 1} {
				optionBox -title $msgText(warning.traffic.1) -icon warning -type ok -message $msgText(warning.traffic.2)
			}
		}
	} else {
#		dispMSG "OK."
	}
	wm title . "Inquisitor"
	wm iconname . "FIQ"
	set linktext ""
#	ProgressBar 0 0
#puts "EXIT: $url : $baseurl($activeHTM)"
if {[string length $url]>[string length $baseurl($activeHTM)] && [regexp -nocase {/$} $baseurl($activeHTM)] && [regexp -nocase $baseurl($activeHTM) $url]} {
	setBase $url
}
	catch {unset htmldisplay rbytes tbytes}
}

proc preParse {input} {
#preParses the whole HTMLsource before it is rendered into HTMLwidget (cause it is unable to handle all possible HTMLtags)
	global debug cancel thumbsOnly fileTypes tableCorrect iFrames jScripts filtVars useFrames fonts fontcount htmlDIR textIMG otherWarn msgText \
    	   useApplet mainHTML refererBACK baseurl activeHTM remSTR killCHR ficsVars fTypes bgcolor
    set referer [string trim [lindex [split $refererBACK { }] end]]
    if {$referer==""} {set referer [string trim [regSTR $remSTR $baseurl($activeHTM)] /]}
	set back ""
	set merk {"irgenwasunmgliches" 0}
	set href ""
	set src ""
	set value ""
	if {[llength $input]<=2} {return $input}
	set id ""
	set width 0
	set height 0
	set input [split $input \n]
	set max [llength $input]
	set z 0
	set h 0
	set jscript 0
	set div 0
	set nscript 0
	set frames 0
	set nframes 0
	set helpfont 0
	set bgtext ""
	set bgimage ""
	set bgcolor ""
	set fonts ""
        set fontcount 0
	set styleCount 0
	set style ""
	set tableFound 0
	set tableCount 0
	set tableStart ""
	set tableEnd ""
	set class ""
	set merkClass ""
	set embedSRC ""
	set embed 0
#	set swf 0
	set imgCount 0
	set divFound 0
	set divCount 0
	regsub -nocase -all { } $fTypes(Images) {|} check
	while {$z <= $max} {
		if {$cancel==1} {break}
		#NEW230106: progressBar@parsing
		ProgressFile $z $max
		set zeile [lindex $input $z]
		if {$debug>7} {puts "preParse: $zeile"}
#puts "preParse: $z $zeile"
		#NEW:220106: prevent illegal Binaries
		if {[regexp {^ELF|^MZ} $zeile]} {
			set back "<html>\n<head>\n<title>Illegal BinaryCode detected !</title></head>\n</html>"
			setLED red
			.mbar.lbAnim configure -image imTuxForbidden
			if {$otherWarn>0} {optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $msgText(fiq.blocked.2)}
			incr z
			break
			#continue
		}

		#NEW220706: delete strange LinkRel Script (started with "<? ") in some rare sites
		if {[regexp { r \(cz | r \(n 4 |FAIL \(the browser should render some flash content&#44; not this\).} $zeile]} {
			incr z
			continue
		}
#puts "ZEILE $z $zeile"
		#NEW251205: recognize also linked StyleSheets
		if {[regexp -nocase {<link} $zeile]} {
			if {[regexp -nocase {text/css|\.css|stylesheet} $zeile] && [regexp -nocase { href} $zeile]} {
				lappend style $zeile
			}
		}
		#Style parsing
		if {[regexp -nocase {\-\->|/style>} $zeile] && $styleCount == 1} {set styleCount 2; incr z; continue}
		if {$styleCount == 1} {lappend style $zeile; incr z; continue}
		#CHNG311205:
#		if {[regexp -nocase {<style} $zeile] && [regexp -nocase {<!--} $zeile] && $styleCount == 0} {set styleCount 1; lappend style $zeile; incr z; continue}
		if {[regexp -nocase {<style} $zeile] && $styleCount == 0} {set styleCount 1; lappend style $zeile; incr z; continue}

if {[regexp -nocase {</noscript} $zeile] && ![regexp -nocase {\);} $zeile]} {set nscript 0}
if {[regexp -nocase {<noscript} $zeile] && ![regexp -nocase {\);|</noscript} $zeile] && $embedSRC!=""} {set nscript 1}
if {$nscript==1} {incr z; continue}

#document.cookie='atref=noref$#; path=/;'
if {[regexp -nocase {document.cookie} $zeile]} {
   regsub -nocase {document.cookie *[=\(]+ *} $zeile {} cookie
   set cookie [lindex [split $cookie ] end]
   regsub -nocase -all {//|\-\->|'} $cookie {} cookie
   if {![regexp -nocase "$killCHR|function |var|return" $cookie]} {
      getCookie $referer [string trim $cookie]
   }
   incr z
   continue
} elseif {[regexp -nocase {location.href *=.*http:/} $zeile]} {
#Java Umleitung: location.href = "http://myusenet.net/series/52475142/";
	  set href [string trim [getValue location.href $zeile]]
	  if {![regexp -nocase $baseurl($activeHTM) $href] && ![regexp -nocase $href $baseurl($activeHTM)]} {
             #CHNG161010 (wg. http://www.mc-nudes.com/fhg2/fhg.php?f=Mony_w88Ip&ccid=1048813&p=70 ):
             if {[regexp -nocase {onclick *=} $zeile]} {
                     if {$href!=""} {
			 set zeile "<a href='$href'>$href</a>"
		     }
             } else {
                     if {$href!=""} {
			 set zeile "<META http-equiv='refresh' content='2; URL=$href'>"
		     }
	     }
	  }
} elseif {[regexp -nocase {javascript:[a-zA-Z0-9]+ *( *)} $zeile]} {
  regsub -nocase {\(|\)} $zeile {} zeile
} elseif {[regexp -nocase { *unescape *\('} $zeile]} {
#NEW160107: recognize JAVAs: "unescape('%20%36')" command, and decode it
#puts "ESC1: $zeile"
		   set value [getValue unescape $zeile]
		   set zeile [cgiDecode $value]
#puts "ESC2: $zeile"
}

#puts "preParse: $z $zeile"

#JavaScript parsing
if {[regexp -nocase {<script} $zeile]} {set jscript 1}
#if {$swf>0 && [regexp -nocase {</noscript} $zeile]} {set swf 0}
if {[regexp -nocase {</script|<noscript} $zeile] && ![regexp -nocase {\);} $zeile]} {
	   set jscript 0
}
if {$jscript==1} {
	regsub -nocase -all {<|>|</} $zeile { } jScript
	regsub -nocase -all { +} $jScript { } jScript
	set jScript [split $jScript { }]
	#iFrameHandler $iFrame
	lappend jScripts [concat $jScript]\n
#puts "Zeile: $z $zeile"
	if {$useApplet==1} {
		#NEW091206: recognize EMBEDtag within JAVAscript
		if {[regexp -nocase {<embed } $zeile]} {
		   set dummy [split $zeile +]
		   foreach tag $dummy {
		   		   if {[regexp -nocase {<embed } $tag]} {set embed 1}
	   	   		   if {[regexp -nocase {<.*/embed>} $tag]} {
						 set embed 2
						 append embedSRC $tag
						 regsub -nocase -all {'\+ *' *} $embedSRC {} zeile
						 regsub -nocase -all { +|' '} $zeile { } zeile
	 					 regsub -nocase -all {> +<} $zeile {><} zeile
	 					 regsub -nocase -all { +'} $zeile {'} zeile
	 					 regsub -nocase -all {<//embed>'*} $zeile {</embed>} zeile
#puts "EMBED: $zeile"
				   }
		   		   if {$embed==1} {append embedSRC $tag}
		   }
		} elseif {[regexp -nocase { *SWFObject *\(} $zeile]} {
#NEW280107: http://www.femjoy.com/setdetails.php/111015_jkj677/ts
#puts "EMBED: $zeile"
regsub -nocase -all {&*#44;} $zeile {,} dummy
regsub -nocase -all {;} $dummy "\n" dummy
foreach inhalt [split $dummy "\n"] {
#puts "INHALT: $inhalt"
		if {[regexp -nocase {^.+ *SWFObject *\(} $inhalt]} {
           		regsub -nocase {^.+ *SWFObject *\(} $inhalt "{" inhalt
				regsub -nocase {\)} $inhalt "}" inhalt
				regsub -nocase -all {'|"|,|;} $inhalt {} inhalt
				set inhalt [join $inhalt]
#puts "SWFobject: $inhalt"
				set rc [scan $inhalt "%s %s %s %s %s %s" src id width height version bgcolor]
		} elseif {[regexp -nocase {^.+\.addVariable *\(} $inhalt]} {
           		regsub -nocase {^.+\.addVariable *\(} $inhalt "{" inhalt
				regsub -nocase {\)} $inhalt "}" inhalt
				regsub -nocase -all {'|"|,|;} $inhalt {} inhalt
				set inhalt [join $inhalt]
#puts "Addvar: $inhalt"
				set rc [scan $inhalt "%s %s" name value]
				append src "&$name=$value"
		}
}

regsub -nocase {&} $src {?} src
#set zeile "<EMBED src=\"/player24xml.php/111015_jkj677/ts/9904/\" name=\"fjplayer\" width=\"970\" height=\"463\" bgcolor=\"#000000\"></EMBED>"
#set zeile "<EMBED src=\"/player24.swf?file=/player24xml.php/111015_jkj677/ts/9904/\" name=\"fjplayer\" width=\"970\" height=\"463\" bgcolor=\"#000000\"></EMBED>"
set zeile "<EMBED src=\"$src\" name=\"$id\" width=\"$width\" height=\"$height\" bgcolor=\"$bgcolor\"></EMBED>"
#puts "CREATED: $zeile"






append back [string trimright $zeile \n]\n
#set swf 1
#set jscript 1
incr z
continue
		} else {
			   incr z
			   continue
		}
	} else {
		incr z
		continue
	}
} elseif {[regexp -nocase {</script|</noscript} $zeile] && ![regexp -nocase {\);} $zeile]} {
#	set embedSRC " "
#	set swf 0
	parseJava $jScripts
	incr z
	continue
}

#NEW191106: when ThumbsOnly show Movies/Applets as normal Links (make them selectable)
#	if {$thumbsOnly>0 && [regexp -nocase {<applet|<embed} $zeile]} {
#	   	set src [getValue src $zeile]
#		regsub -nocase -all {<applet |<embed } $zeile {<img } dummy
#		regsub -nocase -all {</applet>|</embed>} $dummy {} dummy
#		set width [stripValue [getValue width $dummy] ""]
#		set height [stripValue [getValue height $dummy] ""]
#		set zeile "<a href='$src'><img src='$src' width='$width' height='$height' alt='Video'></a>"
#		append back [string trimright $zeile \n]\n
#		incr z
#		continue
#	}

#iFrame parsing
if {$useFrames==1} {
#puts "$z Zeile: $zeile"
        if {[regexp -nocase {<frameset } $zeile]} {set nframes 1}
        if {[regexp -nocase {</frameset} $zeile]} {set nframes 0}
        if {[regexp -nocase {</iframe} $zeile] && ($frames==1 || $nframes==1)} {
		    set frames 0
   		    regsub -nocase {</iframe} $zeile {</embed} zeile
		}
       	if {[regexp -nocase {</noframe} $zeile] && $frames==1} {
       		set frames 0
       		incr z
       		continue
       	}
        if {$frames==1 && $nframes==0} {incr z; continue}
        if {[regexp -nocase {<iframe } $zeile] && ($frames==0 || $nframes==1)} {
        	set frames 1
		regsub -nocase {<iframe } $zeile {<embed type='iFrame' } zeile
        }
        #NEW160106: check if Frames activated; don't display noFrame-Tag
       	if {[regexp -nocase {<noframe} $zeile] && $frames==0} {
       	    set frames 1
       		incr z
       		continue
       	}
} else {
        if {[regexp -nocase {</iframe} $zeile] && $frames==1} {
		    set frames 0
			incr z
			continue
		}
        if {$frames==1} {incr z; continue}
        if {[regexp -nocase {<iframe } $zeile] && $frames==0} {
		    set frames 1
       		incr z
       		continue
        }
}

#autoBreak too long Text
#if {[string length $zeile]>80} {set zeile [breakText $zeile 80]}

#Image over TableBackground:
#HTTP://www.pacinosworld.com/hosted/1/Daisy_1/1/index.php
#HTTP://hosted.justteensite.com/galleries/g3/88/ccbill/1272773
#	if {[regexp -nocase {<td } $zeile] && [regexp -nocase {background=} $zeile]} {
#	    #z.B.: <td valign="top" width="710" height="170" background="i/img03.jpg">
#		set bgimage [getValue background $zeile]
#       set bgtext [extractText $zeile]
#		regsub -nocase -all $bgtext $zeile {} zeile
#		regsub -nocase {</td>} $zeile "<img src='$bgimage' text='$bgtext' ></td>" zeile
#puts "ZEILE: $zeile"
#	}

##<td align=center valign=middle background=../../graphics/gallery-bubblebath-2.jpg>
#if {([regexp -nocase {^<td} $zeile] && ![regexp -nocase {<body|<th|<tr|<table|<div} $zeile]) && [regexp -nocase {background=} $zeile]} {}
#if {[regexp -nocase {<td} $zeile] && [regexp -nocase {background=} $zeile]} {
#    set height [stripValue [getValue height $zeile] 1]
#    set width [stripValue [getValue width $zeile] 1]
#	regsub -nocase -all {<td} $zeile "\n<td" zeile
#	set dummy [split $zeile "\n"]
#	set help ""
#	foreach inhalt $dummy {
#		if {[regexp -nocase {<td background=} $inhalt]} {
#			regsub -nocase -all {<td background=} $inhalt {<textarea bg=} inhalt
#			regsub -nocase -all {</td>} $inhalt "</form></TD>" inhalt
#regsub -nocase -all "\n" $inhalt "" inhalt
#			append help "<TD width='$width' height='$height'><form action=background>$inhalt"
#puts "SETimageZeile: $help"
#			append back [string trimright $zeile \n]\n
#incr z
#continue
#		} else {
#		  	 append help $inhalt
#		}
#	}
#	set zeile $help
#	regsub -nocase -all "\n" $zeile "" zeile
#append back [string trimright $help \n]\n
#incr z
#continue
#}

#if {[regexp -nocase $filter $zeile]} continue
#if {[regexp -nocase {<!--} $zeile]} {incr z; continue}
#puts "Zeile: $z $zeile"

		#NEW181205: SetBase BEFORE HTML-Widget gets the Code
		if {[regexp -nocase {<base} $zeile]} {
			set base [getValue href $zeile]
			setBase $base
		}

#NEW160406: FontChooser
if {[regexp -nocase {<font} $zeile]} {
            regsub -nocase -all {^.+<font} $zeile {<font} dummy
            set face [getValue face $dummy]
#puts "Font: $face"
            if {$helpfont==0} {
                        #lappend fonts "charter"
                        set helpfont 1
            } else {
                        lappend fonts $face
            }
}

		if {[regexp -nocase {/div>} $zeile] && $div>0} {
		      regsub -nocase {</div>} $zeile {</FONT></div>} zeile
		      set div 0
		}

		if {[regexp -nocase {<TABLE|<TR|<TD} $zeile] && $divFound==0} {
		   			set divFound 1
		}

		#NEW171205: check 4 Images in Background Styles (make them as normal IMG SRC) z.B.:
		#<div class="pb" style="background:url(thumbs/16.jpg) center center no-repeat transparent;"></div>
		if {[regexp -nocase {<div} $zeile] && [regexp -nocase {style} $zeile] && [regexp -nocase {background:url} $zeile]} {
		#Wenn Objekt (DIV) Style gefunden
			regsub -nocase -all {\(|\)} $zeile { } dummy
			#Hole IMG SRC URL aus Background
			set value [getValue style $dummy]
			if {[string length $value]<=0} {set value [getValue background:url $dummy]}
			set url [getValue $value $dummy]
			regsub -nocase -all {<img} $dummy {<img} dummy
			set dummy [lindex [split $dummy ] 0]
			if {[string length $url]>0 && ![regexp -nocase {:|;|font|px|padding} $url]} {
				set zeile "$dummy<img src='$url'></a></div>"
			}
		} elseif {[regexp -nocase {<div} $zeile] && [regexp -nocase {style} $zeile]} {
				   regsub -nocase -all {:|;} $zeile { } value
	  		 	   set div 1
				   set type [getValue font-family $value]
               	   set size [stripValue [getValue font-size $value] 11]
               	   #recalculate PixelValues in HTML Values 1-7
				   set fsize [fontPick $size]
               	   set color [getValue color $value]
               	   set bgcolor [getValue background-color $value]
       			   set zeile "$zeile<FONT size='$fsize' color='$color' face='$type' bgcolor='$bgcolor'>"
		} elseif {$divFound==0 && $imgCount>=5 && [regexp -nocase {<div} $zeile] && [regexp -nocase { class} $zeile]} {
              set class [getValue class $zeile]
              if {$merkClass=="" && ![regexp -nocase $class $merkClass]} {
              	 		  set merkClass $class
              	 		  set zeile "<TABLE>\n<TR>\n<TD>\n$zeile\n</TD>"
              	 		  incr divCount
			  } elseif {![regexp -nocase $class $merkClass] || $divCount>4} {
              	 		  set merkClass $class
              	 		  set divCount 0
              	 		  set zeile "</TR>\n<TR>\n<TD>\n$zeile\n</TD>"
              } else {
              	 		  set zeile "<TD>\n$zeile\n</TD>"
              	 		  incr divCount
              }
		} elseif {$divFound==0 && $imgCount>=5 && $merkClass!="" && [regexp -nocase {</div} $zeile]} {
              		   	  set zeile "$zeile\n</TR>\n</TABLE>"
              		   	  set merkClass ""
        }

		#NEW050907:
		if {[regexp -nocase {style *= *'*"*background-image:url\(} $zeile]} {
		   regsub -nocase -all {\(|\)} $zeile { } zeile
		}
#puts "ZEILE: $zeile"

#NEW251206: show FakeURL as ALTtag (show the User what ALL other Browsers hide !)
#onMouseOver="window.status='http://free-video-dawnloads.net/gallery_1/movie1.wmv'
if {[regexp -nocase {onMouseOver} $zeile] && [regexp -nocase {window.status} $zeile]} {
   regsub -nocase -all { } $zeile {%20} dummy
   regsub -nocase -all {(%20)*window.status(%20)*} $dummy { window.status } dummy
   set fake [getValue window.status $dummy]
   set dummy [regSTR $remSTR $fake]
   set href [regSTR $remSTR [getValue href $zeile]]
   if {([regexp -nocase -all {\.} $fake]>1 && [regexp -nocase {/} $fake])} {
         if {([regexp -nocase -all {\.} $href]>1 && [regexp -nocase {/} $href]) && (![regexp -nocase $dummy $href] || ![regexp -nocase $href $dummy])} {
            	regsub -nocase {<img } $zeile "<img alt=\'FAKE:_$fake\' " zeile
         }
   } else {
         if {([regexp -nocase -all {\.} $href]>1 && [regexp -nocase {/} $href]) && (![regexp -nocase $dummy $href] || ![regexp -nocase $href $dummy])} {
            	regsub -nocase {<img } $zeile "<img alt=\'$fake\' " zeile
         }
   }
}

#NEW251206: add aHREFtag if missed
if {[regexp -nocase {</a>.*$} $zeile] && ![regexp -nocase {^.*<a |<form action=marquee|<form action=blink|<form action=medit} $zeile]} {
   set hilf ""
   regsub -nocase -all {>} $zeile ">\n" dummy
   foreach inhalt [split $dummy \n] {
   		   if {[regexp -nocase {^<} $inhalt] && [regexp -nocase {>$} $inhalt]} {
	  		   append hilf $inhalt
		   } elseif {![regexp -nocase {^<} $inhalt] && [regexp -nocase {>$} $inhalt]} {
	       	   append hilf "<A HREF='$inhalt"
	       } else {
	           append hilf $inhalt
	       }
   }
   regsub -nocase -all {''+} $hilf {'} zeile
}

#if {[regexp -nocase {<a href *= *'link'} $zeile]} {
#   regsub -nocase -all {<a href *= *'link'} $zeile "<A HREF='link$z'" zeile
#puts "ZEILE: $zeile"
#}

#if {[regexp -nocase {<!-} $zeile]} {incr z; continue}
#if {$z>33 && $z<48} {incr z; continue}
#puts "ZEILE $z $zeile"

#NEW101206: special FormHanlder 4 TextArea/Input without FORMtag
#if {[regexp -nocase {<textarea } $zeile] && ![regexp -nocase {<form } $zeile] && ![regexp -nocase {marquee|blink} $zeile]} {
#   			set zeile "<form action=textarea>\n$zeile\n</form>"
#}

#NEW preBodyHandler:
#<body onLoad="MM_preloadImages('/images2/exgirl_babes_14_o.jpg','/images2/exgirl_babes_17_o.jpg','/images2/exgirl_babes_22_o.jpg','/images2/exgirl_babes_26_o.jpg','/images2/exgirlf_25_o.jpg','/images2/footer_44_over.jpg')">

		if {$tableCorrect==1} {
#<tr>s zhlen, WENN jedes IMG in ein <tr></tr> eingeschlossen ist, darf nur jedes 5. <tr></tr> gesetzt werden
			if {$tableFound>0 && [regexp -nocase "</table" $zeile]} {set tableFound 0}
			#NEW010106:
			if {$tableFound==2 && $tableCount<5} {
				set tableStart "\n<td>"
				set tableEnd "</td>\n"
			}
			if {$tableFound==1 && ![regexp -nocase {<tr|<td|<th} $zeile]} {
				set tableStart "\n<tr>\n<td>"
				set tableEnd "</td>\n"
				set tableFound 2
				#set tableCount 0
			}
			if {$tableFound==2 && $tableCount>=4} {
				set tableFound 1
				set tableCount 0
				set tableStart "\n<td>"
				set tableEnd "</td>\n</tr>\n"
			}
			if {$tableFound>1} {incr tableCount}
			if {$tableFound==1} {
				if {[regexp -nocase -all {<tr|<th} $zeile]} {
					regsub -nocase -all {<tr>|</tr>|<th>|</th>} $zeile {} zeile
				}
			} elseif {$tableFound>1} {
				if {[regexp -nocase -all {<td} $zeile]} {
					regsub -nocase -all {<td>|</td>} $zeile {} zeile
				}
			}
			if {$tableFound==0 && [regexp -nocase {<table|<tr|<th|<td} $zeile]} {set tableFound 1}
		} else {
		  	   if {[regexp -nocase {<td .+><|<td .+><|<div .+><} $zeile]} {
#puts "Zeile: $zeile"
		  	   	  regsub -nocase {><} $zeile ">\n<" zeile
#puts "XEILE: $zeile"
		  	   }
		}
		set size " "
		#nur 1 IMG in Zeile gefunden
		if {[regexp -nocase -all {<img} $zeile]} {
		incr imgCount
#puts "IMG1 gefunden"
			regsub -nocase -all { +|\<|\>} $zeile { } dummy
			set src [getValue src $dummy]
			set src [reslvURL $src 0]
#NBW111106:
#			set alt [getValue alt $dummy]
set alt [getAlt alt $dummy]
			if {[string length $alt]>0} {
				set alt " alt='$alt' "
			} else {
#				set alt [getValue title $dummy]
set alt [getAlt title $dummy]
				if {[string length $alt]>0} {
					set alt " alt='$alt' "
				} else {
					set alt " "
				}
			}
			set border [getValue border $dummy]
			if {[string length $border]>0} {
				set border " border='$border' "
			} else {
				set border " "
			}
			set high [stripValue [getValue height $dummy] ""]
			set widt [stripValue [getValue width $dummy] ""]
			if {[string length $high]>0 && [string length $widt]>0} {
				if {$widt>0 && $high>0 && $thumbsOnly==0} {
					set size " height=$high width=$widt "
				} else {
					set size " "
				}
			}
#CHNG120306:
#			if {![regexp -nocase -all { href} $zeile]} {}
			if {![regexp -nocase -all { href} $zeile] && [regexp -nocase -all {<img} $zeile]>1} {
#CHNG160406:
#				regsub -nocase -all {<img} $zeile {\n<img} zeile
#puts "HREF2 gefunden"
				if {$thumbsOnly==0} {
					set zeile "$tableStart[join $zeile]$tableEnd"
				} else {
					set help ""
					set size " "
#					regsub -nocase -all {<tr>|<th>} $tableStart {} dummyStart
#					regsub -nocase -all {</tr>|</th>} $tableEnd {} dummyEnd
#CHNG160406:
regsub -nocase -all {<img} $zeile {\n<img} zeile
					set zeile [split [join $zeile] \n]
					foreach dummy $zeile {
						if {[regexp -nocase -all {<img} $dummy]} {
							set src [getValue src $dummy]
							set src [reslvURL $src 0]
#NEW111106:
#							set alt [getValue alt $dummy]
set alt [getAlt alt $dummy]
							if {[string length $alt]>0} {
								set alt " alt='$alt' "
							} else {
#							       	set alt [getValue title $dummy]
set alt [getAlt title $dummy]
								if {[string length $alt]>0} {
									set alt " alt='$alt' "
								} else {
									set alt " "
								}
							}
							set border [getValue border $dummy]
							if {[string length $border]>0} {
								set border " border='$border' "
							} else {
								set border " "
							}
							if {[string length $src]>0} {
#								append help "$dummyStart<a href=\"$src\" ><img src=\"$src\"$size></a>$dummyEnd"
								append help "\n<a href=\"$src\" ><img src=\"$src\"$size$alt$border></a>"
							} else {
								append help $dummy
							}
						} else {
						       	append help $dummy
						}
					}
#					regsub -nocase -all {<td>} $tableStart {} dummyStart
#					regsub -nocase -all {</td>} $tableEnd {} dummyEnd
					set zeile "$tableStart[join $help]$tableEnd"
					#set zeile [join $help]
				}
			} else {
#regsub -nocase -all "\n" $zeile {} zeile
#puts "IMG2 gefunden: $zeile"
				#set title [getValue title $dummy]
				set title ""
				set name ""
				if {$thumbsOnly==1} {
					set href $src
					regsub -nocase -all {<img} $zeile {\n<img} dummy
					regsub -nocase -all {<a } $dummy {\n<a } dummy
					set dummy [split [join $dummy] \n]
					set help ""
					foreach inhalt $dummy {
							if {[regexp -nocase {<img } $inhalt]} {
							   set src [getValue src $inhalt]
							   set src [reslvURL $src 0]
							   append help "\n<a href=\"$src\" >$inhalt"
							} elseif {[regexp -nocase {<a } $inhalt]} {
							   continue
							} else {
							   append help $inhalt
							}
					}
					set zeile $help
				} else {
					set href [getValue href $dummy]
#puts "HREF: $href"
					#NEW210106:
					if {[regexp -nocase $filtVars $href]} {incr z; continue}
					if {$href==[lindex $merk 0]} {set href $src}
					if {[regexp -nocase {popupPicture} $zeile]} {
						regsub -nocase -all {\(|\)} $zeile {=} zeile
						set href [getValue {popupPicture} $zeile]
					} elseif {[regexp -nocase {javascript:[ a-zA-Z0-9]+\(*'*} $zeile]} {
regsub -nocase -all {javascript:[ a-zA-Z0-9]+\(*'*} $zeile {} zeile
regsub -nocase -all {&#44;|\);'} $zeile { } zeile
#puts "ZEILE: $zeile"
					} elseif {[regexp -nocase {window.open} $zeile]} {
						regsub -nocase -all {\(|\)} $zeile {=} zeile
						set href [string trim [getValue {window.open} $zeile]]
					} elseif {[regexp -nocase {onClick} $zeile]} {
						if {[regexp -nocase {window} $zeile]} {
							regsub -nocase -all {\(|\)} $zeile {=} zeile
							set href [string trim [getValue {window} $zeile]]
						} else {
							set wert [string trim [getValue {onClick} $zeile]]
							regsub -nocase -all {\(|\)} $zeile {=} zeile
							regsub -nocase -all {\(|\)} $wert {} wert
							set href [string trim [getValue $wert $zeile]]
						}
					} elseif {[regexp -nocase {document.image} $zeile] && [regexp -nocase {\.src.*=} $zeile]} {
					  		 set src [lindex [split $zeile =] end]
					  		 regsub -nocase -all {"|;} $src {} src
					  		 regsub -nocase -all {\+.+\+} $src {1} src
					  		 set src [string trim $src]
					  		 set zeile "<img src=\"$src\" >"
					}
				}

#regsub -nocase -all {'*javascript:[ a-zA-Z0-9=]+\(} $zeile {} zeile
#puts "Zeile: $zeile"

#				if {$htmlDIR==0} {
#					if {[string length $href]>0 && [string length $src]>0} {
#						set zeile "<a href=\"$href\" >$title<img src=\"$src\"$size$alt$border></a>"
#					} elseif {[string length $href]>0} {
#						set zeile "<a href=\"$href\" >$title</a>"
#					} elseif {[string length $src]>0} {
#				  		set zeile "<img src=\"$src\" >"
#					}
#				} else {
					set zeile "$tableStart$zeile$tableEnd"
#				}
			}
		} elseif {$textIMG==1 && ([regexp -nocase { href} $zeile] && ![regexp -nocase {<img} $zeile])} {
#NEW160706: TextLinks mit miniImgs versehen
#regsub -nocase -all {\r+|\n+|\t+|\f+|\v+|\x0a+|\x0d+|\x09+|\x0b+|\xff+|\xfe+|\x00|\xc2} $zeile {} zeile
#set zeile "<img src=\"FIQdummy$z\">$zeile<img src=\"FIQdummy$z\">"
set zeile "$zeile<img src=\"FIQdummy$z\">"
#regsub -nocase -all {</a>} $zeile {} zeile
#set zeile "[string trim $zeile \n]<img src=\"dummy$z\"></a>"
#set zeile "<a href=\"$href\" ><img src=\"dummy$z\" ></a>"

		}

#NEW101106: unique Counter for each Link (has to be cutted off when coming from Widget)
#if {[regexp -nocase {<a href} $zeile]} {
#   	    regsub -nocase -all {"} $zeile {'} zeile; # "
#   	    set dummy [getValue href $zeile]
#   	    regsub -nocase $dummy $zeile {} zeile
#   	    set zeile [lindex [split $zeile ] end]
#   	    regsub -nocase {^'} $zeile {} zeile; # "
#	    set zeile "<a href=\"$dummy$h\" $zeile"
#      	    regsub -nocase -all {'} $zeile {"} zeile; # "
#	    #regsub -nocase -all {<a href='|<a href ='|<a href = '} $zeile "<a href='$h" zeile
#	    incr h
#}
#Geht nicht, weil Selection dann zahl enthlt, was AddSelected, CopyPic, MarkImg usw. wieder aufdrseln mssen, und zwar ohne die SonderzeichenZhler zu entfernen !

		append back [string trimright $zeile \n]\n
#puts "Zeile: $z $zeile"
		incr z
	}
	ProgressFile 0 0
	if {[llength $style]>0} {styleHandler $style}
#	set back [concat [join [split $back "\n"]]]
	regsub -nocase -all { +} $back { } back
	#regsub -nocase -all {\n+} $back {\n} back
	if {$debug>12} {writeFile /home/frenzy/parsedSRC.txt $back}
#puts "BACK: $back"
#	error 13
	catch {unset input zeile dummy h z}
	return $back
}

#Splits HTMLinput into seperate pieces (needed for Image/Link parser)
proc splitHTM {input} {
	global debug tableCorrect htmlDIR useFrames
	if {$debug>12} {writeFile /home/frenzy/originalSRC.txt $input}
	setLED cyan
#puts "Input $input"
	regsub -nocase -all {"} $input {'} dummy; # "
#	set dummy [join [concat $dummy]]
	#LinkTypeIcons bei T-Online funktionieren NUR wenn 4x (Klammer) durch Leerschritt ersetzt wird !
#regsub -nocase -all {&} $dummy {%26} dummy
#	regsub -nocase -all {\-\)|\-\(} $dummy {~} dummy
#regsub -nocase -all {\(} $dummy {%28} dummy
#regsub -nocase -all {\)} $dummy {%29} dummy
	regsub -nocase -all {\\} $dummy {/} dummy
	regsub -nocase -all {,} $dummy {\&#44;} dummy
	regsub -nocase -all {div } $dummy {<div } dummy
	regsub -nocase -all {<+div } $dummy {<div } dummy
#puts "SOURCE: [hexDump $dummy]"
#CHNG031206:
	regsub -nocase -all {\r+|\n+|\t+|\f+|\v+|\x0a+|\x0d+|\x09+|\x0b+|\xff+|\xfe+|\x00|\xc2} $dummy {} dummy
#geht NICHT, wenn CRLF mitten im Dateinamen steht wie z.B. "Image\n.jpg"
#regsub -nocase -all {\r+|\t+|\f+|\v+|\x09+|\x0b+|\xff+|\xfe+|\x00+|\xc2+} $dummy {} dummy
#regsub -nocase -all {(\x0a\x0a)+|(\x0d\x0d)+|(\x0d\x0a\x0d\x0a)+|(\x0a\x0d\x0a\x0d)+|(\x0d\x0a)+|( +\x0a +)|( +\x0d +)} $dummy {} dummy
	regsub -nocase -all {\n+|\x0d\x0a|\x0a\x0d|\x0a+|\x0d+} $dummy "\n" dummy
	regsub -nocase -all {\{|\}} $dummy { } dummy
#regsub -nocase -all {\n+<img *title *= *} $dummy {<img title=} dummy
	set dummy [join [concat $dummy]]
#puts "DUMMY: $dummy"
#Order HTML-Tags
	regsub -nocase -all " *href *\n*= *\n*" $dummy { href=}
	regsub -nocase -all "'href *\n*= *\n*" $dummy {' href=} dummy
	regsub -nocase -all "ahref *= *|a *\n *href *= *|a *\n*href *\n*= *\n*" $dummy {a href=} dummy
    regsub -nocase -all {'width *= *} $dummy {' width=} dummy
    regsub -nocase -all {'height *= *} $dummy {' height=} dummy
    regsub -nocase -all {'border *= *} $dummy {' border=} dummy
    regsub -nocase -all {'align *= *} $dummy {' align=} dummy
	regsub -nocase -all {'class *= *} $dummy {' class=} dummy
	regsub -nocase -all "imgsrc *\n*= *\n*|img *\n*src *\n*=" $dummy {img src=} dummy
	regsub -nocase -all {imgclass *= *} $dummy {img class=} dummy
	regsub -nocase -all {widgth} $dummy "width" dummy
	regsub -nocase -all {javascript: +} $dummy {javascript:} dummy
#NEW211006:
regsub -nocase -all {imgdynsrc=|imgdynsrc =|img dynsrc=|img dynsrc =} $dummy {embed dynsrc=} dummy
regsub -nocase -all {scrolling *= *} $dummy {scrollbars=} dummy
	regsub -nocase -all {> <|> < |>< } $dummy "><" dummy
#	regsub -nocase -all {<img } $dummy "\n<img " dummy

#	regsub -nocase -all {<br>} $dummy "\n<br>" dummy

#	regsub -nocase -all {<br><img } $dummy "<br>\n<img " dummy
#	regsub -nocase -all {<br><a href} $dummy "<br>\n<a href" dummy
#	regsub -nocase -all {<a href} $dummy "\n<a href" dummy

	#NEW160706: show directory Listing
	if {[regexp -nocase {<title>(Index of /|directory|contents|verzeichnis)} $dummy]} {
		regsub -nocase -all {<img *} $dummy "\n<img " dummy
		set htmlDIR 1
#	} else {
#		regsub -nocase -all {<a } $dummy "\n<a " dummy
#		set htmlDIR 0
#NEW231206:
#   	regsub -nocase -all {\n<img } $dummy "<img " dummy
#   	regsub -nocase -all {<a } $dummy "\n<a " dummy
#	regsub -nocase -all {</a>} $dummy "\n</a>\n" dummy
	}

#	regsub -nocase -all { +/>} $dummy {/>} dummy
	regsub -nocase -all {<p} $dummy "\n<p" dummy
	regsub -nocase -all {<h} $dummy "\n<h" dummy
	#regsub -nocase -all {</h} $dummy "\n</h" dummy
	regsub -nocase -all {<ul} $dummy "\n<ul" dummy
	regsub -nocase -all {</ul>} $dummy "\n</ul>" dummy
	regsub -nocase -all {<li} $dummy "\n<li" dummy
	regsub -nocase -all {</li>} $dummy "\n</li>" dummy
#regsub -nocase -all {<br} $dummy "\n<br" dummy
	#NEW170106:
	if {$tableCorrect==0} {
		regsub -nocase -all {<table} $dummy "\n<table" dummy
		regsub -nocase -all {</table>} $dummy "\n</table>\n" dummy
		regsub -nocase -all {<th} $dummy "\n<th" dummy
		regsub -nocase -all {</th>} $dummy "</th>\n" dummy
		regsub -nocase -all {<tr} $dummy "\n<tr" dummy
		regsub -nocase -all {</tr>} $dummy "</tr>\n" dummy

#regsub -nocase -all {<td>} $dummy "<td>\n" dummy
#regsub -nocase -all {<td} $dummy "\n<td" dummy
#regsub -nocase -all {</td>} $dummy "\n</td>\n" dummy
	}

#Table Background
#regsub -nocase -all {<td background=} $dummy "<td><img src=" dummy

#regsub -nocase -all {<th>} $dummy "<th>\n" dummy
#regsub -nocase -all {<tr>} $dummy "<tr>\n" dummy
#regsub -nocase -all {<td>} $dummy "<td>\n" dummy
	regsub -nocase -all {<map } $dummy "\n<map " dummy
#	regsub -nocase -all {/map>} $dummy "/map>\n " dummy
	regsub -nocase -all {<ascript|<a script|<script} $dummy "\n<script" dummy
	regsub -nocase -all {</script>} $dummy "\n</script>\n" dummy
	regsub -nocase -all {<base} $dummy "\n<base" dummy
	regsub -nocase -all {<html} $dummy "\n<html" dummy
	regsub -nocase -all {<head} $dummy "\n<head" dummy
	regsub -nocase -all {<meta} $dummy "\n<meta" dummy
	regsub -nocase -all {<body} $dummy "\n<body" dummy
	regsub -nocase -all {<link} $dummy "\n<link" dummy
	regsub -nocase -all {<title} $dummy "\n<title" dummy
#regsub -nocase -all {<a onClick} $dummy "\n<a onClick" dummy
#regsub -nocase -all {<div} $dummy "\n<div" dummy
#regsub -nocase -all {<div class='imagethumb'>} $dummy "\n<div class='imagethumb'>" dummy
#regsub -nocase -all {<div class='block'>} $dummy {<TABLE><TD>} dummy
#regsub -nocase -all {</div>} $dummy "\n</TD>\n</TABLE>" dummy
	regsub -nocase -all {<center} $dummy "\n<center" dummy
#FormTags
	regsub -nocase -all {<form} $dummy "\n<form" dummy

#NEW161106: Tricky convert Marquee/BlinkTAG to Form Action/Textarea with action=marquee/blink
#TextareaTAG
regsub -nocase -all {<textarea} $dummy "\n<form action=medit><textarea " dummy
regsub -nocase -all {/textarea>} $dummy "/textarea></form>" dummy
#MarqueeTAG
regsub -nocase -all {<marquee} $dummy "\n<form action=marquee><textarea " dummy
regsub -nocase -all {/marquee>} $dummy "/textarea></form>\n" dummy
#BlinkTAG
regsub -nocase -all {<blink} $dummy "\n<form action=blink><textarea " dummy
regsub -nocase -all {/blink>} $dummy "/textarea></form>" dummy

#regsub -nocase -all {<input} $dummy "\n<input" dummy
#regsub -nocase -all {</form} $dummy "\n</form" dummy
	regsub -nocase -all { method=| method =} $dummy " action=" dummy
	regsub -nocase -all {<applet *} $dummy "\n<applet " dummy
	regsub -nocase -all {<embed *} $dummy "\n<embed " dummy
        regsub -nocase -all {<object data|<object type='application/x-shockwave-flash' data} $dummy "\n<embed src" dummy

#frameTags
#Translate <FRAMES> to <iFRAMES>
	regsub -nocase -all {<frameset} $dummy "\n<frameset" dummy
	regsub -nocase -all {</frameset>} $dummy "\n</frameset>\n" dummy
	regsub -nocase -all {<noframe} $dummy "\n<noframe" dummy
	regsub -nocase -all {</noframe>} $dummy "\n</noframe>\n" dummy
#NEW231106: use for iFrames:
#if {$useFrames==0} {
#	regsub -nocase -all {<div class='iframe >|<iframe +} $dummy "\n<iframe " dummy
	regsub -nocase -all {<iframe +} $dummy "\n<iframe " dummy
	regsub -nocase -all {</iframe>} $dummy "\n</iframe>\n" dummy
	regsub -nocase -all {<frame +} $dummy "\n<iframe " dummy
	regsub -nocase -all {</frame>} $dummy "\n</iframe>\n" dummy
#} else {
#	regsub -nocase -all {<iframe } $dummy "\n<embed " dummy
#	regsub -nocase -all {</iframe>} $dummy "</embed>\n" dummy
#	regsub -nocase -all {<frame } $dummy "\n<embed " dummy
#	regsub -nocase -all {</frame>} $dummy "</embed>\n" dummy
#}

#NEW290907: change only 1 Frame to MainHTML
#<iframe src='http://www.galleryhost.com/1016734/11/jennyheart/custom/jhtpgcolorful02/' scrolling=yes align=MIDDLE width=100% height=100% frameborder=No allowtransparency=true background-color=transparent></iframe>
#OUT260910. cause http://hosted.met-art.com/Full_met-art_DMA_54_442/?pa=1686865 will load another page
#if {[regexp -nocase -all {<iframe} $dummy]==1} {
#	regsub -nocase -all {<iframe * src *= *'} $dummy {<META http-equiv='refresh' content='0; URL=} dummy
#}

#NEW181106: use <OBJECT>-Tag also as an Applet
#regsub -nocase -all {<object} $dummy "\n<applet" dummy
#regsub -nocase -all {<embed|<bgsound} $dummy "\n<embed" dummy
#regsub -nocase -all {<strong} $dummy "\n<strong" dummy
#regsub -nocase -all {<font} $dummy "\n<font" dummy
#regsub -nocase -all {</font>} $dummy "\n</font>\n" dummy
#regsub -nocase -all {<? } $dummy "\n<? " dummy

#regsub -nocase -all {</title>} $dummy "\n</title>\n" dummy
	regsub -nocase -all {</html>} $dummy "\n</html>\n" dummy
	regsub -nocase -all {</head>} $dummy "\n</head>\n" dummy
	regsub -nocase -all {</meta>} $dummy "\n</meta>\n" dummy
	regsub -nocase -all {</body>} $dummy "\n</body>\n" dummy
	regsub -nocase -all {<style} $dummy "\n<style" dummy
	regsub -nocase -all {</style>} $dummy "\n</style>\n" dummy
#regsub -nocase -all {<!--} $dummy "\n<!--" dummy
#regsub -nocase -all {\-\->} $dummy "\n-->\n" dummy
#NEW040307:
regsub -nocase -all {<!--[ a-zA-Z0-9?]+-->} $dummy {} dummy
	regsub -nocase -all {<noscript} $dummy "\n<noscript " dummy
	regsub -nocase -all {</noscript>} $dummy "\n</noscript>\n" dummy
#regsub -nocase -all "<!DOCTYPE" $dummy "\n<!DOCTYPE" dummy
	regsub -nocase -all {= | =| = } $dummy {=} dummy
	regsub -nocase -all {\n+} $dummy "\n" dummy
	regsub -nocase -all {>+|>.>|/>} $dummy {>} dummy
	regsub -nocase -all {<+} $dummy {<} dummy
#Delete JavaTrash:
regsub -nocase -all {window.status='+} $dummy {window.status=} dummy

#Order Properties
	regsub -nocase -all {alt=''|height=''|width=''|name=''} $dummy {} dummy
	regsub -nocase -all {'alt=} $dummy {' alt=} dummy
	regsub -nocase -all {.alt=} $dummy { alt=} dummy
	regsub -nocase -all {'height=} $dummy {' height=} dummy
	regsub -nocase -all {'width=} $dummy {' width=} dummy
	regsub -nocase -all {'border=} $dummy {' border=} dummy
	regsub -nocase -all {'name=} $dummy {' name=} dummy
	regsub -nocase -all " src *\n*= *\n*" $dummy { src=} dummy
	regsub -nocase -all "'src *\n*= *\n*" $dummy {' src=} dummy
	regsub -nocase -all {'style=} $dummy {' style=} dummy
	regsub -nocase -all { +} $dummy { } dummy
#regsub -nocase -all {<samp>} $dummy {<strong>} dummy
#regsub -nocase -all {</samp>} $dummy {</strong>} dummy
#NEW150705: remove empty GoogleImage (otherwise an <image> Tag will shown)
#	regsub -nocase -all {<img width=1 height=1>} $dummy {} dummy
	regsub -nocase -all {^\n+$|^\n$|<img width=1 height=1>} $dummy {} dummy
	regsub -nocase -all {//} $dummy {/} dummy
#	regsub -nocase -all {jpg''} $dummy {jpg'} dummy
	regsub -nocase -all {:/} $dummy {://} dummy
	if {$debug>12} {writeFile /home/frenzy/splittedSRC.txt $dummy}
#puts "SOURCE: [hexDump $dummy]"
#puts "Dummy: $dummy"
	return $dummy
}

#ReLoadPage
#Seite erneut Laden, falls schon in Cache, diesen leeren
proc ReLoad {} {
	global homeDir debug LastFile zlrGFX anzGFX active grabMode MapMode activeHTM urltext cacheLocation
	if {$active} return
	if {$MapMode==4} {
		enterFTP [chkFTPactive]
	} else {
		if {![info exists LastFile($activeHTM)] || [string length $LastFile($activeHTM)]==0} return
		clearPage
		set anzGFX 1
		set zlrGFX 0
		#neu200304 getFileURL "austricksen", weil sonst GFX nicht neu geladen werden
		set grabMode 1
		set fake [trimFile $LastFile($activeHTM)]
#		set chart [lindex [split $fake {}] 0]
		set chart [getCachedir $fake]
		mkCacheDir
		set cachedir [string trimright $cacheLocation /]/cache/html/$chart
		if {![file isdirectory $cachedir]} {file mkdir $cachedir}
		set fake [acode encode $fake]
		set gfx $fake
		# Wenn file auch NICHT lokal im Cache existiert
		if {[file exists $cachedir/$gfx]} {
		if {$debug>3} {puts "ReLoad FileDelete: $cachedir/$gfx"}
			catch {file delete -force $cachedir/$gfx}
		} else {
				set dummy [split $gfx #]
				set len [expr [llength $dummy] - 2]
				set dummy [join [lrange $dummy 0 $len]]
				regsub -all -nocase { } $dummy {#} dummy
				set files [string trim $dummy]*
				catch {file delete -force $cachedir/$files}
				if {$debug>3} {puts "delete: $cachedir/$files"}
		}
		LoadFile $LastFile($activeHTM)
		set grabMode 0
	}
}

#2DO (eTag auslesen, Anfrage an Server, ob Datei noch aktuell; ggf. Datei erneuern)
proc AskServer {datei} {
#Fragt Server, ob Datei (aus Cache) noch aktuell (Anhand des eTags, Modified);
#wenn nicht, wird neue Datei (erneut) geholt, soda "getFileURL" aktuelle Datei zurckliefert
#1. eTag/Modify auslesen, 2. Request-Header generieren, 3. Server-Antwort prfen:
#entweder=304 (Not modified), oder 200 (Datei anbei)
#Dazu MUSS gewhrleistet sein, da die eTags richtig von "copyURL" je Domain geschrieben werden !!!
}

#NEU120304: Dateialter (letzte nderung) je Domain pro Datei (aus HTML) merken
proc writeETAG {datei etag modify} {
return
#Schreibt eTag(Modify) aus HTTP-Header-Antwort in Datei je Domain
#puts ">writeETAG bekommt: $datei; $etag; $modify"
	global homeDir remSTR cacheLocation
	if {[string length $datei]==0 || [string length $etag]==0 || [string length $modify]==0} return
	if {$datei=="" || $etag=="" || $modify==""} return
	set ausgabe [list $datei $etag $modify]
	mkCacheDir
#	regsub -nocase -all {www[0-9]*\.} $datei {} chart
#	regsub -nocase -all {www\.} $chart {} chart
#	set chart [lindex [split $chart {}] 0]
	set datei [regSTR $remSTR $datei 0]
	set chart [getCachedir $datei]
	set fake [acode encode [lindex [split $datei /] 0]]
	set dir [string trimright $cacheLocation /]/cache/eTagDB/$chart
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set filename $dir/$fake.ETG
	if {[file exists $filename]} {
	# Wenn es eTag-Datei schon gibt, auslesen, lschen, alle (neuen) Werte speichern
		set inhalt [openFile $filename]
		#in $inhalt ist jetzt Liste aller zur Domain gehrigen Dateien und deren eTag (Modify)
		#aktuelle eTag-Datei in $inhalt suchen
		set idx [lsearch $inhalt $datei]
		if {$idx<0} {
		#Wenn Datei NICHT in eTagDB gefunden, hnge neue eTag-Datei an vorhandene an
			if {![catch {open $filename a} write]} {
				puts $write $ausgabe
				close $write
			}
		} else {
		#Datei in eTagDB bereits enthalten (weil z.B. Seite zum 2.Mal aufgerufen wird), eTag aktualisieren
		#aktualisierte Liste erstellen, eTagDB lschen, und neue DB schreiben
			set newlist [lreplace $inhalt $idx [expr $idx + 2] $datei $etag $modify]
			catch {file delete -force $filename}
			if {![catch {open $filename w} write]} {
				puts $write $newlist
				close $write
			}
		}
	} else {
	#eTag-Datei gibt's noch nicht, also anlegen
		if {![catch {open $filename w} write]} {
			puts $write $ausgabe
			close $write
		}
	}
}

#NEU140304: P3P Value pro Domain "merken" (currently unused)
proc writeP3P {datei inhalt} {
return
	global homeDir cacheLocation
	mkCacheDir
#	regsub -nocase -all {www[0-9]*\.} $datei {} chart
#	regsub -nocase -all {www\.} $chart {} chart
#	set chart [lindex [split $chart {}] 0]
	set chart [getCachedir $datei]
	set dir [string trimright $cacheLocation /]/cache/eTagDB/$chart
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set filename $dir/[string trimright [lindex [split $datei /] 0] /].P3P
	if {![catch {open $filename w} write]} {
		puts $write $inhalt
		close $write
	}
}

#sets BaseURL for resolver cause HTMLwidget is unable to resolve all URLs correctly (called from different functions)
proc setBase {base} {
	global debug baseurl mainHTML activeHTM newPage activeBase HTMLreferer remSTR cookie cookieHeader killCHR translateFiles filtVars useFrames winSYS
#CHNG100606:
	if {$useFrames>0} {
		if {[string length $base]<=0 || [regexp -nocase "_blank|_self|$filtVars|\.css$|\.js$" $base]} return
	} else {
		if {[string length $base]<=0 || [regexp -nocase "$filtVars|\.css$|\.js$" $base]} return
	}
#regsub -nocase -all {\\} $base {/} base
#	set chkBase [regSTR $remSTR $baseurl($activeHTM)]
#	set chkBase [fileDIR $chkBase]
#	set newBase [regSTR $remSTR $base]
#	set newBase [fileDIR $newBase]
#NEW050606:
set base [acode decode $base]
#NEW201206: cut Port if specified
#regsub -nocase -all {:[0-9]+} $base {} base
set chkBase [regSTR $remSTR $baseurl($activeHTM)]
set chkBase [string trim $chkBase /]
set dumBase [split $chkBase /]
catch {expr [llength $dumBase] - 1} dumErg
if {$dumErg<=0} {set dumErg 0}
#set chkBase [join [lrange $dumBase 0 $dumErg]]
catch {join [lrange $dumBase 0 $dumErg]} chkBase
regsub -nocase { +} $chkBase {/} chkBase
set newBase [regSTR $remSTR $base]
set newBase [string trim $newBase /]
set dumBase [split $newBase /]
catch {expr [llength $dumBase] - 1} dumErg
if {$dumErg<=0} {set dumErg 0}
#set newBase [join [lrange $dumBase 0 $dumErg ]]
catch {join [lrange $dumBase 0 $dumErg ]} newBase
regsub -nocase { +} $newBase {/} newBase

#puts "Base: $base $chkBase $newBase"
	if {![regexp -nocase $newBase $chkBase] || ![regexp -nocase $chkBase $newBase]} {
		set dummy [reslvURL [string trimright $base /] 1]
		#regsub -nocase -all {\?|&|#} $dummy {} dummy
		#set dummy [string trim [lindex [split $dummy ] 0]]
		set HTMLreferer "Referer [lowerHTTP [acode recode $dummy]]"
		set newPage 0
#		set cookie ""
		set translateFiles ""
		set cookieHeader ""
	} else {
		#NewBase == oldBase
		return
	}
	set base [regSTR $remSTR $base 0]
	#NEW080505: prevent wrong resolv if Directory-Structure is: www.irgendwas.de/123/index.php/dir/../../../pics/image.gif
	if {[regexp -nocase -all {\.\./} $base]} {
		regsub -nocase -all {/[^/]*\..../} $base {/} base
	}
	set dummy [URLsplit $base]
	set new [lindex $dummy 1]
	if {$debug>3} {puts "setBase get: $base"}
	set baseurl($activeHTM) $new
	set ufile [lindex $dummy 2]
	if {[string length $baseurl($activeHTM)]<=0 && [regexp -nocase {^/} $base]} {
		set baseurl($activeHTM) $ufile
	} else {
		set urlpath $ufile
		if {$debug>2} {
			puts "setBase: $base"
			puts "setPath: $ufile"
		}
		set baseurl($activeHTM) [string trimright $baseurl($activeHTM) /]/[string trimleft $urlpath /]
		set baseurl($activeHTM) [reslvDIR $baseurl($activeHTM)]
		set baseurl($activeHTM) [fileDIR $baseurl($activeHTM)]
	}
	#NEU180704: Wenn BaseUrl in 2nd Win nicht gesetzt, setze Base von 1st Win
	if {[string length $baseurl($activeHTM)]<=0} {
		set dest "local"
		if {$activeHTM=="local"} {
			set dest "remote"
		}
		set baseurl($activeHTM) $baseurl($dest)
	}
        #Ohne die BaseUrl im HTML-Widget zu setzen geht "ZoomFont" nicht !!!
	if {$debug>3} {puts "setBase sets Base: $baseurl($activeHTM)"}
#	$mainHTML config -base $baseurl($activeHTM)
	$mainHTML config -base ""
}

#Argh; the hardest function in the whole program (resolves nearly every URL; called from everywhere)
proc reslvURL {args} {
#URL auflsen
	global debug mainHTML baseurl activeHTM mouseOver remSTR chkCHR chkSTR fTypes
	set datei [lindex $args 0]
regsub -nocase -all {\\|/ /} $datei {/} datei
#NEW030906:
regsub -nocase -all {[^h]ttp:/|htp:/|htt:/|hhtp:/|hhttp:/|http:/ |http:// |http://&} $datei {http:/} datei
regsub -nocase -all {&&+} $datei {\&} datei
if {[regexp -nocase {^htt.+:/} $datei]} {
   	regsub -nocase -all {www,|www-|www|wwwl|[^&w]ww\.} $datei {www.} datei
}
	set datei [acode resolv $datei]
#regsub -nocase -all { } $datei {%20} datei
	if {[string length $datei]<=0} return
	set mithttp [lindex $args 1]
	if {[string length $mithttp]<=0} {set mithttp 0}
	if {$debug>6} {puts "reslvURL get: $datei $mithttp"}
#	regsub -nocase -all {:/+} $datei {://} datei

set datei [regchn $datei]
	#NEU150404: Tag A HREF=javascript: bercksichtigen
	if {[regexp -nocase {javascript} $datei]} return
	set dummy [lindex [split $datei ?] 0]
	regsub -nocase -all {/} $chkSTR {} dumSTR
	if {[regexp -nocase "^$dumSTR" $dummy]} {
#		set back [upperHTTP $datei]
set back $datei
		if {!$mithttp} {
			set back [regSTR $remSTR $back 0]
		}
		if {[regexp -nocase {\?} $back]} {
			set ext .[string trim [getEXT $dummy] .]
			set ext [transType $ext]
			if {![chkALL $ext]} {
				regsub -nocase {\?} $back {/?} back
				regsub -nocase {/*\?} $back {/?} back
			}
		}
		#NEW080706:
		if {[regexp -nocase -all {\?|%3F} $back]>1} {
			regsub -nocase -all {\?|%3F} $back {\&} back
			regsub -nocase {&} $back {?} back
			regsub -nocase -all {/&} $back {\&} back
		}
		#NEW170906:
		regsub -nocase -all {.fhg/$} $back {.fhg} back
#puts "Back $back"
		return [encode $back]
	}
	# 1. URL aufsplitten in 5 Main Komponenten: scheme, authority, urlpath, query, fragment
	set dummy [URLsplit $datei]
	set urlscheme [string trim [lindex $dummy 0]]
	set urlauthority [string trim [lindex $dummy 1]]
	set urlpath [string trim [lindex $dummy 2]]
	set urlquery [string trim [lindex $dummy 3]]
	set urlfragment [string trim [lindex $dummy 4]]
	if {$debug>9} {
		puts "URLscheme1: $urlscheme"
		puts "URLauthority1: $urlauthority"
		puts "URLpath1: $urlpath"
		puts "URLquery1: $urlquery"
		puts "URLfragment1: $urlfragment"
	}
	#NEU180704: URL ist kein File, wenn URL Query enthlt
	if {[regexp -nocase {\?|&} $datei] && [string length $urlauthority]<=0} {
		if {[string length $baseurl($activeHTM)]<=0} {
			set dest "local"
			if {$activeHTM=="local"} {
				set dest "remote"
			}
			set urlauthority $baseurl($dest)
			set baseurl($activeHTM) $baseurl($dest)
		}
	}
	#NEU180704ende
	set dummy [acode resolv $baseurl($activeHTM)]
	set dummy [URLsplit $dummy]
	set base [string trim [lindex $dummy 1]]
	set path [lindex $dummy 2]

	#NEU190304: URL-Commands rausfiltern
	regsub -nocase -all $chkCHR $path {} file
	set file [lindex [split $file ] 0]
	set file [lindex [split $file /] end]
	if {([string length $urlquery]<=0 && [string length $urlfragment]<=0) || [regexp -nocase {\.} $file]} {
		set path [string trim [fileDIR $path]]
	}
	if {$debug>7} {
		puts "BaseURL: $baseurl($activeHTM)"
		puts "urlBase: $base"
		puts "urlPath: $path"
	}
	#Fall2 Authority (baseURL)
	if {[string length $urlpath]<=0 && ![regexp -nocase {/} $urlauthority]} {
		set urlauthority [string trim $urlauthority]
	} else {
		if {![regexp -nocase $base $urlauthority] && ![regexp -nocase {\.} $urlauthority]} {
			if {[string length $urlscheme]<=0} {
				set urlauthority [string trimright $base /]/[string trimleft $urlauthority /]
			}
		}
	}
	if {[string length $urlauthority]<=0} {
		set urlauthority $base
	}
	#Fall3 Path
	if {[string length $urlpath]>0} {
		#CHNG260106:
		#if {![regexp -nocase [string trimleft $path /] $urlpath] && ![regexp {^/} $urlpath]} {}
		if {![regexp -nocase [string trimleft [string trimleft $path /] -] $urlpath] && ![regexp {^/} $urlpath]} {
			if {[regexp -nocase {\.} $urlpath]==1 && [regexp -nocase {\.} $path]} {
				set urlpath /[fileDIR $path]/[string trim $urlpath /]
			} else {
				if {[string length $path]>0} {
					if {![regexp -nocase {/$} $path] && ![regexp -nocase {^/} $urlpath]} {
						set dummy [lindex [split $path /] end]
						regsub -nocase $dummy$ $path {} path
					} elseif {[regexp -nocase {^/} $urlpath]} {
						set path ""
					}
					set urlpath /[string trim $path /]/[string trim $urlpath /]
					if {$debug>4} {puts "1URLpath: $urlpath"}
				}
			}
			regsub -nocase -all {/+} $urlpath {/} urlpath
		}
#Do NOT set last "/" cause some Sites won't work if automatically set !!!
		#Wenn kein "." in Filename enthalten, setzte letzten "/"
		if {![regexp -nocase {\.} [lindex [split $urlpath /] end]]} {
			if {![chkALL $urlpath]} {
				set urlpath [string trim $urlpath]
			}
		}
	} else {
		if {[string length $urlquery]<=0 && [string length $urlfragment]<=0} {
			if {![regexp -nocase $path $urlpath]} {
				if {[string length $path]<=0} {
					set urlpath /
				} else {
					set urlpath $path$urlpath/
					if {$debug>4} {puts "2URLpath: $urlpath"}
				}
			} else {
				set urlpath [string trimright $path /]/
			}
		} else {
			set urlpath $path
		}
	}
	#Fall1 Scheme (HTTP://) leer
	if {[string length $urlscheme]<=0} {
		#Wenn URLscheme leer
		if {[regexp -nocase {\.} $urlauthority]} {
			#prfe, ob "." oder fhrender "/" in URLauthority (weil dann HTTP://)
			if {![regexp -nocase {^/} $urlauthority] || [regexp -nocase {www\.|www[0-9]\.} $urlpath] || [regexp -nocase {.+\..+:[0-9]} $urlauthority]} {
				set urlscheme "HTTP"
				#set urlauthority /
			} else {
				set urlscheme "FILE"
			}
		} else {
			set urlscheme "FILE"
		}
	}
	if {$debug>9} {
		puts "URLscheme2: $urlscheme"
		puts "URLauthority2: $urlauthority"
		puts "URLpath2: $urlpath"
		puts "URLquery2: $urlquery"
		puts "URLfragment2: $urlfragment"
	}
	set urlpath [reslvDIR $urlpath]
	set urlback [URLjoin [list $urlscheme $urlauthority $urlpath $urlquery $urlfragment]]
	set back [$mainHTML resolve $urlback]
#	set back [upperHTTP $back]
	if {$debug>9} {
		puts "URLback: $urlback"
		puts "Back: $back"
	}
	if {!$mithttp} {
		set back [regSTR $remSTR $back 0]
	}
	#NEU241004
	if {[regexp -nocase {\?} $back]} {regsub -nocase -all {$/} $back {} back}
        regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
        regsub -nocase {&} $back {?} back
	#NEW170906:
	regsub -nocase -all {.fhg/$} $back {.fhg} back
	set back [encode [acode resolv $back]]
set back [regchn $back]
#regsub -nocase -all {:/+} $back {://} back
	if {$debug>6} {puts "reslvURL returns: $back"}
	return $back
}

#Pastes 5 URLcomponents together to a full URL
proc URLjoin {urlList} {
	if {[llength $urlList]<=0} return
	global debug
	if {$debug>7} {puts "URLjoin get: $urlList"}
	set dummy $urlList
	set urlscheme [string trim [lindex $dummy 0]]
	set urlauthority [string trim [lindex $dummy 1]]
	set urlpath [string trimleft [string trim [lindex $dummy 2]] /]
	set urlquery [string trim [lindex $dummy 3]]
	set urlfragment [string trim [lindex $dummy 4]]
	set back ""
	#URLscheme
	if {[string length $urlscheme]>0} {
		regsub -nocase {://} $urlscheme {} urlscheme
		set back "$urlscheme:/"
	}
	#URLauthority (Base)
	if {[string length $urlauthority]>0} {
		set back "$back/$urlauthority"
	}
	#URLpath
	if {[string length $urlpath]>0} {
		set back "$back/$urlpath"
	}
	set ext .[string trim [string trim [getEXT $urlpath] /] .]
	set ext [transType $ext]
	#URLquery
	if {[string length $urlquery]>0} {
		set back "[string trimright $back /]/$urlquery"
	} else {
	    set back [string trimright $back /]/
	}
	#URLfragment
	if {[string length $urlfragment]>0} {
		set back "$back?$urlfragment"
	}
#	#presolve such Domains as chip.de
	if {[string length $urlauthority]>0 && ([string length $urlpath]<=0 && [string length $urlquery]<=0 && [string length $urlfragment]<=0)} {
		set back [string trimright $back /]/
	}
	regsub -nocase -all {/+} $back {/} back
#	regsub -nocase -all {:/+} $back {://} back
	#NEW080706:
        regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
        regsub -nocase {&} $back {?} back
set back [regchn $back]
	if {$debug>7} {puts "URLjoin returns: $back"}
	return $back
}

proc URLsplit {urlList} {
#urlSplit (url) teilt angegebene URL in 5 Main-Komponenten auf:
#scheme (HTTP://), authority (baseURL), path (Verzeichnis), query (File), fragment (?xyz=123&a=1)
	if {[string length $urlList]<=0} return
	global debug baseurl activeHTM remSTR fTypes newPage
	set urlList [acode resolv $urlList]
	if {$debug>7} {puts "URLsplit get: $urlList"}
	regsub -nocase -all {\\} $urlList {} urlList
#NEW260806: preserve Errors with leading "+" (a.e.: "+PIC01.JPG+")
regsub -nocase -all {\+} $urlList {\\+} urlList
	#Set Fragment
#	set urlfragment [lindex [split $urlList #] 1]
#	regsub -nocase #$urlfragment $urlList {} urlList
	#Set Query
#CHNG251206: split also URLs like "www.somewhere.com/images/clever&smart.jpg" too
#	regsub -nocase -all {\?|&|%3F|%26} $urlList {} dummy
	regsub -nocase -all {\?|%3F} $urlList {} dummy
	regsub -nocase -all {} $dummy {} dummy
	set dummy [split $dummy ]
	set urlfragment [join [lrange $dummy 1 end]]
	regsub -nocase -all { } $urlfragment {\&} urlfragment

	#Set Authority
	set dummy [lindex $dummy 0]
	set merk $dummy
	set dummy [regSTR $remSTR $dummy]
set urlquery $dummy
if {[regexp -nocase {/} $dummy]} {
	#Set Query (=file)
	set urlquery [lindex [split $merk /] end]
}
	set merk $dummy
	set dummy [string trim $dummy /]
	set urlauthority [lindex [split $dummy /] 0]
	if {[regexp -nocase {^/} $merk] || [regexp -nocase -all { } $urlauthority] && ![regexp -nocase {www|http:|\.} $urlauthority] || [regexp -nocase {\.\.} $urlauthority]} {
		set urlauthority ""
#puts "Bin hier."
	} else {
#puts "oder da"
		set ext .[getEXT $urlauthority]
#puts "Ext: $ext"
#NEW271105: prevent such Directories: "main.page.3/image.jpg" from being resolved as Domains
		if {![regexp -nocase {www[0-9]*\.|^http:|\.} $urlauthority]} {
#puts "oder auch hier"
			if {((![chkALL $ext] && ![regexp -nocase {^com$} $ext]) || ([string length $ext]>3 && ![regexp -nocase {/} $urlauthority])) || (![regexp -nocase {[a-zA-Z][a-zA-Z]} $ext] && ![regexp -nocase {[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*} $urlauthority])} {
					set urlauthority ""
			}
		} elseif {[regexp -nocase {\.} $urlauthority]==1 && ![regexp -nocase {www[0-9]*\.|^http:} $urlauthority]} {
			if {[chkALL $ext] && ![regexp -nocase {^com} $ext] && ![regexp -nocase {.+\..+:[0-9]} $urlauthority]} {set urlauthority ""}
#puts "oder vielleicht da"
		}
#		set ext [lindex [split [transType $urlauthority] .] end]
#		if {([chkIMG $ext] || [chkAPP $ext] || [chkEXT $ext] || [chkSND $ext] || [chkANI $ext]) || [regexp -nocase {[a-zA-Z][a-zA-Z]} $ext]} {
#			set urlauthority ""
#		}
	}
	regsub -nocase -all $urlauthority $merk {} urlpath
	#NEU280804: wenn path fhrenden "." enthlt, muss URL umgestrickt werden
	if {[regexp -nocase -all {^\.} $urlauthority]} {
		regsub -nocase -all {/+} $dummy {/} urlpath
		set urlauthority [lindex [split $baseurl($activeHTM) /] 0]
	}
	regsub -nocase $urlquery $urlpath {} urlpath
#puts "path1: $urlpath"
if {[regexp -nocase $urlauthority $urlquery]} {
   regsub -nocase $urlauthority $urlquery {} urlquery
}
	#Set Scheme (HTTP://)
	if {[regexp -nocase {://} [string range $urlList 0 9]]} {
		regsub -nocase -all {/} [lindex [split $urlList :] 0] {} dummy
		set urlscheme $dummy
	} else {
		set urlscheme ""
	}
	set urlback [list $urlscheme $urlauthority $urlpath $urlquery $urlfragment]
	if {$debug>7} {puts "URLsplit returns: $urlback"}
	#Rckgabe: Liste einzelner MainKomponenten
	return $urlback
}

#sets "HTTP://" in upperCase (mostly called from reslvURL)
proc upperHTTP {datei} {
#Wandelt manuelle Scheme-Angaben in Grobuchstaben
#Wird von "reslvURL" bentigt
        global chkSTR
        set dumSTR [split $chkSTR "|"]
        foreach input $dumSTR {
                set input [string trimright $input /]
        	regsub -nocase "^$input" $datei [string toupper $input] datei
        }
	return $datei
}

#NEW221104
proc lowerHTTP {datei} {
#Wandelt manuelle Scheme-Angaben in Kleinbuchstaben
#Wird von "reslvURL" bentigt
    global chkSTR
    set dumSTR [split $chkSTR "|"]
    foreach input $dumSTR {
        set input [string trimright $input /]
       	regsub -nocase "^$input" $datei [string tolower $input] datei
    }
	if {![regexp -nocase {^[a-zA-Z]+:/+|^/} $datei]} {set datei "http://[string trimleft $datei /]"}
#	regsub -nocase -all {:/+} $datei {://} datei
	return $datei
}

#NEU170404: searchDoc: Durchsucht HTML-Seite nach best. Text und markiert diesen
proc searchMode {} {
	global MapMode cancel sMode urltext msgText mainHTML
	switch $sMode {
		1 {
			dispMSG $msgText(search.mode.1)
			setLED blue
			pack forget .head.dispUrl
			bind .head.searchDoc.etSearch <Return> {set sMerk [searchDoc $search $sMerk]}
			bind .head.searchDoc.etSearch <Escape> {searchMode}
			pack .head.searchDoc -in .head -expand true -fill x
			focus .head.searchDoc.etSearch
			set sMode 0
			.mbar.stop configure -command searchMode
			$mainHTML configure -selectioncolor red
		}
		0 {
			dispMSG $msgText(search.mode.2)
			setLED blue
			pack forget .head.searchDoc
			pack .head.dispUrl -in .head -expand true -fill x
			bind .head.searchDoc.etSearch <Return> {}
			focus .head.dispUrl.url.e
			set sMode 1
			.mbar.stop configure -command {Stop $token}
			$mainHTML configure -selectioncolor LightBlue
		}
	}
}

#NEW270805: freezeURL (freezes currentURL and adds only filename)
proc freezeURL {input} {
	global frozenURL chkCHR
	set back $input
	if {[string length $back]<=0 || [string length $frozenURL]<=0} {return $back}
	if {![regexp -nocase {/$} $input]} {
		set back [fileDIR $frozenURL]
		set file [lindex [split $input /] end]
		regsub -nocase -all $chkCHR $file {} file
		set file [lindex [split $file ] 0]
		set back [string trimright $back /]/[string trim $file]
	}
	return $back
}

#NEW270805: adds actual URL to frozenURL-Variable
proc setFreeze {} {
	global frozenURL urltext backColor msgText
	if {[string length $urltext]<=0} return
	if {[string length $frozenURL]<=0} {
		.head.dispUrl.url configure -background red
		set frozenURL $urltext
		dispMSG $msgText(url.freeze.1)
		setLED blue
	} else {
		.head.dispUrl.url configure -background $backColor
		set frozenURL ""
		dispMSG $msgText(url.freeze.2)
		setLED blue
	}
}

#Menu: HTMLDefaultColors
proc SetDefColor {} {
	global htmlBG htmlFG mainHTML
	#NormBGcolor: 6080C0; 80A0C0
	$mainHTML configure \
		-unvisitedcolor blue \
		-visitedcolor DarkBlue \
		-background $htmlBG \
		-foreground $htmlFG
	setLED blue
}

# clearPage (Wenn clrURL oder clrPage geklickt wird)
proc clearPage {} {
	global dispSRC activeHTM FTPanz FTPdir FTPdest MapMode fontsize imgSize newPage baseurl urltext \
	HTMLquery HTMLenter merkName merkValue refererBACK liste active cookie cancel translateFiles \
	cookieHeader msgText iFrames jScripts
	if {$MapMode==4} {
		set win [chkFTPactive]
		set FTPdest($win) ""
		set FTPanz($win) 00
		if {[llength $FTPdir($win)]>0} {
			refreshFTP $win
			setActive $win
		}
	} else {
		Clear
		SetDefColor
		ProgressFile 0 0
		ProgressBar 0 0
		set dispSRC 0
#		set active 0
		set urltext ""
		set iFrames ""
		set jScripts ""
		set translateFiles ""
		set cancel 0
#OUT260807:
#		set cookie ""
		set cookieHeader ""
		set baseurl($activeHTM) ""
		if {$newPage==1} {set refererBACK ""}
		set newPage 0
		dispMSG $msgText(fiq.ready)
		set HTMLquery ""
		set HTMLenter ""
		set merkName ""
		set merkValue 0
		focus .head.dispUrl.url.e
		#update idletasks
		update
#		set fontsize 3
#		set imgSize 2
	}
}

# File/Open menu
proc LoadPage {datei} {
	global debug active lastDir urltext selected autoConfig fTypes homeDir remSTR iFrames cacheLocation msgText
	if {$active==1} return
	set datei [acode resolv $datei]
	if {$debug>2} {puts "LoadPage: $datei"}
	set f $datei
	if {$datei==""} {
		set filetypes ""
		lappend filetypes {{All Files} *}
		lappend filetypes "HTML {$fTypes(HTML)}"
		lappend filetypes "Images {$fTypes(Images)}"
#		lappend filetypes "Text {$fTypes(Text)}"
#		lappend filetypes "Text {pdf ps}"
		lappend filetypes "Text {txt}"
		catch {stop_anigif .mbar.lbAnim}
		catch {show_anigif [list -data [getAnim digger22]] .mbar.lbAnim}
		set f [tk_getOpenFile -title $msgText(load.page) -initialdir $lastDir -filetypes $filetypes]
                catch {stop_anigif .mbar.lbAnim}
		if {$f!=""} {
			set lastDir [string trimright [fileDIR $f] /]/
		} else {
			return
		}
		set cachedir [string trimright [fileDIR $f] /]
		set gfx [acode encode [string trimright [lindex [split $f /] end] /]]
	} else {
#		set active 1
		set fake [trimFile $f]
		set chart [getCachedir $fake]
		mkCacheDir
		set cachedir [string trimright $cacheLocation /]/cache/html/$chart
		set gfx [regSTR $remSTR $f]
		set gfx [acode encode [string trim $gfx]]
	}
	set ext .[lindex [split $gfx .] end]
#CHNG170406: getEXT NICHT verwenden, da ".HTM" zurckgeliefert wird, auf wenn Endung ".HTML" ist !
#	set ext .[getEXT $gfx]
#puts "Ext: $ext"
	regsub -nocase ${ext}$ $gfx {} gfx
#puts "GFX: $gfx"
	set fakeurl [string trim $cachedir/$gfx].INI
#puts "FakeFile: $fakeurl"
	if {[file exists $fakeurl]} {
	#INI-Einstellungen fr gespeicherte Seite wieder laden; falls vorhanden
		clearPage
#		Clear
		LoadScript $fakeurl
		#NEW250606:
#		set url [lindex [split $urltext /] end]
#		if {![regexp -nocase {\.|\&|\?|\#} $url] && ![chkALL $url]} {
#			set urltext [string trimright $urltext /]/
#		}
#puts "LOADF1: $urltext"
		LoadFile $urltext
		if {[llength $iFrames]>0} {iFrameHandler $iFrames}
	} else {
		if {$autoConfig==0} {
			clearPage
#puts "LOADF2: $f"
			LoadFile $f
			if {[llength $iFrames]>0} {iFrameHandler $iFrames}
		}
		set selected ""
	}
#	set active 0
#puts "LoadPage sets addHistry"
#	addHistry [string trimright [string trim $urltext] /]
	addHistry [string trim $urltext]
}

#aktuelle Seite (HTML/GFX) speichern
proc SavePage {} {
	global urltext lastDir destDir fTypes convert msgText
	set noini 0
	set merk $urltext
	set filetypes { {{All Files} *} }
	if {![regexp -nocase -all {\.} [lindex [split $urltext /] end]]} {set merk [string trim $merk /]/index.htm}
        set ext .[string trim [getEXT $merk] .]
	# Images
	if {[chkIMG $ext]} {
		set filetypes ""
		foreach inhalt $fTypes(Images) {lappend filetypes "$inhalt $inhalt"}
		lappend filetypes {{All Files} *}
		set noini 0
	} else {
	# HTML
		if {[chkEXT $ext]} {
			set filetypes ""
			foreach inhalt $fTypes(HTML) {lappend filetypes "$inhalt $inhalt"}
			lappend filetypes {{All Files} *}
			set noini 1
		}
	}
	#NEU060304: FileName gibt es schon, also Uhrzeit an vorgeschlagenen Filename anhngen
	set filename [lindex [split $merk /] end]
	if {[file exists [string trimright $lastDir /]/$filename]} {
		set extension [lindex [split $filename .] end ]
		set zielname [lindex [split $filename .] 0 ]
		set filename $zielname\_[clock seconds].$extension
	}
	catch {stop_anigif .mbar.lbAnim}
	catch {show_anigif [list -data [getAnim ballooner22]] .mbar.lbAnim}
	set f [tk_getSaveFile -title $msgText(save.page) -initialdir $lastDir -filetypes $filetypes -initialfile $filename]
	catch {stop_anigif .mbar.lbAnim}

	if {$f!=""} {
		set lastDir [string trimright [fileDIR $f] /]/
		set ext [string trim [getEXT $f] .]
		set dummy [cutEXT $f]
		set f [string trim $dummy].[string trim $ext]

		set quelle [getFileURL $urltext 0]
		set ziel [fileDIR $f]
		set ext [string trim [getEXT $f] .]
		if {![regexp -nocase -all $ext $quelle] && $noini==0} {
			if {[string length $ext]<=0} {
				set ext $convert
				set f $f.$ext
			}
			if {[convertGFX $quelle $ext]!=$f} {
				dispMSG $msgText(image.convert)
				setLED blue
			} else {
				set org [lindex [split $quelle .] end]
				regsub -nocase -all $ext $f $org f
				file copy -force $quelle $f
				dispMSG $msgText(page.saved)
				setLED blue
			}
		} else {
			if {[file exists $f]} {
				set extension [lindex [split $f .] end ]
				set zielname [lindex [split $f .] 0 ]
				set f ${zielname}_[clock seconds].$extension
			}
			file copy -force $quelle $f
			dispMSG $msgText(page.saved)
			setLED blue
		}
		set ini [lindex [split $f /] end]
		set ini [lindex [split $ini .] 0]
		regsub -nocase -all { } $ini {.} ini
		if {$noini>0 && [chkEXT .$ext]} {
			#NUR bei HTML-Seite .INI-Datei mit speichern (enthlt "real"-URL)
			SaveScript [string trimright $ziel /]/[string trimright $ini .].INI
		}

	}
}

#NEU160404 preSolve URL
#Resolves manual Entered URL BEFORE "resolveURL" runs
#This prevents Domains with 1 "." from beeing resolved as a File !
proc preSolve {} {
	global urltext MapMode remSTR active chkCHR chkSTR firstStart inifile
	if {$active==1} return
#NEW100711: remember 1st Site after Start
	if {$firstStart == 0} {
		set firstStart 1
		SaveScript $inifile
	}
	set merk $urltext
	clearPage
	set urltext $merk
	if {![regexp -nocase -all "^$chkSTR" $urltext]} {
#puts "preSolve: $urltext"
		set dummy [regSTR $remSTR $urltext 0]
		set url $dummy
		set merk [lindex [split $dummy /] 0]
		if {[regexp -nocase $chkCHR $urltext] || ([regexp -nocase -all {\.} $merk]>=1 && ![regexp -nocase {^/|^[a-zA-Z]:} $dummy] || [regexp -nocase {://} $urltext] || [regexp -nocase {^ww|^http|.+\..+:[0-9]} $merk])} {
			if {[regexp -nocase {^ftp:/+|^ftp\.|:2[01]} $urltext]} {
				set urltext "FTP://$dummy"
			} else {
				set urltext "HTTP://$dummy"
			}
		} elseif {[string length $dummy]>6 && [regexp -nocase {^~*[a-zA-Z0-9]+=*~*$} $dummy] && ![regexp -nocase {\.|:|/|-|\?|&|%} $dummy]} {
		#URL may be encoded
			 set urltext [::base64::decode $dummy]
		} elseif {[regexp -nocase {^/|^[a-zA-Z]:|^.+\.[a-zA-Z0-9]+} $dummy] && ![regexp -nocase {\.|:|/|-|\?|&|%} $dummy] } {
			set urltext "FILE://$dummy"
		}
	}
	if {$MapMode==2} {ChangeMode 2}
	goEnter
}

#Enter-Taste/Button
proc goEnter {} {
	global twice fontsize imgSize home urltext HTMLquery grabMode cancel newPage
	if {[string length $urltext]<=0} return
	set HTMLquery ""
	set twice 0
	set newPage 0
	regsub -nocase -all {\\| /$} $urltext {/} dummyurl
	regsub -nocase -all {www:|www;|www,|www-|www[a-zA-Z]+.*|^ww\.|[^w]ww\.} $dummyurl {www.} dummyurl
	regsub -nocase -all {^[^h]ttp:/|^htp:/|^htt:/|^hhtp:/|^hhttp:/|^http:/ |^http:// } $dummyurl {http:/} dummyurl

#NEW260806: delete ENTER-Character (if any)
regsub -nocase -all {\r+|\n+|\t+|\f+|\v+|\x0a+|\x0d+|\x09+|\x0b+|\xff+|\xfe+|\x00|\xc2|^&|^\?|^ |^%20} $dummyurl {} dummyurl

#puts "goEnter: $urltext"
#NEW020706:
if {[regexp -nocase -all {\?|%3F} $dummyurl]<=1} {
        regsub -nocase -all {\?|%3F} $dummyurl {} dummy
	set dummy [lindex [split $dummy ] 0]
	set dummy [lindex [split $dummy /] end]
#	if {![chkALL $dummy] && ![regexp -nocase {gallery.avenueblue.net} $dummyurl]} {}
	if {![chkALL [transType $dummy]] && [string length $dummy]>1} {
		if {![regexp -nocase {/\?} $dummyurl]} {
			regsub -nocase {\?} $dummyurl {/?} dummyurl
		}
		#setBase $urltext
	}
} else {
	#NEW090706:
	regsub -nocase -all {\?|%3F} $dummyurl {\&} dummyurl
	regsub -nocase {&} $dummyurl {?} dummyurl
	regsub -nocase -all {/&} $dummyurl {\&} dummyurl
}
 	set dummyurl [string trim $dummyurl]
	#NEW270506:
#	set url [lindex [split $dummyurl /] end]
#	if {![regexp -nocase {\.|\&|\?|\#} $url] && ![chkALL [transType $url]]} {
#		set dummyurl [string trimright $dummyurl /]/
#	}

#NEW030711:
if {[regexp -nocase -all {ccbill.com} $dummyurl]} {set dummyurl [cutLink $dummyurl]}

	set urltext [upperHTTP [string trim $dummyurl]]
	set home $urltext
	#addHistry $urltext
	set grabMode 1
	focus .head.dispUrl.url.e
	#update idletasks
	update
	LoadPage $urltext
}

#NEU200304: HTMLwidget ber procedure Aufrufen (wird spter fr "Frames" bentigt !!
#creates HTMLwindows
proc createHTML {parent name scroll border} {
	global debug backColor normLight htmlBG htmlFG frameHTML HTMLactive activeHTM HTMbuttonSize urltext listColor followLinks
	lappend frameHTML [list .$parent $name]
	if {$debug>2} {
		puts "crtHTML: [concat $parent.$name]"
		puts "frmHTML: $frameHTML"
	}
	if {[regexp -nocase {1|y|yes|ok|true|show|on} $scroll]} {set scroll 1} else {set scroll 0}
	if {[regexp -nocase {1|y|yes|ok|true|show|on} $border]} {set border 1} else {set border 0}
	#Create the HTMLwidget
        html .$parent.$name \
		-padx 0 \
		-pady 0 \
		-formcommand FormCmd \
		-imagecommand ImageCmd \
		-fontcommand PickFont \
		-underlinehyperlinks 1 \
		-tablerelief raised \
		-isvisitedcommand IsVisited \
		-background $htmlBG \
		-foreground $htmlFG \
		-borderwidth $border \
		-unvisitedcolor blue \
		-visitedcolor DarkBlue \
		-highlightbackground $backColor \
		-highlightcolor $listColor \
		-selectioncolor $normLight \
		-scriptcommand ScriptCmd \
		-appletcommand AppletCmd \
		-hyperlinkcommand HyperCmd \
		-relief sunken \
		-rulerelief raised \
		-takefocus false \
		-cursor {}
#		-bgimagecommand ImageCmd
#		-width $x -height $y

if {$scroll>0} {
	.$parent.$name configure -yscrollcommand [subst ".$parent.vscroll$name set"] \
	-xscrollcommand [subst ".$parent.hscroll$name.xscroll$name set"]
}

	#-framecommand FrameCmd \ (Unused, cause HTMLwidget dosn't call FrameHandler; wird nicht untersttzt !!!)
	#"Frames" mssen also ber "TokenHandler" geregelt werden !!!
	# defined HTML-Tag Handlers (which tells HTMLwidget what 2do with specified Tags)
	# BodyHandler changes Background Color of HTMLPage <body>-TAG
	.$parent.$name token handler "body" bodyHandler
	#NEU190304: BASE Handler (wenn BASE durch HTML-Page gesetzt wird)
	.$parent.$name token handler "base" baseHandler
#If Set TextareaHandler no Marquees will go any longer
#	.$parent.$name token handler "textarea" {}
	.$parent.$name token handler "div" dummyHandler
#	.$parent.$name token handler "p" {}

# MetaHandler <meta>-Tag (160304: vorrbergehend deaktiv)
	.$parent.$name token handler "meta" metaHandler
#CHNG070105: Frames now translated to iFrames (for now)
#Frames (FrameHandlers)
#	.$parent.$name token handler "FRAMESET" setHandler
#	.$parent.$name token handler "FRAME" frmHandler
#.$parent.$name token handler "font" PickFont2
	#NEW070106: iFrame Handler
#	.$parent.$name token handler "IFRAME" iFrameHandler
#	.$parent.$name token handler "IFRAME" tFrameHandler
#.$parent.$name token handler "font" fontHandler
#NEW211006: AppletHandler
#.$parent.$name token handler "embed" AppletCmd
#.$parent.$name token handler "applet" AppletCmd

#NEW110605: BGsoundHandler (only for IE but most browsers uses <embed> tag)
#.$parent.$name token handler "bgsound" sndHandler
	#Create the Scrollbars INSIDE the HTMLWidget
	frame .$parent.hscroll$name
	set other local
	if {$name=="local" || $name=="remote"} {
		#NEU170604: merkActiveHTMLwin
		if {$name=="local"} {
			set back im2back
			set other "remote"
		}
		if {$name=="remote"} {
			set back im2forw
			set other "local"
		}
		set activeHTM $name
		set HTMLactive($name) .$parent.hscroll$name.lbl$name
		#label $HTMLactive($name) -text "00" -image imBackPNG -relief ridge
		if {[regexp -nocase {\.x\.x[0-9]$} $parent]} {
				label $HTMLactive($name) -background $htmlBG -image imFrames -relief groove -width $HTMbuttonSize -height $HTMbuttonSize
				.$parent.hscroll$name configure -relief sunken -background $htmlBG
		} else {
			radiobutton $HTMLactive($name) -variable activeHTM -value $name -indicatoron false -background $backColor \
			-offrelief ridge -command "setHTMLactive $activeHTM 1" -image $back -selectcolor green -cursor hand2 -width $HTMbuttonSize -height $HTMbuttonSize
			bind $HTMLactive($name) <3> [subst "setHTMLactive $activeHTM 0"]
		}
#		pack $HTMLactive($name) -in .$parent.hscroll$name -side right
		if {$scroll>0} {
			pack $HTMLactive($name) -in .$parent.hscroll$name -side right
		}
	}
	if {$scroll>0} {
		scrollbar .$parent.hscroll$name.xscroll$name -orient horizontal -command [subst ".$parent.$name xview"] -background $listColor -activebackground $normLight
		pack .$parent.hscroll$name.xscroll$name -in .$parent.hscroll$name -side right -fill x -expand true
		pack .$parent.hscroll$name -side bottom -fill x
		scrollbar .$parent.vscroll$name -orient vertical -command [subst ".$parent.$name yview"] -background $listColor -activebackground $normLight
		pack .$parent.vscroll$name -side right -fill y
	}
	#Display HTMLwidget
    pack .$parent.$name -side right -fill both -expand true
	#pack .$parent.$name
	#Mausklick Links an Fenster (Frame) binden
	bind .$parent.$name.x <1> {cLink %x %y [winfo parent %W]}
	#bind .$parent.$name.x <1> {cLink %x %y $parent}
	#NEU210804: doubleclick on Link cuts reDirections from url
	bind .$parent.$name.x <Double-Button-1> {set urltext [upperHTTP [cutLink $urltext]]; preSolve}

#NEW010907: MiddleClick on Link will Download page, SelectALL, and download with 1 click !
#CHNG020907: in MouseMover now
#bind .$parent.$name.x <2> {
#	 	 cLink %x %y [winfo parent %W]; selectALL $followLinks; downloadStart
#}

	# Mausklick rechts !
	bind .$parent.$name.x <3> {onClick %x %y [winfo parent %W]}
	#update idletasks
	#NEU160604
	#bind .$parent.hscroll$name.lbl$name <3> [subst "setHTMLactive $HTMLactive($name) $name"]
}

#activate one of the 2 HTML-Windows
proc setHTMLactive {wert oPane} {
	global active base baseurl urltext HTMLurl fgColor backColor normLight HTMLactive activeHTM \
	HTMLwin mainHTML fTypes etryBack imFavIcon
	if {$active==1} return
	set names [array names HTMLactive]
	if {[llength $names]<=0 || [string length $wert]<=0} return
	if {$oPane==1} {
		openPane $wert
		if {$wert=="local"} {
			set opp "local"
			set wert "remote"
		} else {
			set opp "remote"
			set wert "local"
		}
	} else {
		if {$wert=="local"} {
			set opp "remote"
		} else {
			set opp "local"
		}
	}
       	set HTMLurl($opp) $urltext
	set urltext [upperHTTP $HTMLurl($wert)]
	set imFavIcon imClrURL
	.head.dispUrl.btClrUrl configure -relief raised -image imClrURL -background $backColor
	catch "$HTMLactive($wert) configure -selectcolor green -activebackground lightgreen"
	catch "$HTMLactive($opp) configure -background $backColor -selectcolor $backColor -activebackground $normLight"
	catch "$HTMLwin($wert) configure -relief raised"
	catch "$HTMLwin($opp) configure -relief sunken"
	#NEW111106: check for dangerous Domains
	if {[string length $urltext]>5} {
		if {[regexp -nocase $fTypes(Danger) $urltext] && [regexp -nocase $fTypes(DDOM) $urltext]} {
		      .head.dispUrl.url configure -foreground black -entrybg red
		      setLED red
		} elseif {[regexp -nocase $fTypes(DDOM) $urltext]} {
		      .head.dispUrl.url configure -foreground black -entrybg orange
		} elseif {[regexp -nocase $fTypes(Danger) $urltext]} {
		      .head.dispUrl.url configure -foreground black -entrybg yellow
		} else {
	              .head.dispUrl.url configure -foreground $fgColor -entrybg $etryBack
		}
	}
	set mainHTML $HTMLwin($wert)
	set activeHTM $wert
	set mouseOver $wert
	setBase $baseurl($activeHTM)
	#setBase $urltext
}

#NEW250904: DisplaySource via HTMLwidget
proc displayHTML {datei} {
	global dispSRC selected msgText
	if {[string length $datei]<=0} {
	   setLED orange
	   dispMSG $msgText(ftp.edit.1)
	   return
	}
	if {![chkEXT $datei] && ![chkTXT $datei] && ![regexp -nocase {\.FIL$} $datei]} {
	   setLED red
	   dispMSG $msgText(ftp.edit.2)
	   return
 	}
	if {$dispSRC==0} {
		set fakefile [getFileURL $datei 0]
		set htmltext [ReadFile $fakefile]
		if {[string length $htmltext]<=0} {setLED red; dispMSG $msgText(error); return}
		renderTEXT [htmSplitter $htmltext] $datei $fakefile
		unset htmltext
		ProgressBar 0 0
		set dispSRC 1
	} else {
		set dispSRC 0
		ReLoad
	}
}

#shows HTMLsource in own TextEditor-Window (called from displayHTML)
proc renderTEXT {input datei cfile} {
    global mainHTML backColor fgColor etryBack htmlBG htmlFG sysFont
    #catch {$mainHTML clear}
	Clear
	SetDefColor
	set w $mainHTML
	frame $w.frame
	text $w.frame.text -background white -foreground black -insertbackground darkblue -relief sunken -bd 2 -wrap word -autosep 1 -yscrollcommand "$w.frame.scroll set"
	# -font $sysFont(6)
	$w.frame.text insert 0.0 [regsub -nocase -all {\n+|\x0d\x0a|\x0a\x0d|\x0a+|\x0d+} $input "\n"]

	frame $w.frame.edit
	button $w.frame.edit.close -image imClose -relief raised -command "destroy [subst "$w.frame"]"
	pack $w.frame.edit.close -side right -pady 1

	button $w.frame.edit.cut -image imCut -relief raised -command {event generate . <Control-x>}
	button $w.frame.edit.copy -image imCopy -relief raised -command {event generate . <Control-c>}
	button $w.frame.edit.paste -image imPaste -relief raised -command {event generate . <Control-v>}
	button $w.frame.edit.search -image imFind -relief raised -command searchMode
	button $w.frame.edit.save -image imSave -relief raised -command "saveText \[[subst "$w.frame.edit.etry get"]\] [subst "$w.frame.text"]"
	#CacheFile Entry
	entry $w.frame.edit.etry -textvariable cfile -background $etryBack -foreground $fgColor -relief sunken
	$w.frame.edit.etry insert 0 $cfile
	pack $w.frame.edit.cut $w.frame.edit.copy $w.frame.edit.paste $w.frame.edit.search $w.frame.edit.save -side left -pady 1
	pack $w.frame.edit.etry -side left -expand 1 -fill x -padx 1

	scrollbar $w.frame.scroll -command "$w.frame.text yview" -cursor {}
	pack $w.frame.edit -side bottom -fill x
	pack $w.frame.scroll -side right -fill y -padx 1 -pady 1
	pack $w.frame.text -expand 1 -fill both -padx 1 -pady 1
	pack $w.frame -expand 1 -fill both
	#Save and Close with RightMouse
#	bind $w.frame.edit.save <3> {
#		 saveText "\[$w.frame.edit.etry get\]" $w.frame.text
#		 destroy $w.frame
#	}

#OLD (without selectable Text):
#	if {[catch {$mainHTML parse "<BODY bgcolor=\"$htmlBG\" color=\"$htmlFG\"><plaintext>$input</plaintext>"} err]} {
#		#onError "$err DisplaySource Error"
#	}
}

#NEW160106:
proc renderHTML {input} {
        global mainHTML htmlBG
        #catch {$mainHTML clear}
	Clear
	SetDefColor
	if {[catch {$mainHTML parse "<BODY bgcolor=\"$htmlBG\">$input"} err]} {
#		onError "$err DisplaySource Error"
	}
}

#Ugh; the cruelest function(s) in the whole Program (cuts off a redirected Link to the real target URL)
proc cutLink {url} {
#Function for cutting away reDirected Links (so only "real" Link is resolved)
#Example: www.irgendwas.de/test/index.php?url=www.irgendwo.com/gfx.php&image=1 will be cutted to: www.irgendwo.com/gfx.php&image=1
        global baseurl mouseOver msgText cutLinks cutFiles remSTR chkCHR killCHR fTypes debug
		if {$url==""} {return ""}
		if {$debug>6} {puts "cutLink gets: $url"}
	set back $url
	set decode 0
if {[regexp -nocase {^file:/+|^/} $url]} {return $back}
if {[regsub -nocase -all {\.} $url {} dummy]<=2} {
   if {$cutLinks>0 && [string length $back]>6 && [regexp -nocase {^~*[a-zA-Z0-9]+=*~*$} $back] && ![regexp -nocase {\.|:|/|-|\?|&|%} $back]} {
		  set back [::base64::decode $back]
                  regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
                  regsub -nocase {&} $back {?} back
   		  return $back
   }
}
regsub -nocase -all {\\} $back {/} back
#NEW260806:
regsub -nocase -all {^[^h]ttp:/|^htp:/|^htt:/|^hhtp:/|^hhttp:/|^http:/ |^http:// } $back {http:/} back
regsub -nocase -all {^www,|^www-|^www|^wwwl|^ww\.|[^w]ww\.} $back {www.} back
regsub -nocase { } "$fTypes(HTML) SHTML SHTM PHTML PHTM ASPX" {|} ext
set base [lindex [split [regSTR $remSTR $back] /] 0]
#NEW020906: if NOT: www.somewhere.com/images/pic.php?galerie=www.someother.com/somehow/, but instead: www.somewhere.com/images/pic.php?galerie&www.someother.com/somehow/
#if {$cutLinks>0} {
#	regsub -nocase -all { } $fTypes(HTML) {|} ext
#	if {![regexp -nocase {\?.*=.*&} $back] && [regexp -nocase {&} $back] && [regexp -nocase $ext [lindex [split $back ?] 0]]} {
#		regsub -nocase {&} $back {=} back
#		set back [lindex [split $back &] 0]
#		set back [lindex [split $back =] end]
#	}
#}
	if {$cutLinks==2 || $cutLinks==3} {
		#regsub -nocase -all { } $back {} back
		set back [string trim $back]
#		regsub -nocase -all {:/} $back {://} back
set back [regchn $back]
		regsub -nocase -all {:///} $back {://} back
		if {[regexp -nocase {[=\?&]+http:/*.+$} $back]} {
			regsub -nocase -all {=http:/|&http:/|\?http:/} $back {http:/} back
		} elseif {[regexp -nocase {target=[a-zA-Z0-9=:/]+} $back]} {
			regsub -nocase -all {url=} $back {} back
		} elseif {[regexp -nocase {url=[a-zA-Z0-9=:/]+} $back]} {
			regsub -nocase -all {url=} $back {} back
		} elseif {[regexp -nocase {link=[a-zA-Z0-9=:/]+} $back]} {
			regsub -nocase -all {link=} $back {} back
		} elseif {[regexp -nocase {html=[a-zA-Z0-9=:/]+} $back]} {
			regsub -nocase -all {html=} $back {} back
		} elseif {[regexp -nocase {www\.|www[0-9]\.} $back]>1} {
			regsub -nocase {^www\.|^www[0-9]\.} $back {} back
			regsub -nocase -all {www\.|www[0-9]\.} $back {www.} back
		} elseif {[regexp -nocase {\.} [lindex [split $back =] end]]>1} {
			regsub -nocase {=} $back {} back
#			regsub -nocase {&} $back {?} back
			set back [lindex [split $back &] 0]
		} elseif {[regexp -nocase {.+www[0-9]*\.[a-zA-Z0-9]+\.[a-zA-Z][a-zA-Z]+} $back]>0 && [regexp -nocase {\?|&} $back]} {
			regsub -nocase -all {www} $back {www} dummy
	 		set hilf $dummy
	 		if {[regsub -nocase -all "$base" $dummy {} hilf]>1} {set dummy $hilf}
			set dummy [lindex [split $dummy ] end]
			if {[regexp -nocase "$ext$|/$" $dummy]} {
#                                regsub -nocase {\?|&} $dummy {} dummy
#                                set dummy [lindex [split $dummy ] 0]
                           	regsub -nocase -all {www\.|www[0-9]\.} $dummy {www.} back
			} elseif {[regexp -nocase {/[?&]+.*$} $back]} {
                                regsub -nocase {/[\?|&].*$} $back {/} dummy
                                set dummy [lindex [split $dummy ] 0]
                                regsub -nocase -all {\?|&} $dummy {} dummy
                                set dummy [lindex [split $dummy ] end]
					            regsub -nocase -all {=} $dummy {} back
			}
		} elseif {[regexp -nocase {.www[0-9]\.} $back]>0 && [regexp -nocase {\?|&} $back]} {
#                        set idx [string first {www[0-9]\.} $back]
			regexp -nocase -indices {www[0-9]\.} $back idx
			set idx [lindex [split $idx] 0]
                        set dummy [string range $back $idx end]
#puts "Dummy2: $dummy $idx"
	  		   			if {[regexp -nocase "$ext$|/$" $dummy]} {
                                    regsub -nocase {\?|&} $dummy {} dummy
                                    set back [lindex [split $dummy ] 0]
                        } elseif {[regexp -nocase {/[\?&].*$} $dummy]} {
                                    regsub -nocase {/[\?&].*$} $dummy {/} dummy
                                    set dummy [lindex [split $dummy ] 0]
				    set back $dummy
                        }
		}
		set back [lindex [split $back ] end]
	}
#puts "BACK: $back"
	set back [string trim $back ]
    if {[string length $back]>12 && [regexp -nocase {^~*[a-zA-Z0-9]+=*~*$} $back] && ![regexp -nocase {\.|:|/|_|-|\?|&|%} $back]} {
		  set help $back
		  set back [::base64::decode $back]
    } elseif {[string length $back]>6 && [regexp -nocase {=*~*[a-zA-Z0-9]+[=\?&%~]*.*$} $back] && ![regexp -nocase {\.|:|/|_|-|\?|&|%} $back]} {
	  	  if {[regexp -nocase {=~*[a-zA-Z0-9]+=*~*} $back]} {
		  	  regsub -nocase -all {~*[a-zA-Z0-9]+$} $back {} dummy
#		  	  regsub -nocase "^$dummy" $back {} back
			  set back [string range $back [string length $dummy] end]
			  set decode 1
       	  	  set back [::base64::decode $back]
       	  	  set back [acode decode $back]
	  	  } elseif {[regexp -nocase {^~*[a-zA-Z0-9]+=*~*} $back] && ![regexp -nocase {\.|:|/|_|-|%} $back]} {
		  	  regsub -nocase -all {\?|&|%|=} $back {} back
		  	  set back [lindex [split $back ] 0]
  			  set decode 1
			  set back [::base64::decode $back]
       	  	  set back [acode decode $back]
		  }
    } elseif {[string length $back]>12 && [regexp -nocase {=*~*[a-zA-Z0-9]+[=\?&%~]*.*$} $back] && ![regexp -nocase {\.|:|/|_|-|%} $back]} {
		  	  regsub -nocase -all {\?|&|%} $back {} back
		  	  set back [lindex [split $back ] 0]
			  set decode 1
			  set back [::base64::decode $back]
       	  	  set back [acode decode $back]
    }
#puts "BAK2: $back"
	if {$cutLinks==1 || $cutLinks==3} {
		regsub -nocase -all $chkCHR $back {} back
		set back [lindex [split $back ] 0]
	}
	if {$cutFiles==1} {
		set dummy [split $back /]
		set len [llength $dummy]
		if {$len>0} {
			set len [expr $len - 1]
#			set back [string trimright [join [lrange $dummy 0 $len] /]/]/
			set back [string trim [join [lrange $dummy 0 $len] /]]
		}
	}
#NEW140206: if ext = .htm do NOT use query (added by "&")
	if {$cutLinks>0} {
		if {[regexp -nocase {\.htm&|\.html&|\.shtml&} $back]} {
			set back [lindex [split $back &] 0]
		}
	}
	regsub -nocase -all {|"|'} $back {} back; #"
#NEW210106:
#	regsub -nocase -all {:/} $back {://} back
set back [regchn $back]
	regsub -nocase -all {:///} $back {://} back
	regsub -nocase -all {/\+\+$} $back {/} back
	#NEW020706:
	if {[regexp -nocase {&} $back] && ![regexp -nocase {\?} $back]} {
		regsub -nocase {&} $back {?} back
	}
	regsub -nocase -all {^&|^\?|^ |^\+|^\-|&$|\?$| $|\+$|\-$|^%20|^ |%$} $back {} back
	regsub -nocase -all {&&+} $back {\&} back
#puts "BAK3: $back"
#NEW111106:
	set help 0
	if {$cutLinks>0} {
		regsub -nocase -all {%[a-zA-Z]+=*.*$|^[a-zA-Z0-9]+=} $back {} back
		regsub {\.shtml.*$} $back {.shtml} back
		regsub {\.html.*$} $back {.html} back
		regsub {\.phtml.*$} $back {.phtml} back
		regsub {\.phtm.*$} $back {.phtm} back
		regsub {\.aspx.*$} $back {.aspx} back
		regsub {\.htm[^l]*$} $back {.htm} back
		regsub -nocase -all $killCHR [regSTR $remSTR $url] {} chk
		set dummy [lindex [split [regSTR $remSTR $back] /] 0]
		set kill "^\\?|^&|$killCHR"
		regsub -nocase -all $kill $dummy {} try
		if {([regexp -nocase "^$try" $chk] || $try==$chk) && [regexp -nocase {/*\?.+=.+\..+$|/*&.+=.+\..+$} $back]} {
		   set back [cutLink2 $url]
#puts "BAKx: $back"
		   set help 1
		} else {
			#NEW261206:
			if {$decode>0 && [regexp -nocase {^https*:/} $back] && [regexp -nocase {index\.ht*$} $back]} {
			   set dummy [lindex [split $back /] end]
			   regsub -nocase $dummy$ $back {} back
#			   set back [string trimright $back /]/
			} elseif {$decode<=0} {
		       regsub -nocase {%[a-zA-Z]+=.+$} $back {} back
  			   regsub -nocase -all {\.html[\?&%]+.+$} $back {.html} back
  			   regsub -nocase -all {\.htm[\?&%]+.+$} $back {.htm} back
			}
		}
		if {[regexp -nocase -all {\.} $back]<=1 && ![regexp -nocase {http:/} $back]} {set back $url}
	}
	#NEW160906:
	if {$help<=0} {regsub -nocase -all {\.fhg/\?.*$|\.fhg\?.*$|\.fhg/&.*$|\.fhg&.*$} $back {.fhg} back}
        regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
        regsub -nocase {&} $back {?} back
if {$debug>6} {puts "cutLink returns: $back"}
	return [string trim $back]
}

#NEW291106:
proc cutLink2 {url} {
    global cutLinks cutFiles remSTR chkCHR fTypes debug
    if {$url==""} {return ""}
	if {$debug>6} {puts "cutLink2 gets: $url"}
#	regsub -nocase { } "$fTypes(HTML) SHTML SHTM PHTML PHTM ASPX" {|} ext
	set back $url
	if {[regsub -nocase -all {\.} $url {} dummy]<=2} {
	    if {$cutLinks>0 && [string length $back]>6 && [regexp -nocase {^~*[a-zA-Z0-9]+=*~*$} $back] && ![regexp -nocase {\.|:|/|_|-|\?|&|%} $back]} {
			  	set back [::base64::decode $back]
                                regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
                                regsub -nocase {&} $back {?} back
				return $back
		}
 	}
 	set decode 0
	if {$cutLinks>0} {
		regsub -nocase -all {\\} $back {/} back
		#NEW260806:
		regsub -nocase -all {^www,|^www-|^www|^wwwl|^ww\.|[^w]ww\.} $back {www.} back
		regsub -nocase -all {[a-zA-Z]+:/+} $back {} back
#		set base [lindex [split $back /] 0]
		regsub -nocase -all {\-} $back {} back
		regsub -nocase -all {==} $back {} back
		regsub -nocase -all {=~$} $back {} back

#		if {![regexp -nocase {=} $back]} {regsub -nocase -all {\?|&} $back {=} back}
regsub -nocase -all {\?|&} $back {=} back

		set dummy [split $back =]
set base [lindex $dummy 0]
regsub -nocase -all {\?|&.+$} $base {} base
		set back ""
		set help ""
		foreach inhalt $dummy {
#puts "$cutLinks Inhalt: $inhalt"
				if {[regexp -nocase {^[a-zA-Z0-9]+\.[a-zA-Z0-9]+\.[a-zA-Z][a-zA-Z]*|^[a-zA-Z0-9]+\.[a-zA-Z][a-zA-Z]*} $inhalt]} {
						if {$cutLinks==3} {
								regsub -nocase -all {\?|&} $inhalt {} inhalt
								set help [lindex [split $inhalt ] 0]
								if {[string length $help]>[string length $back] && [chkEXT [transType $help]]} {set back $help}
						} elseif {$cutLinks==2} {
					  		 	if {[regexp -nocase $base $inhalt]} continue
								regsub -nocase -all {\?|&} $inhalt {} inhalt
								set help [lindex [split $inhalt ] 0]
								if {[string length $help]>[string length $back] && ([chkEXT [transType $help]] || [regexp -nocase {\.|/} $help])} {set back $help}
						} elseif {$cutLinks==1} {
							    regsub -nocase -all $inhalt $back {} help
							    if {$help==""} {set help $inhalt}
   								if {[string length $help]>[string length $back] && [chkEXT [transType $help]]} {set back $help}
						}
#puts "HELP: $help"
				} elseif {[string length $inhalt]>12 && [string length $inhalt]>[string length $back] && [regexp -nocase {^~*[a-zA-Z0-9/]+=*~*$} $inhalt] && ![regexp -nocase {\.|:|_|-|\?|&|%} $inhalt]} {
					 #URL may be encoded
 					 regsub -nocase -all {$} $inhalt {=~} inhalt
					 regsub -nocase -all {=|} $inhalt {==} inhalt
#puts "INHALT: $inhalt"
					 set help [::base64::decode $inhalt]
        	  	  	 set help [acode decode $help]
					 if {[regexp -nocase {^[a-zA-Z]+:/+|^ww|.+/.*|\?|&|^.+\.[a-zA-Z0-9]+} $help]} {set decode 1; set back $help}
		 	 	}
#puts "BACK: $back"
		}
		regsub -nocase -all {} $back {-} back
	    regsub -nocase -all {$} $back {=~} back
		regsub -nocase -all {=|} $back {==} back
		regsub {%.+$|%$} $back {} back
	}
	if {[string length $back]<=0 || ![regexp -nocase {\.|/} $back]} {set back $url}
        #NEW261206:
	if {$decode>0 && [regexp -nocase {^https*:/} $back] && [regexp -nocase {index\.ht*$} $back]} {
	   set dummy [lindex [split $back /] end]
	   regsub -nocase $dummy$ $back {} back
#	   set back [string trimright $back /]/
	} elseif {$decode<=0} {
		#NEW311206: cut only beginning
		if {$cutLinks==2} {
			regsub -nocase $back $url "$back" url
			set back [lindex [split $url ] end]
			regsub -nocase {/&} $back {/?} back
			regsub -nocase -all {%26|\*} $back {\&} back
		    regsub -nocase {%[a-zA-Z]+=.+$} $back {} back
  			   regsub -nocase -all {\.html[\?&%]+.+$} $back {.html} back
  			   regsub -nocase -all {\.htm[\?&%]+.+$} $back {.htm} back
		}
	}
	if {[regexp -nocase -all {\.} $back]<=1} {set back $url}
#	regsub -nocase -all {} $back {} back
	set back [lindex [split $back ] end]
	regsub -nocase -all {\.fhg/\?.*$|\.fhg\?.*$|\.fhg/&.*$|\.fhg&.*$} $back {.fhg} back
        regsub -nocase {/%} $back {/?} back
        regsub -nocase -all {\?|%3F|%26|\*|/&} $back {\&} back
        regsub -nocase {&} $back {?} back
if {$debug>6} {puts "cutLink2 returns: $back"}
	return $back
}

proc setGamma {wert} {
#sets GammaControl for Images within HTMLwidget (rightMouse on Zoom+/-)
	global gamma MapMode
	if {$MapMode==4} return
	set merk $gamma
	switch -regexp $wert {
		dark {
			if {$gamma>0.1} {set gamma [expr $gamma - 0.1]}
		}
		light {
			if {$gamma<2} {set gamma [expr $gamma + 0.1]}
		}
		[0-9] {
			set gamma $wert
		}
		default {
			set gamma 1
		}
	}
	if {$gamma!=$merk} {gammaHTM $gamma}
}

proc gammaHTM {gamma} {
	global htmlIDX activeHTM Images
	foreach search $htmlIDX($activeHTM) {
		if {[info exists Images($activeHTM,$search)]} {
			set memgfx $Images($activeHTM,$search)
			if {[string length $search]>0} {::$memgfx configure -gamma $gamma}
		}
	}
	catch {unset search memgfx}
}

proc getParsed {datei} {
	global cancel fileTypes
	if {![chkEXT .[string trim [getEXT $datei] .]]} {return}
	set htmlpage [ReadFile $datei]
	set htmlpage [preParse [splitHTM $htmlpage]]
	set htmlpage [split $htmlpage \n]
	set srcfiles ""
	set fsize 0
	foreach zeile $htmlpage {
		if {$cancel==1} {break}
		if {[regexp -nocase { href} $zeile]} {
			set href [reslvURL [getValue href $zeile] 1]
			if {[string length $href]<=0} {set href [reslvURL [getValue src $zeile] 1]}
			set ext [getEXT $href]
			if {[reGrep $ext $fileTypes]>0} {
				#WENN FileType in HREF enthalten (bei PHP)
				set dummy [getFileURL $href 0]
				if {[string length $dummy]>0} {
					catch {file size $dummy} fsize
					lappend srcfiles [list $fsize $dummy]
				}
			} else {
				#WENN FileType in SRC enthalten (meist bei HTML)
				set src [reslvURL [getValue src $zeile]]
				set ext [getEXT $src]
				set dummy [getFileURL $src 0]
				if {[string length $dummy]>0} {
					catch {file size $dummy} fsize
					lappend srcfiles [list $fsize $dummy]
				}
			}
		} elseif {[regexp -nocase {img} $zeile] && [regexp -nocase {src} $zeile]} {
			#WENN FileType in SRC enthalten (meist bei HTML)
			set src [reslvURL [getValue src $zeile] 1]
			set ext [getEXT $src]
			if {[reGrep $ext $fileTypes]>0} {
				set dummy [getFileURL $src 0]
				lappend srcfiles $dummy
			} elseif {[chkEXT $ext]} {
				set dummy [getFileURL $src 0]
				if {[string length $dummy]>0} {
					catch {file size $dummy} fsize
					lappend srcfiles [list $fsize $dummy]
				}
			}
		}
	}
	return $srcfiles
}
