package provide FIQIRC 1.0
#FIQIRC V260904
#IRC Functions 4 Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

proc displayIRC {} {
	global normLight tagStyle msgText
	set window .tile.top.irc.tile.ircDir.dir
	set ircDir $msgText(irc.dir)
	set ircIMG {imWorld}
	set i 1
	set x 4
	foreach inhalt $ircDir {
		set inhalt [string trim $inhalt]\n
		$window image create $i.0 -image [lindex $ircIMG [expr $i - 1]] -padx $x -pady 1
		$window insert $i.1 $inhalt $i
		if {$i > 1} {
			$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(bold)"
			$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(normal)"
		}
		#ActionBindings on every TextTag (What should happen, if User Clicks on Tag)
		#$window tag bind $i <1> [subst "openTag $win $i"]
		#$window tag bind $i <3> [subst "selectTag $win $i"]
		incr i
		set x 10
	}
	unset i x
}

#MapMode=5; IRCmode
proc MapIRC {} {
	global mainHTML backColor normColor normLight fgColor
	.imHTTPS configure -image imIRC -background $backColor
	pack forget .tile.top.ftp
	pack forget .tile.top.html
	pack .tile.top.irc -fill both -expand true
	focus .head.dispUrl.url
	#ReadOnly entfernen
	.tile.bottom.foot.box.selected configure -state normal
}

