package provide FIQVAR 1.0
#FIQVAR.tcl
#Initialize Variables needed by Inquisitor

set version "Frenzy's Inquisitor V160711"
#Set BrowserIdentifier
set HTMLuseragent "Mozilla/5.0 (compatible; Inquisitor/FIQ160711; $system)"
set HTMLreferer ""
set refererBACK ""
set cookie ""
set cookieHeader ""
set cookieCount 0
set favicon ""
#Timeout 4 HTTP-Connection (ACHTUNG, wird auch WHREND bertragung gezhlt !)
set HTMLtimeout 36000
#Additional HTTP-Header (wird je Request mitgesendet)
#set HTMLheader "Pragma no-cache Cache-control no-cache Accept-Encoding {x-gzip, gzip, identity} Accept-Charset iso-8859-15 Accept-Language de"
#set HTMLheader ""
#set HTMLheader "Pragma no-cache Cache-control no-cache Accept-Encoding {x-gzip, gzip, identity} Accept-Charset iso-8859-15 Accept-Language de Connection keep-alive"
set HTMLheader "Pragma no-cache Cache-control no-cache Accept-Encoding {x-gzip, gzip, identity} Accept-Charset iso-8859-15 Accept-Language de Keep-Alive 300 Connection keep-alive"
#set HTMLheader "Connection Keep-Alive Accept-Encoding {x-gzip, gzip, identity} Accept-Charset iso-8859-15 Accept-Language de"
#Accept-Header(s) (IMG/HTML-File)
set HTMLnorm "text/*, image/jpeg, image/png, image/*, */*"
set HTMLimg "image/x-xbm, image/png, image/jpeg, image/x-xpm, image/tiff, image/x-bmp, image/gif"
#set HTMLimg ""
set HTMLAccept $HTMLnorm
set HTMLmethod "GET"
set HTMLaction ""
set HTMLquery ""
set HTMLenter ""
set HTProxy(serv) ""
set HTProxy(port) ""
set HTMLpwd ""
set metaREDIR ""
set merkDOM ""
set sync {0 2 4 6 8 12 16 20 24 28 32 36 40 44 48 52 56 60 64 68 72 76 80 84 88 92 96 98}
set chunk {1024 2048 3072 4096 5120 6144 7068 8192 9216 10240 12288 14336 16384 18432 20480 24576 28272 32272 36368 40960 48000 52624 56544 58602 60650 62698 64746 72892 80432 96816 109248 101024 102048 103072 104096 105120 106144 107068 108192 109216 110240 112288 114336 116384 118432 120480 124576 128272 132272 136368 140960 148000 152624 156544 158602 160650 162698 164746 172892 180432 196816}
set blocksize 16384
set merkName ""
set merkValue 0
set marqSwap 0
set htmlDIR 0
#NEW160706: miniImages for TextLinks (VERY slowly if set to 1 !!!!) used at bottom of PreParser
set textIMG 0
set noTimeout 0
set saveTimeout 0
set compltCache 0
set downMode 0
set visitedGFX ""
set moved 0
set fileOK 0
set thumbsOnly 0
set silentHTM 1
set tempIcons 1
set firstStart 0
#PHPlinks in SelectBox anzeigen (z.B. bei Filmposter-Archive)
set showPHPlinks 0
#synchron/Asynchron-Mode 4 multiple File Requests (currently up to 98 simultan requests at the same time)
set HTMLsync 32
set DOWNsync 6
# HistoryList
set idxHistry 0
set histry ""
set imgHistry ""
set urltext ""
set filter [list "irgendwasunmgliches"]
set baseurl(local) ""
set baseurl(remote) ""
set baseurl(internal) ""
set reqURL ""
set activeBase "irgendwasunmgliches"
set htmlTD ""
set htmlIMG ""
set htmlIDX(local) ""
set htmlIDX(remote) ""
set htmlIDX(internal) ""
#Remove/CheckStrings for URL/authority
set remSTR {http:/+ https:/+ ftp:/+ file:/}
set chkSTR {http:/|https:/|ftp:/|file:/|mailto:/}
set chkCHR {\?|&|\#|;|,|%35|%26|%23|%3D|%3B}
set killCHR {^\+|\(+|\)+|\*+|\\+|^\-+|\[+|\]+|\{+|\}+|:url\(}
set codeCHNG {/%3F|/%26|%3F|%26|/\?|/&|\?|&|;|%3B|%3A%2F%2F|%3A%2F}
#used 2 resolve same fileTypes (nearly same as transType but faster) 4 getLink, getThumb, and link2thumb
set typeCHNG {\.jp(e*)g|\.([spx]*)htm(l*)|\.asp(x*)|\.php([0-9]*)|\.mp(e*)g}
#Set FilterVariables used with FICS (TM)
set ficsVars {buttom\.|bottom\.| click|recip|werb|comerc|commerc|purchas|hold| space|spacer\.|seperat|dummy|counter|tracker|traq}
#FilterDomain/FICS (TM) Variables (ATTENTION: NO Images will shown, which contain one of these keywords !)
set filtVars {analytics.com|!(ftv)cash.com|datinggold.com|fayno-content.com|tracking.com|hit.+now.com|/newdiz/spacer.gif|traffanalyzer.com|protect.+x.com|hitbox.com|counter.com|counter.net|counter.cgi|count\.|tracker.com|tracker.net|mystats|spylog.com|hotlog.ru|masterstats.com|web.+stat.com|webstat.com|hitslog.com|freestats|feedburner|clicktraq|clicktrack.com|extreme.+dm.com|extremetracking.com|porntrack.com|stats[0-9]+\.[a-zA-Z]+track\.com|livejasmin.com}
#MainHTMLwidget (Frame)
set activeHTM local
set mouseOver local
set HTMLwin(local) ".tile.top.html.tile.html.pane.left.hold.local"
set HTMLwin(remote) ".tile.top.html.tile.html.pane.rght.hold.remote"
set mainHTML $HTMLwin(local)
set movement(local) ""
set movement(remote) ""
set HTMLactive(local) ""
set HTMLactive(remote) ""
set HTMLactive(internal) ""
set HTMLurl(local) ""
set HTMLurl(remote) ""
set HTMLurl(internal) ""
set formOptions ""
set menuEntrys ""
set LastFile(local) ""
set LastFile(remote) ""
set LastFile(internal) ""
#Liste aller erstellten Frames (HTMLwidgets); wird in "createHTML" jeweils dazu addiert
set frameHTML ""
set iFrames ""
set jScripts ""
set fonts ""
set lastFont ""
set fontcount 0
set shiftPress 0
set command $argv
set smallStyle 1
set linkmark 0
set createMirror 0
#getFavIcon: 1=BEFORE HTML, 2=AFTER HTML, 0=OFF
set getFavIcon 1
#Write temporary FavIcons, if Server gives no FavIcon
set writeTempIcons 0
#Mark LinkType with MiniIcon
set markIcons 1
#maxImgSize used for autoscrolling (norm: maxImg 268, 280)
set maxImgSize 300
#je hher minImgSize, desto weniger wird Autogescrollt (scrollt bei 150 mehr, als bei 170)
set minImgSize 172
#Max. ImageSize 4 mark (grey, light and selection)
set maxMarkSize 340
#set maximum Images 4 Zoom
set maxZoomImg 60
#auto shrink (half) Image if height > XYZ, only when ThumbsOnly Set (0=off)
set shrinkBigSize 420
set imScroll 0
set tableCorrect 0
# InetVerbindung Stop/Active
set cancel 0
set active 0
set dispSRC 0
set rubber 0
set rubberX1 0
set rubberY1 0
set rubberX2 0
set rubberY2 0
set child .
# ProgressBar Vorbelegung
set anzGFX 1
set zlrGFX 0
set anzSEL 00
set synCount 0
set rbytes($synCount) 0
set tbytes($synCount) 1
set bytesTotal 0
set ByteCount 0
set maxBytes 1048576
set waitID 0
set waitLED 0
set err 0
set errNo 0
set errMerk 0
set infostatus "Ready."
#set HTMLwidget ClearMethod
set cleanHTML 1
set htmldisplay ""
set currentFile ""
set selected ""
set buffer ""
set token ""
set tokCount 0
set header ""
set toknHandles ""
set onLink 0
set newPage 0
set styleParsed 0
set URLvalue ""
set URLvalueIDX 0
set frozenURL ""
set HTMLsplit ""
set user ""
set pwd ""
set applet ""
set video ""
set sound ""
set picture ""
set bgImage ""
set mediaCTRL 1
set videoSize 400
set getCSS 0
set getBG 0
set chkWait 0
#WENN "grabMode" aktiv , DANN "FICS" nicht benutzen, weil sonst u.U. Datei aus Cache benutzt wird !
set grabMode 0
#Zhler Seiten-"Tiefe" (Max. Anzahl erl. Weiterleitungen von BaseSeite an gezhlt)
#geCapturete Seiten knnen bei maxDepth=0 dennoch angezeigt werden (zumindest einige) !
set maxcount 0
set maxDepth 3
set globalCount 0
#Infiltrator Mode (0=Off)
set ignoreReDir 0
#AnimationDelay (HTML)
set ANIdelay 190
#and a seperate Delay for TUX (140=norm)
set GIFdelay 140
# ChoseDestinationDirectory
set lastDir $homeDir
set destDir $homeDir
set dirList ""
set idxDirlist 0
set cacheLocation $homeDir
#set lastDirHome $lastDir
set anzDest 0
set home ""
set merkScan ""
set returnValue 0
#DummyIMG 4 "Zoom"/DisplWhileDownload-Mode anlegen
image create photo dummyIMG
image create photo imSkin
set skinFile ""
set imgSize 2
set vSize(local) "0x0"
set vSize(remote) "0x0"
set imFavIcon imClrURL
set inifile [string trimright $homeDir /]/FIQ.INI
set cfgfile [string trimright $homeDir /]/FIQ.CFG
set cacheSpace 102400
set destSpace 102400
set underlineHyper 1
set showTableStruct 0
set showImages 1
set playAnim 0
set onceAnim 1
set playSounds 1
set onceSounds 1
set zoomText 0
set quickSave 1
set changeBack 1
set backImage 0
set useApplet 1
set useVideo 1
set useBlink 1
set stream 1
set fsizeWarn 0
set fics 2
set divZoom 0
set kidZprotect 0
set merkFics $fics
set ficsText "Normal"
set askServer 1
set autoConfig 0
set fontsize 3
set useSiteFonts 1
set cCompress 0
set cClean 400
set dayClean 0
set ImageIDX(local) ""
set ImageIDX(remote) ""
set ImageIDX(internal) ""
set TableIDX(local) ""
set TableIDX(remote) ""
set TableIDX(internal) ""
set altTAG(local) ""
set altTAG(remote) ""
set altTAG(internal) ""
set accept 80
set dontaccept 50
#Minimum FileSize to recognize as desired Image (used by downPic); norm = 22000
set minFileSize 22000
set renderUPD 1
#HTML-Seite vorab, whrend GFX Download anzeigen
#(0=erst wenn Seite komplett geladen, 1="vorab anzeigen", wie z.B. "Konqueror")
set renderIMG 1
set keepColor 1
set tableOnly 0
set variTime 0
set variHead 0
set debug 0
set otherWarn 1
set followLinks 0
#Should Frames used ?
set useFrames 0
set cutLinks 1
set cutFiles 0
set showDecode 0
set unused 0
set cutGfx 1
set unknownGFX 1
set bHelp 1
set speedCache 1
#Application HexColors
set backColor "#0061A8"
set fgColor   "#FFFFFF"
set barColor  "#00008B"
set normLight "#3881C8"
set etryBack  "#4891D8"
set listColor "#003178"
set htmlBG    "#61A2FF"
set htmlFG    "#000028"
set actColor  "#FFFFFF"
set merkColor(backColor) $backColor
set merkColor(fgColor) $fgColor
set merkColor(normLight) $normLight
set merkColor(etryBack) $etryBack
set merkColor(listColor) $listColor
set merkColor(htmlBG) $htmlBG
set merkColor(htmlFG) $htmlFG
set merkColor(barColor) $barColor
#Set only BGcolor if not set previously (maybe in Frame) wil reset on clearPage
set colorSet 0
#ConfigColors
set gamma 1
#Frames
set FRMrows ""
set FRMcols ""
set zlrFRM 0
set merkX 0
set merkY 0
set MapMode 3
set MMode 3
set sMode 1
set iMode 1
set rMode 1
set sMerk 0
set tokenlist(local) ""
set tokenlist(remote) ""
set tokenlist(internal) ""
set tokenmerk(local) ""
set tokenmerk(remote) ""
set tokenmerk(internal) ""
#MultipleSavePageDialogue
set value(kind) 1
set value(with) 1
set remoDir ""
set FTPpreview 1
set prevSize 8
set thumbSize 1
set crtThumbs 0
set FTP(local) ""
set FTPinput ""
set FTPdebug 0
set FTPask 1
set FTPedit 0
set FTPhost(local) ""
set FTPuser(local) "anonymous"
set FTPpass(local) "Frenzy@Softworks.de"
set FTPport(local) 21
set FTPstatus(local) ""
set FTPdir(local) ""
set FTPhome(local) $homeDir
set FTPanz(local) 00
set FTPdest(local) $destDir
set FTPimages(local) ""
set FTPfilesize(local) 0
set FTPhistry(local) ""
set FTPidx(local) 0
set FTP(remote) ""
set FTPhost(remote) ""
set FTPuser(remote) "anonymous"
set FTPpass(remote) "Frenzy@Frenzy-Softworks.de"
set FTPport(remote) 21
set FTPstatus(remote) ""
set FTPdir(remote) ""
set FTPhome(remote) $homeDir
set FTPanz(remote) 00
set FTPdest(remote) ""
set FTPimages(remote) ""
set FTPfilesize(remote) 0
set FTPhistry(remote) ""
set FTPidx(remote) 0
set FTPmode "active"
set FTPsort 1
set FTPrealprev 0
#Experimental (Render FTPdir into HTMLwidget=1, instead of TEXTwidget=0)
set FTPrender 0
#specifies, how to render the FTPdirectory into which Widgets (TEXT/HTML-Widget)
set merkDest ""
set merkRemo ""
set BookMarks ""
set bookMerk ""
set bookName ""
set anzBook 00
set pipe 0
set buttons 0
set mainButtons 22
set miniButtons 16
set mainButtonSize 1
set mainGroove ridge
set menuSize 0
set hideMenu 0
#SelectedTagsStyles (Mark on MouseMove); will changed too while loading Config or SkinColors
set tagStyle(bold) "-background $normLight -relief raised -borderwidth 1"
set tagStyle(normal) "-background {} -relief flat"
#Only for SelectBox (MouseOverTag)
set tagStyle(mark) "-foreground $fgColor -background $normLight -relief raised -borderwidth 1"
set tagStyle(unmark) "-foreground {} -background {} -relief flat"
set tagIDX 0
set language 1
set config [list $underlineHyper $showTableStruct $showImages $zoomText $quickSave $changeBack $backImage $useApplet $fsizeWarn $thumbsOnly $useFrames $renderIMG $keepColor $ignoreReDir $tableOnly $autoConfig $fontsize $playAnim $onceAnim $playSounds $onceSounds $FTPask $bHelp $useVideo $otherWarn]

#NEW111106: DANGEROUS URLs/FileTypes:
set fTypes(Danger) {\.EXE$|\.BAT$|\.SYS$|\.BIN$|\.OCX$|\.VBS*$|\.JS$}
set fTypes(DDOM) {codec.com|ivideo.com|passthison.com|rapidblaster.com|codecs.com|activexmediaobject.com|multimediaobject.com|mediaobjectguide.com|iesafetywarning.com|uptodateprotect.com|allsecuritysite.com|todaysfreevideo.com|checkssecurity.com|cleansoftwares.com|protectionszone.com|entertainingzone.com|outgates.com|atruesecurity.com|atotalsafety.com|allprotections.com|vaxobject.com|activexsite.com|generateskey.com|mediaobjectsite.com|activeximage.com|pornmaggalleries.com|fpctraffic.com|buy404s.com|realfreevideos.com|hiddenserver.com}
set blacklistDIR ""
#global known FileTypes for Download (NormalMode)
set fileTypes {*}
set fTypes(Images) {JPG GIF TIF PCX TGA BMP PNG ICO XPM XBM SGI SUN PPM}
set fTypes(Audio) {WAV MP3 VOC SAM SMP SND AIF WMA RAW MID RMI SMF KAR MPA AAC AMC M4A}
set fTypes(Video) {AVI MPG MOV MQV DVX WMV MP4 M1V M4V MPV MPA MPE ANI FLI FLC VFW SWA QT}
set fTypes(Text) {TXT DOC RTF PDF GS PS EPS}
set fTypes(Tables) {XLS DBF SQL}
set fTypes(HTML) {HTM CFM XML PHP CGI ASP MSP JSP SHT DTD PLEX DLL CSS JS}
set fTypes(Applets) {SWF SPL RMF RMP RA RM RV RMV RMJ RMS RAM RAX RVX RP RTX RMX RMM XPL FLV WMX ASF ASX WAX WVX WPL PLS M4P M3U RTS SDP}
set fTypes(Archives) {ZIP RAR TGZ TAR LHA LZA BZ2 GZ}
set fTypes(All_Files) [concat $fTypes(Images) $fTypes(Audio) $fTypes(Video) $fTypes(Text) $fTypes(Tables) $fTypes(HTML) $fTypes(Applets) $fTypes(Archives)]
#Logical FileType-Groups (4SpinBox; NormalMode)
set Stype [concat {"All Selected" All_Files Images Audio Video Text Tables HTML Applets Archives} $fTypes(All_Files)]
set sTypeZlr 0
set prefType "All Selected"
#Variable (NonNumeric Scan for ScannerMode)
set ftype {Numeric "Var. a-z" "From File" "Month" "Monat" "Day" "Tag" "Date" "Datum"}
set cutType "All Selected"
set convert "None"
set scanType {Numeric}
set scanFile 1
set scanLen 3
set scanCreate 0
set selStart 0
set selStop 1
set sendCookies 1
set writeCookie 0
#AutoScroll: 0=OFF; 1=ON; 2=ON+Scroll on Click
set autoscroll 1
set translateFiles ""
#Save Window (Sash) Positions ?
set winPos 1
set wins {.tile .tile.top .tile.top.html.tile.bookmark .tile.top.html.tile.html.pane.left}
#set wins {.tile .tile.top .tile.top.html.tile.html.pane.left}
set volumes [string toupper [lrange [file volume] 0 end]]
#nCGI-Mapping (used for encoding/decoding of HEXmapping used by cgiDecode/cgiEncode):
#taken from the nCGIpackage of TCLLIB (so we do not use the WHOLE package)
for {set i 1} {$i <= 256} {incr i} {
	set c [format %c $i]
	if {![string match \[a-zA-Z0-9\] $c]} {
	    set map($c) %[format %.2X $i]
	}
}
array set map {
	" " +   \n %0D%0A
}

#Check 4 OperatingSystem
if {[regexp -nocase -all {linux} $system] || [regexp -nocase -all {unix} $system]} {
#OperatingSystem is Linux
	set buttonSize 16
	set FTPbuttonSize 4
	set HTMbuttonSize 15
	set trashSize 16
    set winSYS 0
#	set sysFont(0) "Arial 8 bold"
#	set sysFont(1) "Times 8"
#	set sysFont(2) "Arial 7"
#	set sysFont(3) "Arial 7 bold"
#	set sysFont(4) {"gothic i" 8}
#	set sysFont(5) "Times 7 bold"
#	set sysFont(6) "clean 8 bold"
#	set sysFont(7) "arial 10 bold"
	set sysFont(0) "Monospace 9 bold"
	set sysFont(1) "Monospace 9"
	set sysFont(2) "Monospace 8"
	set sysFont(3) "Monospace 9"
	set sysFont(4) {"Monospace i" 9}
	set sysFont(5) "Monospace 8 bold"
	set sysFont(6) "Monospace 9 bold"
	set sysFont(7) "Monospace 11 bold"
    set FTPfont(0) 15
    set FTPfont(1) 13
    set FTPfont(2) 11
    set FTPfont(3) 9
    set FTPfont(4) 8
    set FTPfont(5) 7
    set FTPfont(6) 6
	set bookWidth 158
	#Space between Panels/CheckboxBG
	set space 2
	set padv 2
	set btnPress green
} else {
#OpperatingSystem is Windoze, or Macintrash (or maybe the great Amiga ?)
        catch {package require optcl}
        #package require zlib
		set blocksize 56544
        #Menus/Labels/etc
		set buttonSize 13
		set FTPbuttonSize 6
		set HTMbuttonSize 9
        set trashSize 16
		set winSYS 1
		set sysFont(0) "Arial 8 bold"
		set sysFont(1) "Times 9"
		set sysFont(2) "clean 8 bold"
	    set sysFont(3) "Arial 8 bold"
		set sysFont(4) {"gothic i" 8}
		set sysFont(5) "clean 6 bold"
		set sysFont(6) "helvetica 8 bold"
		set sysFont(7) "arial 12 bold"
        set FTPfont(0) 13
        set FTPfont(1) 12
        set FTPfont(2) 11
        set FTPfont(3) 10
        set FTPfont(4) 9
        set FTPfont(5) 8
        set FTPfont(6) 7
		#set bookWidth 146
		set bookWidth 165
		#Space between Panels/CheckboxBG
		set space 3
		set padv 3
		set btnPress $backColor
}

#PlungINs decoding List: shortName Class RealName GUID MIMEtype(unused) FileType(s)
set plugINs {
	{"SWF" "ShockwaveFlashObjects" "ShockwaveFlash.ShockwaveFlash.9" "D27CDB6E-AE6D-11CF-96B8-444553540000" "application/x-shockwave-flash" {SWF SPL FLV}}
	{"WMV" "WMPLib" "WMPlayer.OCX.7" "6BF52A52-394A-11D3-B153-00C04F79FAA6" "video/x-ms-wmv" {AVI MPG DVX WMV M1V MPA MPE MP4 WAV MP3 WMA WMX MID RMI ASF ASX WAX WPL M3U}}
	{"MOV" "QTActiveXPlugin" "QuickTime.QuickTime.4" "02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" "video/x-Quicktime" {AVI MPG MOV MQV MPG MPV MPA VFW FLI FLC WAV MP3 AIF MID SMF KAR SWA AAC AMC M4A M4V RTS SDP QT}}
	{"AVI" "WMPLib" "MediaPlayer.MediaPlayer.1" "22D6F312-B0F6-11D0-94AB-0080C74C7E95" "video/x-MSMedia" {AVI MPG WAV MID RMI}}
	{"RMP" "RealAudioObjects" "rmocx.RealPlayer G2 Control.1" "CFCDAA03-8BE4-11CF-B84B-0020AFBBCCFA" "application/x-RealMedia" {RMV RMJ RMS RAM RAX RVX RP RTX RMX RMM RMP XPL SWF WMV AVI MPG MOV SMI WMA WAV MP3 M4P M4A AIF FLV ASF ASX PLS M3U WVX WMX AIF SDP QT}}
}
#        {"WAP" "WinampOCX" "Winamp.ocx" "58938D1B-A1F5-11D3-A056-0048543B0240" "application/x-WAMedia" {WAV MP3 ASF ASX PLS M3U}}
#{"GIF" "SpriteControl" "DirectAnimation.SpriteControl" "FD179533-D86E-11d0-89D6-00A0C90833E6" "application/x-shockwave-flash" {GIF}}
#	"Adobe Acrobat 7.0 Browser Document" "AcroPDF.PDF.1" "CA8A9780-280D-11CF-A24D-444553540000" "application/x-adobe-pdf" {PDF}
